//
// AecPci ISR example.c
//--------------------------------------------------------
//	 AecPci ISR example
//	Uses the Win32 API calls to create a simple example of
//	how to use the interrupt service routine in connection
//	with the AEC PCI-TC devices.
//
//   Displays " hh:mm:ss:ff" in client area and interrupt count
//				for reader (and generator and video field) interrupts
//
//	REVISION: 
//		May 2000	NEW - A2
//
//
//	NOTE: This is NOT an MFC based program.
//			In order to modify for MFC, you will need to ...????? (TBD)
//--------------------------------------------------------
//#include "stdafx.h"
#include <windows.h>
#include <winioctl.h>		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>

#include <winioctl.h>
#include "AECioctl.h"        // This defines the IOCTL constants.
#include "Time.h"

//#include "AECiNTTC.h"		//PROTOTYPES OF THE AEC_NTTC.DLL FUNCTIONS
//This example (new for PCI devices) makes the calls directly to the DRIVER
//The DLL will be modified to include the calls to this driver TOO.

#define		true	1
#define		false	0
#define		NONE	0x0000
#define		VLTC	0x0050
#define		LTC		0x0098
#define		VITC	0x0093

#define     PCI_DEVICE_NAME     "AecPci"	//BASE device Name - Hard coded in the DRIVER

//VARIABLE DEFINITIONS

// -- These are used in ISR too!
volatile int	iOtherCnt, iVidCnt, iGenCnt, iReadCnt;
int				i1_4A, i5_8A, i9_12A, i13pA, i0A;
int				i1_4B, i5_8B, i9_12B, i13pB, i0B;
int				i1_4C, i5_8C, i9_12C, i13pC, i0C;
int				i1g,i2g,i3g, i4g, i5g, i6g, i7g;
volatile int	intertime0, intertimeMinus, intertimePlus;
int a,b,c,d,e,f;
volatile int	intspan1, intspan2, intspan3, iWait, iTCwait, iNext;


DWORD	Cnt1, Cnt2, Cnt3, DelFq, DelCnt, CntDif, toc;
LARGE_INTEGER	lpFq, lpCnt1, lpCnt2;


char buffer[30];
volatile BOOL	bRnew, bGnew, bVnew;
ULONG	lRTdat, lRUdat;
ULONG	lGTdat, lGUdat;
HANDLE	hAecPci; //, hAecPciX;

HWND	 hwnd;			//GLOBAL access
int		iMB;
BOOL	ReaderAvailable, GeneratorAvailable, VideoAvailable;
BOOL	returnval1;
volatile BOOL exiting = FALSE;
int min = 999;
int max = 0;
int count = 0;
DWORD	RetDw;
int		aecint;
BOOL    IoctlResult;

UCHAR	iCode;
char	hhmmssff[50];		//data string to hold formated unpacked dataC
char	charStr[20], rev[4];//character string to hold data sent to screen
LARGE_INTEGER first1 = {0, 0};
LARGE_INTEGER second1 = {0, 0};
LARGE_INTEGER third1 = {0, 0};
LARGE_INTEGER first2 = {0, 0};
LARGE_INTEGER second2 = {0, 0};
LARGE_INTEGER third2 = {0, 0};

LARGE_INTEGER frequency;
//LARGE_INTEGER last = {0, 0};



ULONG data4, len, portaddress;

//FUNCTION PROTOTYPES
DWORD	TcISR1(HANDLE);	//my 1 isr
BOOL	DoReadWriteAction(HANDLE, enum AECPCI_ACTION_ITEM, ULONG, PULONG, PULONG);
BOOL	DoReadWriteActionISR(HANDLE, enum AECPCI_ACTION_ITEM, ULONG, PULONG, PULONG);
int		LtoStrTm(ULONG, char*);
UCHAR	deviceName[MAX_PATH];

long WINAPI WndProc (HWND, UINT, UINT, LONG) ; //window proceedure (WndProc) PROTOTYPE
HDC			hdc;				
PAINTSTRUCT	ps;					
RECT		rect;				
MSG			msg;	//Global message structure that several
				    // functions use as a parameter

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	BOOL bRet;
	BOOL	device_opened = FALSE;		//if successful in opening PCI device-->true
	HANDLE hThreadTcISR1;               // Thread TcISR handle
	LONG	threadIdTcISR1;              // ID of thread TcISR
	BOOL    IoctlResult;
	int		iMB;
	UCHAR	BrdCapCode;					//byte read from offset 08h
	int i;

    static char szAppName[] = "AEC PCI-Win32 INTERRUPT TEST" ;
    //HWND	 hwnd ;		/changed to global
    WNDCLASS	 wndclass ;
	bRnew = FALSE;
	bGnew = FALSE;
	bVnew = FALSE;
	exiting = FALSE;


	
	i = clock();
	MessageBeep(0xFFFFFFFF);

//	QueryPerformanceFrequency ( &frequency );	//for ISR use

    if (!hPrevInstance) // used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		
	  wndclass.lpfnWndProc	 = WndProc ;				
	  wndclass.cbClsExtra	 = 0 ;					
	  wndclass.cbWndExtra	 = 0 ;					
	  wndclass.hInstance	 = hInstance ;				
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	
	  wndclass.lpszMenuName  = NULL ;				
	  wndclass.lpszClassName = szAppName ;				

	  RegisterClass (&wndclass) ;				
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "AecPci ISR EXAMPLE",		     // window text/header
		    //WS_THICKFRAME | WS_SYSMENU,	     // window style
			WS_BORDER | WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX,
		    10,				     // initial x position
		    30,				     // initial y position
		    0x200,			     // window width
		    0x60,			     // window height
            NULL,                // parent window handle
            NULL,                // window menu handle
            hInstance,           // program instance handle
		    NULL) ;				// creation parameters

    // Copy the device name into the name buffer.
	//The driver will be consistent in the device number it assigns to each
	//of the AEC PCI-TC boards in the machine. The device number depends upon
	//the PCI slot the board is installed in and its position relative to any
	//others in the machine. In any case, the first board that is found in the
	//scan (enumeration) will be labled "0"
		strcpy(deviceName, "\\\\.\\");
		strcat(deviceName, PCI_DEVICE_NAME);	//
		strcat(deviceName, "0");	//This value will open Device"0"

		hAecPci = CreateFile(
                deviceName,	//  "\\\\.\\AecPci0",       // Open the Device "file"
                GENERIC_READ | GENERIC_WRITE,
                FILE_SHARE_READ | FILE_SHARE_WRITE,	//NULL (do not share if COM device)
                NULL,
                OPEN_EXISTING,
                0,		//FILE_FLAG_OVERLAPPED, ????????
                NULL
                );
               
    if (hAecPci == INVALID_HANDLE_VALUE)        // Was the device opened?
    {
        //printf("Unable to open the device.\n");
		//int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType); 
		iMB = MessageBox(hwnd, "Unable to open the Aec PCI device.",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK); 

        exit(1);
    }
	else 
	{
		returnval1 = TRUE;
	}

//--------------------------------
		// This is important!! Make this program have highest Priority
		//		or interrupts will not be processed quickly enough
		SetPriorityClass ( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );

//--------------------------------
	//----------
	//Do NOT Set the IntA enable bit at offset FE.4 for POLLED operations
	//  OR until you have set up things to be ready for IRQs.
	// This call makes sure that the INTA enable  is NOT set
	// writing 0x00000000 to Offset FC (Write4 must be used!)
	portaddress = 0x000000FC;	//Write4 to 0xFC	
	data4 = 0x00000000;			//IRQ DISABLE
	IoctlResult = DoReadWriteAction(hAecPci, Write4, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
	    //printf("\nW4 0@FC Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "Couldn't clear INTERRUPT enable.",
			NULL, MB_ICONSTOP | MB_OK);
		goto exit_routine;	
	}

	//----------
// Determine what this device can do!
	portaddress = 0x00000008;		//Read1 from 0x08	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hAecPci, Read1, portaddress, &data4, &len);
    if (!IoctlResult)    //error  // Did the IOCTL fail?
    {
        //printf("Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "R1 08",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK); 
		goto exit_routine;				//Do NOT go on, bad problem!	
    }
	//Set capabilities flags
	BrdCapCode = (UCHAR)data4;
		//If bit is set... (Register mapping)
		//bit 7=Vitc	Generator	installed
		//bit 6=Vitc	Reader		installed
		//bit 5=LTC		Generator	installed
		//bit 4=LTC		Reader		installed
		//bit ?=OSD					installed
		//bit 1=Serial				installed
		ReaderAvailable = FALSE;
		GeneratorAvailable = FALSE;
		VideoAvailable = FALSE;

	if ((BrdCapCode & BIT7) != 0)	//VGen
	{
		GeneratorAvailable = TRUE;
		VideoAvailable = TRUE;
	}
	if ((BrdCapCode & BIT6) != 0)	//VRdr
	{
		ReaderAvailable = TRUE;
		VideoAvailable = TRUE;	//if OSD?
	}
	if ((BrdCapCode & BIT5) != 0)	//LGen
	{
		GeneratorAvailable = TRUE;
		VideoAvailable = TRUE;
	}
	if ((BrdCapCode & BIT4) != 0)	//LRdr
	{
		ReaderAvailable = TRUE;
		//VideoAvailable = TRUE;
	}

//	Put the board into IDLE mode
	portaddress = 0x00000020;	//Write IDLE command to 0x2F
	data4 = 0x00000000;			//Do all time code available mode
	IoctlResult = DoReadWriteAction(hAecPci, SND_CMD, portaddress, &data4, &len);

	Sleep(100);

//	Start all of the board's reader/generators to run
//		simultaneously. 
	portaddress = 0x0000002F;	//Do ALL time code available mode
	data4 = 0x00000000;			//Do all time code available mode
	IoctlResult = DoReadWriteAction(hAecPci, SND_CMD, portaddress, &data4, &len);
	//NOTE: unless this is a VLTC/RG1 model, this will return a different
	//		command echo than 2Fh. Only "available" bits will be set/returned

	if (GeneratorAvailable)	//Start the generator RUNNING IF there is one
	{
		data4 = 0x00000000;			//START generating command 
		portaddress = 0x00000048;	//Write START generating command to 0x2F
		IoctlResult = DoReadWriteAction(hAecPci, SND_CMD, portaddress, &data4, &len);
	}

//The following items will initialize the PCI time code boards ready 
//to handle interrupts within an ISR Thread!


	//set the ENABLE bits so that when these interrupts occur, we will be told!
	//(Software interrupt only UNLESS FE.4 is set, see next)
	portaddress = 0x0000002E;	//Write1 to 0x2E	
	data4 = 0x07;			//INT READER/GEN/VIDEO FLAG ENABLES
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
		//printf("Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "W1 07@2E",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK); 
		goto exit_routine;	
	}
	//----------


////-------------- 
// Now create the thread to handle the Interrupts.
// SINCE THE BOARD has ALREADY been put into a "paused" mode, (see all of 
// the above) the thread may be started once the PRIORITY has been set.
////--------------
	
	hThreadTcISR1 = NULL;
	if (returnval1)	// if not fail
	{
		hThreadTcISR1  = CreateThread(
			NULL, 
			0,
			(LPTHREAD_START_ROUTINE)TcISR1, 
			hAecPci,			//does not do anything
			CREATE_SUSPENDED, 
			&threadIdTcISR1);

		// This is important!! Make this Thread have highest Priority
		//		or interrupts will not be processed quickly enough
//		SetThreadPriority(hThreadTcISR1, THREAD_PRIORITY_TIME_CRITICAL);
	} 
        // Start up the isr threads
	if (hThreadTcISR1)	// if not fail
		RetDw = ResumeThread(hThreadTcISR1); // start this thread now

    ShowWindow (hwnd, nCmdShow) ;	
    UpdateWindow (hwnd) ;			
	
	InvalidateRect ( hwnd, NULL, 0 );
	bRet = GetMessage (&msg, NULL, 0, 0);
    do					//LOOP TILL THE PROGRAM IS EXITED
	{
		if (bRet == -1)
		{
			Sleep(1);
		}
		else
		{
			TranslateMessage(&msg); 
			DispatchMessage(&msg); 
		}				
		//InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
		do
		{
			Sleep(10);	//don't be a processor hog!
			if (bRnew || bGnew  || bVnew)	//These values are SET in ISR thread
			{
				InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
				//Sleep(5);
			}			
		}
		while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))); //while no msg
		//Nonzero -> success, Zero -> failure
	    // look for any messages (allows Windows access to Main loop)

		//TranslateMessage (&msg) ;				
		//DispatchMessage (&msg) ;				
		//InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
	}
    while ( (bRet = GetMessage( &msg, NULL, 0, 0 )) != 0 );		

	//TranslateMessage (&msg) ;		//don't call till later
    //DispatchMessage (&msg) ;		//""

exit_routine:
		exiting = TRUE;
		//	THE NEXT TWO ITEMS ARE IMPORTANT WHEN EXITING THE PROGRAM
		//  THAT HAS BEEN USING INTERRUPTS.
		//
		//1)Force an interrupt,  by sending a dummy command
		//  Purpose: This will allow the ISR thread to exit cleanly
		//	if it has not already done so. 
		//2)Clear the IntA enable bit at offset FE.4 by
		//  writing 0x00000000 to Offset FC (Write4 must be used!)
		//
		//These are done in the following segements!
//----------
	//cause a command response - IRQ has been turned off (ie: exiting = TRUE)
	//This will cause a "phony command response" interrupt to occur, but will 
	//NOT re-enable the board to generate any more IRQs. The ISR will clear 
	//this interrupt and if there is an ISR thread running, it will end 
	//because the EXITING flag is now TRUE! See the "while (!exiting)" code.
	portaddress = 0x0000002F;	//Write1 to 0x2F	
	data4 = 0xFF;			//
	IoctlResult = DoReadWriteAction(hAecPci, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL fail?
	{
	    //printf("\nW1 FF@2F Ioctl failed with code %ld\n", GetLastError() );
		iMB = MessageBox(hwnd, "W1 FF@2F",
			NULL, MB_ICONSTOP | MB_OK); 
		goto final_exit;	
	}
	Sleep(100);
//----------

final_exit:
    if (!CloseHandle(hAecPci))                  // Close the Device "file".
    {
        //printf("Failed to close device.\n");
		iMB = MessageBox(hwnd, "Unable to Close the Aec PCI device.",
			NULL, MB_ICONSTOP | MB_OK);
    }
//----------
	TranslateMessage (&msg) ;					
    DispatchMessage (&msg) ;
	return 0;
}
//################################################################
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// *********************  WINDOW PROC  ***************************
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
long WINAPI WndProc (HWND hwnd, UINT message, UINT wParam,
                                                          LONG lParam)
     {

     switch (message)						
          {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			
		  GetClientRect (hwnd, &rect) ;			


//Handle reader, video field and Generator interrupts
//
//		  DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
//		       hhmmssff,		//print the number of interrupts that each
//		       wsprintf (hhmmssff,"%d  %d  %d  %d", //of the ISRs have processed
//			   iOtherCnt, iVidCnt, iGenCnt, iReadCnt), // **NEW** prints out int timing info Too.
//		       &rect,
//		       DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if (bRnew)
		{
			bRnew = FALSE;		//reset this flag
			//lRTdat, lRUdat iReadCnt

			aecint = LtoStrTm(lRTdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
		       charStr,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_CENTER);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iReadCnt),
				&rect,
				DT_SINGLELINE | DT_RIGHT );

//	//--->
//			DrawText (hdc,		
//				hhmmssff,
//				wsprintf (hhmmssff,"A=%d %d %d %d %d  B=%d %d %d %d %d C=%d %d %d %d %d",
//					i0A, i1_4A, i5_8A, i9_12A, i13pA, i0B, i1_4B, i5_8B, i9_12B, i13pB, i0C, 
//					i1_4C, i5_8C, i9_12C, i13pC),
//				&rect,
//				DT_SINGLELINE | DT_BOTTOM );
//
//			DrawText (hdc,		
//				hhmmssff,
//				wsprintf (hhmmssff,"Span=%d %d %d %d %d %d %d", i1g,i2g,i3g, i4g, i5g, i6g, i7g),
//				&rect,
//				DT_SINGLELINE | DT_VCENTER );
//int				i1_4A, i5_8A, i9_12A, i13pA;
//int				i1_4B, i5_8B, i9_12B, i13pB;
//int				i1_4C, i5_8C, i9_12C, i13pC;
//int				i1g,i2g,i3g;
	//  <----
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		else if (bGnew)			//print the GENERATOR data
		{		
			bGnew = FALSE;		//reset this flag
			//lGTdat, lGUdat
			aecint = LtoStrTm(lGTdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
			    charStr,
				aecint,
				&rect,
				DT_SINGLELINE | DT_VCENTER | DT_CENTER );
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iGenCnt),
				&rect,
				DT_SINGLELINE | DT_VCENTER | DT_RIGHT );
		}

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		else if (bVnew)	//print the video field interrupt timing...
		{
			bVnew = FALSE;		//reset flag value
			
//			DrawText (hdc,			//PRINT IN THE WINDOW
//			    charStr,
//				aecint,
//				&rect,
//				DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iVidCnt),
				&rect,
				//DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
				DT_SINGLELINE | DT_CENTER | DT_BOTTOM);
		}

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		else	//something else	//Revision info???, size change
		{
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"READER"),
				&rect,
				DT_SINGLELINE );
			if (!ReaderAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_CENTER );
			//----------------------------------------------
			DrawText (hdc,		
				hhmmssff,
				wsprintf (hhmmssff,"GENERATOR"),
				&rect,
				DT_SINGLELINE | DT_VCENTER );
			if (!GeneratorAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_VCENTER | DT_CENTER );
			//-----------------------------------------------
			DrawText (hdc,		
				hhmmssff,
				wsprintf (hhmmssff,"VIDEO"),
				&rect,
				DT_SINGLELINE | DT_BOTTOM );
			if(!VideoAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_BOTTOM | DT_CENTER );
	//-----------------------------------------------
			//this is NOT needed here becasue we are NOT using
			// the AEC_nttc.DLL file
//			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
//				hhmmssff,
//				wsprintf (hhmmssff,"Rev: %c%c", rev[0], rev[1]),
//				&rect,
//				DT_SINGLELINE | DT_RIGHT );
		}
		EndPaint (hwnd, &ps) ;					
	       return 0 ;								

	  case WM_DESTROY:								
	       PostQuitMessage (0) ;					
	       return 0 ;								
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	
     }

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----------------------------------------------------------
//Convert a LONG (4byte) value into a character string of TIME (Tm)
//This does NOT mask embedded bits 
// use "dw = (dw & 0x3F7F7F3F);" to mask embedded bits IF needed
//before calling this routine.
//------------------------------------------------------------
int LtoStrTm(ULONG dw, char *chs)	
{
	wsprintf (chs,"%8.8X",dw);
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';
	return 11;
}

//-----------------------------------------------------------
/*++	****** DEFINED ACTIONS SUPPORTED BY THE DRIVER ******
AECPCI_ACTION_ITEM parameter must be one of the following!
NOTE: The values ARE case sensitive!

    NOP_THING,         //  No operation		0                   0
    Read1,              //  input byte			offset				data (in)	
    Read2,              //  input word			offset				data (in)
    Read4,              //  input long			offset				data (in)
    Write1,             //  output byte			offset				data (out)
    Write2,             //  output word 		offset				data (out)
    Write4,             //  output long 		offset				data (out)

	SND_CMD,		//send command			command(out)		intcode(in)
					//read the NEXT INTCODE - fixed OFFSET read / enable next
	GET_INT			//get int code			0 (don't care?)		intcode(in)
					//
	RTM,			//  input long			0 (don't care?)		data (out)
					//Read the TIME bits at offset 10h (transition tolerent) DWORD
	RUB,			//  input long			0 (don't care?)		data (out)
					//Read the USER bits at offset 14h (transition tolerent) DWORD
	REB,			//  input byte			0 (don't care?)		data (out)
					//Read the EMBEDDED bits at offset 18h (transition tolerent) UCHAR
	NextInt,		//  output byte			0 (don't care)		data (out)
					//Queue an IRP for the ISR/DPC to complete

				--*/
BOOL 
DoReadWriteAction(
				  IN HANDLE hOpen, 
				  IN enum AECPCI_ACTION_ITEM act, 
				  IN ULONG port,
				  IN OUT PULONG pdata,
				  IN PULONG pLB
				  )
{

	BOOL status;
		//enum AECPCI_ACTION	action;		// action to perform
		//ULONG					port;       // port address
		//ULONG					value;      // input or output data
	AECPCI_ACTION_ITEM		ai;			// *PAECPCI_ACTION_ITEM;
	//IOCTL_AECPCI_PROCESS_BUFFER
	//ULONG   LengthBack;

	ai.action = act;
	ai.port = port;
	ai.value = *pdata;

	//Nonzero indicates success. 
	//Zero indicates failure. 
	//To get extended error information, call GetLastError. 

	//status = TRUE;		//TEMP debug
	//*pdata = 0x13;		//TEMP debug

	if (status = DeviceIoControl(		
                hOpen,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_BUFFER,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ai,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ai),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ai,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ai),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				pLB,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                )				
		)
	{		*pdata = ai.value;		}

	return status;
}


//============================================================================
//-----------------------------------------------------------
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DWORD TcISR1(HANDLE hAecPciX)	//FIRST BOARD THAT THE DRIVER SEES (Device0)
{
// ++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++
//	int a,b,c;
//	char buffer[30];
// ++++++++++++++++++++++++++++++++++++++++++++++++
// ++++++++++++++++++++++++++++++++++++++++++++++++

	ULONG		pAddr, d4, dLn;
	BOOLEAN		IOResult, ok_q;
	UCHAR		iCd;
//	LARGE_INTEGER now;
	HANDLE	hAecPciInt = NULL;
	int i = 0;

	hAecPciInt = CreateFile(
            deviceName,	//  "\\\\.\\AecPci0",       
            GENERIC_READ | GENERIC_WRITE,
            FILE_SHARE_READ | FILE_SHARE_WRITE,	
            NULL,
            OPEN_EXISTING,
            0,		
            NULL
            );

    if (hAecPciInt == INVALID_HANDLE_VALUE)        // Was the device opened?
    {
        //printf("Unable to open the device.\n");
		//int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType); 
		iMB = MessageBox(hwnd, "Unable to open the Aec PCI ISR device.",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK); 

		hAecPciInt = NULL;
        exiting = TRUE;
    }

	MessageBeep(0xFFFFFFFF);


	//exiting = TRUE;
	if ( ! exiting )
	{
		//cause a command response (will NAK) - no ISR/IRQ enable yet
		portaddress = 0x0000002F;	//Write1 to 0x2F	
		data4 = 0xFF;			//
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Write1, portaddress, &data4, &len);
		if (!IoctlResult)                            // Did the IOCTL fail?
		{
			//printf("W1 FF@2F Ioctl failed with code %ld\n", GetLastError() );
			iMB = MessageBox(hwnd, "W1 FF@2F",
				NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
				MB_ICONSTOP | MB_OK); 
			//goto exit_routine;	
		}
		//----------
		Sleep(20);	//Let the command be processed
		//----------
		//NOTE: Better code should check value of register FE.0 bit (data ready) to be sure

		/*++
		At this point, the NAK should be available at the command response
		register (offset 0Fh). No IRQ will be driven UNTIL this register is
		read (Reading from 0Fh will clear FE.0) AND a 00h value is written 
		to the "Command" input register (offset 2Fh) to RE-ENABLE the next 
		interrupt to occur.
		--*/

		//Read from offset 0Fh
		portaddress = 0x000000FE;		//Read1 from 0x0F	//TIME data
		data4 = 0x00000000;
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Read1, portaddress, &data4, &len);

		//Read from offset 0Fh
		portaddress = 0x0000000F;		//Read1 from 0x0F	//TIME data
		data4 = 0x00000000;
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Read1, portaddress, &data4, &len);
		if (!IoctlResult)                            // Did the IOCTL fail?
		{
			//printf("Ioctl failed with code %ld\n", GetLastError() );
			iMB = MessageBox(hwnd, "R1 0F",
				NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
				MB_ICONSTOP | MB_OK); 
			//goto exit_routine;		
		}

// note: the "nextInt" call sets this value!
		//Set the IntA enable bit at offset FE.4 by
		// writing 0x00000010 to Offset FC (Write4 must be used!)
		portaddress = 0x000000FC;	//Write4 to 0xFC	
		data4 = 0x00000010;			//IRQ ENABLE
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Write4, portaddress, &data4, &len);
		if (!IoctlResult)                            // Did the IOCTL fail?
		{
			//printf("W4 10@FC Ioctl failed with code %ld\n", GetLastError() );
			iMB = MessageBox(hwnd, "W4 10@FC",
				NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
				MB_ICONSTOP | MB_OK); 
			//goto exit_routine;	
		}

		//Read from offset 0Fh
		portaddress = 0x000000FE;		//Read1 from 0x0F	//TIME data
		data4 = 0x00000000;
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Read1, portaddress, &data4, &len);

		/*++
		Now when the ISR thread loop starts, it will place the "get interrupt"
		 request THEN it writes a 00H value to offset 2Fh, enableing the next
		 interrupt to generate an ISR that is ready to be handled.
		--*/
	}

//----
//		ok_q = QueryPerformanceFrequency(&frequency);
////		DelFq = lpFq.LowPart;
////		DelCnt = DelFq / 1000;	// for ~ 1ms freq. count
// <--------- 


    							//THIS 'WHILE' LOOP IS THE ISR FOR THE 
								//PCI (DEVICE0) BOARD.  THIS EXAMPLE UPDATES A
								//COUNTER THAT SHOWS THE NUMBER OF EACH TYPE OF
								//INTERRUPT THAT HAS OCCURED.  
								//THIS CODE DOES ASSUME THAT THE BOARD IS CAPABLE OF
								//READING TIME CODE.  
								//THE ISR WILL LOOP INDEFINITLY.  TO STOP
								//THE ISR, set the "exiting" flag TRUE!
								//ALSO, CLEAR THE BIT OFFSET FE.4 BY MAKING A
								//"Write4" CALL TO OFFSET FCh WITH A VALUE OF 00h.
								//THIS WILL STOP ANY OF THE SOFTWARE INTERRUPTS FROM
	//exiting = TRUE; 			//GENERATING HARDWARE INTERRUPTS.
	exiting = FALSE;			//IN THIS EXAMPLE, THIS IS DONE JUST AFTER THE MAIN LOOP
	while ( ! exiting )			//BEGINS THE EXIT CODE.
    {  
		i++;
		//if (i > 3000)
		//	exiting = TRUE;		//only ONCE
		//POLLED method
//		Sleep(10);	//TEMP debug
//		pAddr = 0x00000010;
//		d4 = 0x00000000;		
//		IOResult = DoReadWriteActionISR(hAecPciInt, GET_INT, pAddr, &d4, &dLn);

		//ISR QUEUED  method
		//This call is similar to the DLL file "AEC_PCTC_ISR_1"
		IOResult = DoReadWriteActionISR(hAecPciInt, NextInt, pAddr, &d4, &dLn);
		
		// READ output---->
		if (IOResult)                            // Did the IOCTL succeed?
		{
			iCd = (UCHAR)d4;		//convert retruned ulong value to "code" byte
			switch (iCd)
			{
			case (0x13):	//tc reader interrupt (get time & user (don't worry about Embedded)			
				bRnew = TRUE;
				iReadCnt++;				
				pAddr = 0x00000010;//Read4 from 0x10 - TIME data -(RTM)
				d4 = 0x00000000;
				if (DoReadWriteActionISR(hAecPciInt, Read4, pAddr, &d4, &dLn))
					lRTdat = d4;

				//lRTdat = iReadCnt;
				//pAddr = 0x00000014;//Read4 from 0x14 - USER data -(RUB)
				//d4 = 0x00000000;
				//if (DoReadWriteActionISR(hAecPciInt, Read4, pAddr, &d4, &dLn))
				//	lRUdat = d4;

				break;
			case (0x4C):	//tc generator interrupt
				bGnew = TRUE;
				iGenCnt++;
				pAddr = 0x00000040;//Read4 from 0x40 - Gen. TIME data -
				d4 = 0x00000000;
				if (DoReadWriteActionISR(hAecPciInt, Read4, pAddr, &d4, &dLn))
					lGTdat = d4;
//				pAddr = 0x00000044;//Read4 from 0x44 - Gen. USER data -
//				d4 = 0x00000000;
//				if (DoReadWriteActionISR(hAecPciInt, Read4, pAddr, &d4, &dLn))
//					lGUdat = d4;
				break;

			case (0x44):	//Video field int

				iVidCnt++;
				bVnew = TRUE;

				//calculate the number of video field interrupts / second ?
				// see if interrupts occur too fast or too slow - keep track?
//				QueryPerformanceCounter(&now);
//				if ( last.QuadPart )
//				{
//					DWORD n = (DWORD) ((now.QuadPart - last.QuadPart) / (frequency.QuadPart / 1000));
//					if ( n < min )
//						min = n;
//					if ( n > max )
//						max = n;	// **NEW***
//					if ( n > 17 )	// may need to change this value if not detecting
//						count += 1;	// 60 /Second video field rate interrupt.
//								//    Use '34' for 30 frame reader/gen
//								//    Use '41' for 25 frame reader/gen (PAL)
//								//    Use '21' for 50 field video rate interrupt (PAL)
//				}
//
//				last.QuadPart = now.QuadPart;

				break;

			default:	//command response, compare, serial...NAK
				iOtherCnt++;
			}
		}    
		else 
		{
			Sleep(500);
			MessageBeep(0xFFFFFFFF);
		}
	
	}	//end of WHILE loop

/*++


--*/
	if (hAecPciInt)
	{
		portaddress = 0x000000FC;	//Write4 to 0xFC	
		data4 = 0x00000000;			//IRQ DISABLE
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Write4, portaddress, &data4, &len);
		if (!IoctlResult)                            // Did the IOCTL fail?
		{
			//printf("\nW4 0@FC Ioctl failed with code %ld\n", GetLastError() );
			iMB = MessageBox(hwnd, "Couldn't clear INTERRUPT enable.",
				NULL, MB_ICONSTOP | MB_OK);
			//goto final_exit;
		}

				//----------
		portaddress = 0x0000002E;	//Write1 to 0x2E	
		data4 = 0x00;			//DISABLE INT READER FLAG ENABLES on exit
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Write1, portaddress, &data4, &len);
		if (!IoctlResult)                            // Did the IOCTL fail?
		{
			//printf("\nW1 0@2E Ioctl failed with code %ld\n", GetLastError() );
			iMB = MessageBox(hwnd, "W1 00@2E",
				NULL, MB_ICONSTOP | MB_OK); 
			//goto final_exit;	
		}
		//----------

		//Now that we have diabled hardware IRQ, we can finish processing of
		//the current interrpt.
		portaddress = 0x0000002F;	//Write1 to 0x2F	
		data4 = 0x00;			//enable normal operations on exit (about the
								// same as upon entry)
		IoctlResult = DoReadWriteActionISR(hAecPciInt, Write1, portaddress, &data4, &len);



		//Read from offset 0Fh
		//portaddress = 0x0000000F;		//Read1 from 0x0F	//TIME data
		//data4 = 0x00000000;
		//IoctlResult = DoReadWriteActionISR(hAecPciInt, Read1, portaddress, &data4, &len);
		//----------


		//----------

		if (!CloseHandle(hAecPciInt))                  // Close the Device "file".
		{
	        //printf("Failed to close device.\n");
			iMB = MessageBox(hwnd, "Unable to Close the Aec PCI ISR device.",
				NULL, MB_ICONSTOP | MB_OK);
	    }
	}
	
	MessageBeep(0xFFFFFFFF);

    return(NO_ERROR);       // can't get here till exiting!
}


//============================================================================
BOOL  DoReadWriteActionISR(
				  IN HANDLE hOpen, 
				  IN enum AECPCI_ACTION_ITEM act, 
				  IN ULONG port,
				  IN OUT PULONG pdata,
				  IN PULONG pLB
				  )
{

	BOOL status;
		//enum AECPCI_ACTION	action;		// action to perform
		//ULONG					port;       // port address
		//ULONG					value;      // input or output data
	AECPCI_ACTION_ITEM		ai;			// *PAECPCI_ACTION_ITEM;
	//IOCTL_AECPCI_PROCESS_BUFFER
	//ULONG   LengthBack;

	ai.action = act;
	ai.port = port;
	ai.value = *pdata;

	//Nonzero indicates success. 
	//Zero indicates failure. 
	//To get extended error information, call GetLastError. 

	//status = TRUE;		//TEMP debug
	//*pdata = 0x13;		//TEMP debug

	if (status = DeviceIoControl(		
                hOpen,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_BUFFER,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ai,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ai),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ai,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ai),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				pLB,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                )				
		)
	{		*pdata = ai.value;		}

	return status;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	      // END OF CODE	END OF CODE		END OF CODE