// AecPoll.cpp : implementation file
//

#include "stdafx.h"
#include "Line21Reader.h"
#include "AecPoll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*	// some of the AEC_NTTC.DLL API calls
 int   AEC_PCTC_CHECK_BOARD	(LPWORD);
 BOOL  AEC_PCTC_READ_TB		(LPDWORD, LPWORD);
 BOOL  AEC_PCTC_READ_TBE		(LPDWORD, LPWORD);
 BOOL  AEC_PCTC_READ_UB		(LPDWORD, LPWORD);
 int   AEC_PCTC_READ_ASC_TB	(LPSTR,   LPWORD);
 int   AEC_PCTC_READ_ASC_UB	(LPSTR,   LPWORD);
 BOOL  AEC_PCTC_READ_1BYTE 	(LPBYTE,  LPWORD, LPWORD);
 BOOL  AEC_PCTC_READ_4BYTES	(LPDWORD, LPWORD, LPWORD);
 BOOL  AEC_PCTC_WRITE_1BYTE	(LPBYTE,  LPWORD, LPWORD);
 BOOL  AEC_PCTC_WRITE_4BYTES	(LPDWORD, LPWORD, LPWORD);
 BOOL  AEC_PCTC_SEND_COMMAND	(LPBYTE,  LPBYTE, LPWORD);

	// *** See IntCode() method below for NOTES: about using this call ***
 BOOL  AEC_PCTC_GET_INTCODE	(LPBYTE,  LPBYTE, LPWORD);

 int   AEC_PCTC_GET_DLL_INFO	(LPSTR);
 int   AEC_PCTC_GET_NUMBER_OF_DEVICES (VOID);
 int   AEC_PCTC_DWORD_TO_STR	(LPBYTE,  LPDWORD, LPSTR);

*/
/////////////////////////////////////////////////////////////////////////////
// CAecPoll

//make sure that there is a time code board that reads L21!
CAecPoll::CAecPoll()
{

	DWORD dw;
	m_FE = 0;
	m_08 = 0;
	mbReadsTC = FALSE;
	mbReads2TC = FALSE;
	mbReadsL21 = FALSE;
	mbSetUpOK = FALSE;
	mB_Addr = 0x1000;	//1000h ->  Use this value for 1st PCI device in PC...

	Read1(0x0C);	//fixed mOffset
	m_0C = mRead_1;
	Read1(0x0D);	//fixed mOffset
	m_0D = mRead_1;
	Read1(0x2E);	//fixed mOffset
	m_2E = mRead_1;
	m_to2E = mRead_1;
	Read1(0x0E);	//fixed mOffset
	m_0E = mRead_1;


	m_iUnLost = 0;
	m_TCReadInARow = 0;

//	miCheckType = AEC_PCTC_CHECK_BOARD(&mB_Addr);
//	if (miCheckType == 0x04)
//	{
		//DWORD mdwL21Data;
		//BYTE mLastInt;

//		Cmd(0x02); //Reset Command
//		Sleep(500);

		if (Read1(0x08))	//mOffset
		{
			m_08 = mRead_1;		// store board capabilities code
			if (mRead_1 & 0x50)	// bits 4/6
			{
				mbReadsTC = TRUE;
				//mRead_1 = 0x34;	//include if debug with NOT L21 board!!!!
				if ((mRead_1 & 0x50) == 0x50)
					mbReads2TC = TRUE;
			}
			if (mRead_1 & 0x04)	// bit2
			{

				m_to2E = 0x00;
				Write1(m_to2E, 0x2E);	//disable all interrupts (except commands)
				mbReadsL21 = TRUE;
				//Setup the board to use Data Group 1 (50h-53h)
				// for the L21 data DWORD
				dw = 0x00000080;
				if (mbReads2TC)
				{
					Write1(0x20, 0x28);	//disallow VITC from selected area

					//Next two line are temporatry
					Write1(18, 0x29);	//Force VITC lines to be read
					Write1(20, 0x2A);	//Force VITC lines to be read

					dw = 0x21000080;	//PUT VITC reader at 5C-5Fh / L21 at 50-53h.
				}
				Write4(dw, 0x20);	//dword, mOffset -- 80h for L21 reader, 21 for VITC reader??

				//Write4(0x80808080, 0x20);	//dword, mOffset -- 80h for L21 reader
				Cmd(0x5A);
				//if (mbRet == 0x5A)					//stuff data group assignments
				//	mbSetUpOK = TRUE;
				Sleep(50);
				Cmd(0x23);			// make sure in all TC+L21 reader
				//Cmd(0x22);			// make sure in L21/VITC reader mode
				Cmd(0x5B);
				Read4(0x1C);
				if ((mbRet == 0x5B) && (dw == mRead_4))					//stuff data group assignments
					mbSetUpOK = TRUE;
				//PUT code here to verify that all is working as expected!!!!
				// !!!!!!!!!!!!!!!
								
			}
			
		}
//	}
}
/////////////////////////////////////////////////////////////////////////////
CAecPoll::~CAecPoll()
{

}




/////////////////////////////////////////////////////////////////////////////
// CAecPoll message handlers

int CAecPoll::AscTB(char* charStr)
{
	if (mbReads2TC)	//if reads both LTC & VITC, make sure they are ok before reading
	{
		if (Read1(0x0C))
		{
			if (mRead_1 & 0x10)	// bit 4
				return (AEC_PCTC_READ_ASC_TB (charStr, &mB_Addr));
			else if (mRead_1 & 0x20)	// bit 5
			{
				Read4(0x5C);		//This address set in class initialization (dat21h=>adr23h)
				wsprintf (charStr,"%8.8X",mRead_4);
				charStr[11] = 0;	//EOL
				charStr[10] = charStr[7];
				charStr[9] = charStr[6];
				charStr[8] = ':';
				charStr[7] = charStr[5];
				charStr[6] = charStr[4];
				charStr[5] = ':';
				charStr[4] = charStr[3];
				charStr[3] = charStr[2];
				charStr[2] = ':';
				return 11;
			}
			else return 0;
		}
		else return 0;
	}
	else if (Read1(0x0C))
	{
		if (mRead_1 & 0x30)	// bits 4/5 (Lrd and/or Vrd OK)
			return (AEC_PCTC_READ_ASC_TB (charStr, &mB_Addr));
		else
			return 0;
	}
	else
		return 0;

	//AEC_PCTC_READ_ASC_TB	(LPSTR,   LPWORD);
	//return (AEC_PCTC_READ_ASC_TB (charStr, &mB_Addr));

}


/////////////////////////////////////////////////////////////////////////////
// enable the L21 reader upon Start of data aqu.
// Post meassage IF device does NOT have L21 reader
// L21 reader operation mirrors VITC READER mode + need to set bit 2E.6
//    to get interrupts (code = 1Eh) that signal data ready
void CAecPoll::StartL21()		//							
{
	if (!mbReadsL21)
		return;
	//Make sure that the board has the L21 READER enabled-read 0D.6
	Read1(0x0D);
	if (!(mRead_1 & 0x02))	//Bit 0D.1 is "L21 Data Reader AND/OR VITC Reader active" bit
	{
		Write4(0x21000080, 0x20);	//dword, mOffset -- 80h for L21 reader
		if (Cmd(0x5A))					//stuff data group assignments
			mbSetUpOK = TRUE;
		Sleep(10);
		Cmd(0x23);			// make sure in all TC+L21 reader
	}
	//set enable flag if L21 reader available!
	// Set the L21 reader interrupt enable bit 2E.6 to Start
	if (Read1(0x2E))	//mOffset
	{
		//Set the TC reader interrupt enable bit0 + L21 enable bit
		//mWrite_1 = (mRead_1 | 0x40);	//Set bit6  =L21
		mWrite_1 = (mRead_1 | 0x41);	//Set bit6/0  =L21+TCread
		//mWrite_1 = (mRead_1 | 0x43);	//Set bit6/1/0 = L21/VID/TCread
		m_to2E = mWrite_1;	//save copy of enables
		Write1();	//mOffset set by Read1 above
	}

}


/////////////////////////////////////////////////////////////////////////////
//  disable the L21 reader upon Stop of ""   ""
//  Poll & sleep(2) a few times to clear all cued reades (if any)
void CAecPoll::StopL21()			
{
	//clear enable and Poll a few times
	// Clear the L21 reader interrupt enable bit 2E.6 to Stop
	if (!mbReadsL21)
		return;
	if (Read1(0x2E))	//mOffset
	{
		Cmd(0x20); //Put into "IDLE" mode till ready
		//Clear the TC reader interrupt enable bit0 + L21 enable bit
		mWrite_1 = (mRead_1 & 0xBC);	//Clear bit6/1/0
		m_to2E = mWrite_1;	//save copy of enables
		//mWrite_1 = (mRead_1 & 0xBE);	//Clear bit6/0
		Write1();	//mOffset set by Read1 above
	}
}


/////////////////////////////////////////////////////////////////////////////
// Sets the mLastInt value IF returns TRUE
BYTE CAecPoll::PollInt()			//
{
	if (IntCode())
		return mLastInt;
	else return 0x00;	//no Int pending
	//This method can be used with 'CASE' statements to execute code based upon int when returns.
}


/////////////////////////////////////////////////////////////////////////////
// returns 4 byte L21 data from 50-5F range
DWORD CAecPoll::L21Dword()		//
{
	// This is done in the method 'IntCode()'
	//Read4(0x50);
	//mdwL21Data = mRead_4;
	return mdwL21Data;
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
BOOL CAecPoll::Write4(DWORD dw, WORD w)
{
	mWrite_4 = dw;
	mOffset = w;
	return (AEC_PCTC_WRITE_4BYTES (&mWrite_4, &mOffset, &mB_Addr));
	//return (AEC_PCTC_Write_4BYTES (&dw, &w, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Write1(BYTE b, WORD w)
{
	mWrite_1 = b;
	mOffset = w;
	return  (AEC_PCTC_WRITE_1BYTE (&mWrite_1,  &mOffset, &mB_Addr));
	//return (AEC_PCTC_mWrite_1BYTE (&b,  &w, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Read1(WORD w)
{
	mOffset = w;
 	return  (AEC_PCTC_READ_1BYTE (&mRead_1,  &mOffset, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Read4(WORD w)
{
	mOffset = w;
 	return  (AEC_PCTC_READ_4BYTES (&mRead_4, &mOffset, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Write4()
{
 	return  (AEC_PCTC_WRITE_4BYTES (&mWrite_4, &mOffset, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Write1()
{
 	return  (AEC_PCTC_WRITE_1BYTE (&mWrite_1,  &mOffset, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Read4()
{
 	return  (AEC_PCTC_READ_4BYTES (&mRead_4, &mOffset, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Read1()
{
 	return  (AEC_PCTC_READ_1BYTE (&mRead_1,  &mOffset, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::Cmd(BYTE cmdCode)
{
	mbCom = cmdCode;
	return (AEC_PCTC_SEND_COMMAND (&mbCom,  &mbRet, &mB_Addr));
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::IntCode()
{
	BYTE bFlags, bUnhandled, lost;
	int loop;
	//next line is temp!
//	Read4(0x50);	//Get the L21 data DWord (as it has been set up here)
//
	Read1(0x0C);	//fixed mOffset
	m_0C = mRead_1;
//	//bFlags = mRead_1;
//	//if ((bFlags & 0x40) != 0)
//	//	Write1(0x00, 0x2F);
	Read1(0x0D);	//fixed mOffset
	m_0D = mRead_1;
	Read1(0x2E);	//fixed mOffset
	m_2E = mRead_1;
	m_to2E = mRead_1;
	Read1(0x0E);	//fixed mOffset
	m_0E = mRead_1;

	Read1(0xFE);	//fixed mOffset
	m_FE = (m_FE | mRead_1);

	//the next line is temp
//	mdwL21Data = mRead_4;	//save L21 data	

	bFlags = mRead_1;
	if ((bFlags & 0x01) != 0)	//if code pending - get it				
	{
		Read1(0x0F);	//fixed mOffset  //clears FE.0
		mLastInt = mRead_1;	//save int code
		if (mLastInt == 0x1E) // L21 reader interrupt code!
		{
			m_TCReadInARow = 0;	//clear counter
			Read4(0x50);	//Get the L21 data DWord (as it has been set up here)
			mdwL21Data = mRead_4;	//save L21 data
			/*
			Status | x | pChar2 | pChar1 = DWORD

			Byte 3 => Status Byte:
				Bit:	  7		  6		5	4	   3		  2			   1			   0
						VALID - Field - x - x	| NoData - C2ParityErr - C1ParityErr - BufferOverflow

							Bit 7 => 4-byte L21 data block valid
							Bit 6 => odd numbered video field
							Bit 5 => reserved
							Bit 4 => reserved
							Bit 3 => no data (or other error) on L21
							Bit 2 => char #2 parity error
							Bit 1 => char #1 parity error
							Bit 0 => internal buffer overflow

			Byte 2 => reserved
			Byte 1 => Character #2 (including received parity, bit 7)
			Byte 0 => Character #1 (including received parity, bit 7)
			*/

			if (mdwL21Data & 0x01000000)	//if OVERFLOW
				ClearL21Buffer(50);
		}
		else if (m_0C & 0x40) //IF L21 input ok //if (mLastInt == 0x13) /// ANY other than 1E
		{
			m_TCReadInARow++;
		}
		//else m_TCReadInARow = 0;

		loop = 0;
		while ((bFlags & 0x04) != 0x00)	// is Bit2 HIGH / Wait if BUSY? 
		{
			//Sleep(1);
			Read1(0xFE);	//fixed mOffset
			bFlags = mRead_1;
			loop++;
			if (loop > 10000)	//allow up to 1mSec + loops to become NOT busy, stop infinite looping
			{
				Sleep(1);
				break;
			}
		}
		Write1(0x00, 0x2F);	//enable next interrupt -enable the next AVR coprocessor interrupt
		LockedUp(20);
		return TRUE;
	}
	else 
	{
		lost = (m_0C & 0x40);
		//if (m_0E & m_to2E)
		bUnhandled = m_0E & m_2E;
		if (bUnhandled && lost)
		{
			m_iUnLost++;
			if (m_iUnLost > 5)
			{
				bUnhandled = 0x00;
				//Write1(0x00, 0x2F);	//enable next interrupt -enable the next AVR coprocessor interrupt
				// Do this because something probably locked up in the response loop
				ClearL21Buffer(25);
			}
		}
		else m_iUnLost = 0;	//clear 

		return FALSE;
	}

		/* NOTES: 

			The AEC dll API cal "AEC_PCTC_GET_INTCODE (&bWait,  &mbRet, &mB_Addr)"
			does NOT handle this INTERRUPT CODE POLLING CORRECTLY! The way that the
			L21 reader data is handled, it can be over written once the write 00h to
			mOffset 2Fh has been done. This CAN cause a loss of the data if they board
			immediately writes new data that has been held in the internal buffer,
			and you would end up reading the next data packet and not the one that casued
			the interrupt. So this code has been written to handle this! It is NOT so
			important when reading time code as it is NOT going to be buffered in a FIFO
			like the L21 data. This will also probably be an issue for the PCI board
			serial OPTION when it becomes available and is supported in future PCI board
			models/revisions.

			When using an ISR thread to handle the interrupt codes, this will NOT be an 
			issue becasue the next interrrupts are NOT enabled until the call is made back
			into the API/driver to handle the next interrpt. This is similar to having the
			ISR be the code segment above from " == 0x1E)... 
			And this method would NOT be needed. The ISR thread would just handle each interrupt
			as it occured, instead of polling.

		*/
}
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL CAecPoll::ReaderDataGood()
{
	BOOL q = FALSE;
	Read1(0x0C);	//fixed mOffset  //
	if ((mRead_1 && 0x30) != 0)
	{
		Read1(0x0D);
		if ((mRead_1 && 0x03) != 0)
			q = TRUE;
	}
	return q;

}

void CAecPoll::ClearL21Buffer(int msDelay)
{
		Read1(0x2E);
		mWrite_1 = (mRead_1 & 0xBF);
		Write1();
		Sleep(msDelay);
		mWrite_1 = mRead_1;
		Write1();
}

BOOL CAecPoll::Restart()
{
		BYTE r1;

		Cmd(0x20); //Idle Command
		Read1(0x2E);
		r1 = mRead_1;
		mWrite_1 = 0x00;	//(mRead_1 & 0x38);	//leave bits 5/4/3
		Write1();
		Sleep(1000);
		Cmd(0x23); //L+V(L21) Reader MODE Command
		Sleep(10);
		Cmd(0x5A);
		Sleep(10);
		mWrite_1 = r1;
		Write1();
		return TRUE;
}

void CAecPoll::LockedUp(int i)
{
	//DWORD dw20, dw1C;

	if (m_TCReadInARow > i)
	{
		BYTE b = m_0C;
		Sleep(10);
		Cmd(0x5B);
		Sleep(10);
		Read4(0x1C);
		//dw1C = mRead_4;
		Write4(0x00000000, 0x20);
		Cmd(0x5A);
		Sleep(10);
		Read1(0x2E);
		m_to2E = mRead_1;	//save copy of enables
		mWrite_1 = 0x00;	//Clear bits
		Write1();

		Cmd(0x02);
		Sleep(250);

		Cmd(0x02);
		Sleep(250);

		Cmd(0x02);
		Sleep(250);


		Cmd(0x20);
		Sleep(100);
		mWrite_1 = m_to2E;	//
		Write1();
		StartL21();
		m_TCReadInARow = 0;
	}
}
