//--------------------------------------------------------
//	 AECintAP.C	-- INTerrupt APlication Sample program
//			Displays " hh:mm:ss:ff" in client area
//			AND the AECDLL.DLL Revision Number. 
//			This code shows how to call the DLL to implement an
//			interrupt service rountine
//
// Revised to also support PCI-TC devices. (5/25/00)
//--------------------------------------------------------


#include <windows.h>
#include <winioctl.h> 		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>

#include "AECiNTTC.h"		//PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS
 

#define		true	1
#define		false	0
#define		NONE	0x0000
#define		IOR		0x0095
#define		MMR		0x0090
#define		SMART	0x0050
#define		VLTC	0x0050
#define		LTC		0x0098
#define		VITC	0x0093
#define		PCI 	0x0100

typedef struct _AECBrdFnd
	{
		WORD	BrdAddr;
		int		BrdCkType;	//1=IOR, 2=MMR, 3=SMART isa, 4=PCI
		WORD	BrdModel;
		PVOID	PhysAddr;
		BOOL	ReaderAvailable;
		BOOL	GeneratorAvailable;
		BOOL	VideoAvailable;
	} AECBrdFnd, *PAECBrdFnd;

//VARIABLE DEFINITIONS

AECBrdFnd	AecBoard[3];	// hold data for UP TO 3 time code boards
							// that are found (if they are installed).
int		BoardsFound;		// number of boards found in 'find all'
int		boardNum;			// number of boards found in registry
int		aecint;

volatile int	iOtherCnt, iVidCnt, iGenCnt, iReadCnt;
volatile BOOL	bRnew, bGnew, bVnew;
ULONG	lRTdat, lRUdat;
ULONG	lGTdat, lGUdat;

volatile int IntCnt1;
int		IntIndex; 
int		IntCntBak1; 
int		IntsOn1;
char	hhmmssff[30];		//data string to hold formated unpacked dataC
char	charStr[20], rev[2];//character string to hold data sent to screen
char	MBstr[60];

BYTE	rByte1, rByte2, rByte3;
BYTE	bCom, bRet; 
BOOL	returnval, returnval1, returnval2, returnval3, ok;
WORD	Brd1addr; 
LPSTR	lpPassToAECDLLrev;	
DWORD	RetDw, IORdw;
HANDLE	hAecDevice2, hAecDevice3, hAecDevice4; hAecDevice;
volatile BOOL exiting = FALSE;
int min = 999;
int max = 0;
int count = 0;
LARGE_INTEGER last = {0, 0};
LARGE_INTEGER frequency;


//FUNCTION PROTOTYPES
DWORD	TcISR1(HANDLE);	//my 1 isr
int		FindAllBoards(void);
void	RecordPci(int, WORD);	//FOR PCI devices
void	RecordSmart(int, WORD);	//FOR ISA devices (if use uC (SMART!))
void	ClearAllInts(int);
void	StartSmart(int);
//void	SingleSmartInt(void);
void	CleanUpInterrpts(int);
int		LtoStrTm(ULONG, char*);
void	MessageBoxProc(LPSTR);


long WINAPI WndProc (HWND, UINT, UINT, LONG) ;
	    //window proceedure (WndProc) PROTOTYPE
HDC			hdc;				
PAINTSTRUCT	ps;					
RECT		rect;				
MSG			msg;	//Global message structure that several
				    // functions use as a parameter

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int WINAPI WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
{
	HANDLE hThreadTcISR1;               // Thread TcISR handle
	DWORD  threadIdTcISR1;              // ID of thread TcISR

    static char szAppName[] = "AEC PC-TC Win32 ISR TEST" ;
    HWND	 hwnd ;
    WNDCLASS	 wndclass ;
    lpPassToAECDLLrev = (LPSTR) &rev;
	Brd1addr = 0x0000;	//init base addresses to NULL
	IntCnt1 = 0x00;		//init interrupt count
	IntCntBak1 = 0x00;	//init interrupt match count

	bRnew = FALSE;
	bGnew = FALSE;
	bVnew = FALSE;

	QueryPerformanceFrequency ( &frequency );

	boardNum = AEC_PCTC_GET_NUMBER_OF_DEVICES ();	//
//--------------
// programaticly get all base addresses of boards installed & registered
//	and return the number of boards that were found.
// works with the first board(s) that was/were found (up to 3 (maximum))

	// ALSO gets PCI device ready to handle interrupts TOO! **NEW**
	BoardsFound = FindAllBoards();	
	if ( BoardsFound != 0 )			// 
		Brd1addr = AecBoard[0].BrdAddr;			


    if (!hPrevInstance) //  used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		
	  wndclass.lpfnWndProc	 = WndProc ;				
	  wndclass.cbClsExtra	 = 0 ;					
	  wndclass.cbWndExtra	 = 0 ;					
	  wndclass.hInstance	 = hInstance ;				
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	
	  wndclass.lpszMenuName  = NULL ;				
	  wndclass.lpszClassName = szAppName ;				

	  RegisterClass (&wndclass) ;				
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "AEC PC-TC Win32 INTERRUPT EXAMPLE",		     // window text
		    WS_THICKFRAME | WS_SYSMENU,	     // window style
		    10,				     // initial x position
		    30,				     // initial y position
		    0x180,			     // window width
		    0x80,			     // window height
            NULL,                // parent window handle
            NULL,                // window menu handle
            hInstance,           // program instance handle
		    NULL) ;				// creation parameters


		// This is important!! Make this program have highest Priority
		//		or interrupts will not be processed quickly enough
		SetPriorityClass ( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );

////--------------  create a new thread to use as this board's ISR
	if ( Brd1addr != 0x0000 )
	{
		returnval1 = AEC_PCTC_INIT_BRD_INT (&hAecDevice2, &IntIndex, &Brd1addr);
		if (returnval1)	// if not fail
		{
			hThreadTcISR1  = CreateThread(NULL, 0, 
                            (LPTHREAD_START_ROUTINE)TcISR1, hAecDevice2,
                            CREATE_SUSPENDED, 
							&threadIdTcISR1);
			// This is important!! Make this Thread have highest Priority
			//		or interrupts will not be processed quickly enough
			SetThreadPriority(hThreadTcISR1, THREAD_PRIORITY_TIME_CRITICAL);
			//SetThreadPriority(hThreadTcISR1, THREAD_PRIORITY_NORMAL);
		}
	}

////-------------- 
// DO NOT START THE THREAD EXECUTION YET !!!
////--------------
	ClearAllInts(BoardsFound);			// 		

            // Start up the isr threads
	if (returnval1)	// if not fail
	{
		RetDw = ResumeThread(hThreadTcISR1); // start this thread now
	}


	// THIS function can be edited to change what the board interrupts on.
	// G0 check it out! //OBSOLETE 01/2001 with code changes to "Record..." cuncitons
//	StartSmart(BoardsFound);	// enable the smart readers (does NOTHING for PCI)



//----
    ShowWindow (hwnd, nCmdShow) ;	
    UpdateWindow (hwnd) ;			
	
	InvalidateRect ( hwnd, NULL, 0 );
	GetMessage (&msg, NULL, 0, 0);
    do					//LOOP TILL THE PROGRAM IS EXITED
	{
		TranslateMessage (&msg) ;				
		DispatchMessage (&msg) ;				
		do
		{
			Sleep(10);	//don't be a processor hog!
			if (bRnew || bGnew  || bVnew)	//These values are SET in ISR thread
			{
				InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
			}			
		}
		while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))); //while no msg
		//Nonzero -> success, Zero -> failure
	    // look for any messages (allows Windows access to Main loop)

		TranslateMessage (&msg) ;				
		DispatchMessage (&msg) ;				
		InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
	}
    while (GetMessage (&msg, NULL, 0, 0));		
 
	TranslateMessage (&msg) ;					
    DispatchMessage (&msg) ;					

//exit_routine:
		exiting = true;

		
		CleanUpInterrpts(BoardsFound);	//IMPORTANT!!!!
		if ( returnval1 )
			WaitForSingleObject ( hThreadTcISR1, 1000 );


    return msg.wParam ; 						
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		    //WINDOW PROC
long WINAPI WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
     {

     switch (message)						
          {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			
		  GetClientRect (hwnd, &rect) ;			

		  //TEMP
//		  DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
//		       hhmmssff,		//print number of interrupts that have occured
//		       wsprintf (hhmmssff,"%d", //of the ISRs have processed
//			   IntCnt1), 
//		       &rect,
//		       DT_SINGLELINE | DT_VCENTER | DT_RIGHT);
//
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if (bRnew)
		{
			bRnew = FALSE;		//reset this flag
			//lRTdat, lRUdat iReadCnt

			aecint = LtoStrTm(lRTdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
		       charStr,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_CENTER);
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iReadCnt),
				&rect,
				DT_SINGLELINE | DT_RIGHT );
		}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		else if (bGnew)			//print the GENERATOR data
		{		
			bGnew = FALSE;		//reset this flag
			//lGTdat, lGUdat
			aecint = LtoStrTm(lGTdat, charStr);
			DrawText (hdc,			//PRINT IN THE WINDOW
			    charStr,
				aecint,
				&rect,
				DT_SINGLELINE | DT_VCENTER | DT_CENTER );
		}

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		else if (bVnew)	//print the video field interrupt timing...
		{
			bVnew = FALSE;		//reset flag value			
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%d",
				iVidCnt),
				&rect,
				//DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
				DT_SINGLELINE | DT_CENTER | DT_BOTTOM);
		}

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		else	//something else	//Revision info???, size change
		{
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"READER"),
				&rect,
				DT_SINGLELINE );
			if (!AecBoard[0].ReaderAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_CENTER );
			//----------------------------------------------
			DrawText (hdc,		
				hhmmssff,
				wsprintf (hhmmssff,"GENERATOR"),
				&rect,
				DT_SINGLELINE | DT_VCENTER );
			if (!AecBoard[0].GeneratorAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_VCENTER | DT_CENTER );
			//-----------------------------------------------
			DrawText (hdc,		
				hhmmssff,
				wsprintf (hhmmssff,"VIDEO"),
				&rect,
				DT_SINGLELINE | DT_BOTTOM );
			if(!AecBoard[0].VideoAvailable)
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"N/A"),
					&rect,
					DT_SINGLELINE | DT_BOTTOM | DT_CENTER );
			//-----------------------------------------------
			aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
			//uses the AEC_NTTC.DLL.  It passes the DLL revision 
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff," DLL rev:%c%c,  %d", rev[0], rev[1], BoardsFound),
				&rect,
				DT_SINGLELINE  | DT_BOTTOM | DT_RIGHT );
		}

		EndPaint (hwnd, &ps) ;					
	       return 0 ;								

	  case WM_DESTROY:								
	       PostQuitMessage (0) ;					
	       return 0 ;								
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	
     }



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Call the 'Check_board' function for each of the possible addresses
//	that a time code board could be at and then store the board Type and
//	determine if the board has reading ability (some Smart boards are
//	generate only).  
// Returns the number of boards that where found.
//
//	PC-LTC/IOR BOARDS HAVE STANDARD ADDRESS JUMPER SETTINGS OF...
//	(port mapped)	200h, 220h, 280h, 2A0h, 300, 320h, 380h, & 3A0h
//	PC-LTC/MMR ... C0(00)h, C4(00)h, C8(00)h, CC(00)h, D0(00)h, D4(00)h
//	(memory mapped)		D8(00)h, & DC(00)h.
//	PC-LTC/(RDR, GEN, RG1) & ALL PC-VITC/XXX & ALL PC-VLTC/XXX HAVE
//		ADDRESS... CC00h, CD00h, CE00h, CF00h, DC00h, DD00h, DE00h, & DF00h
// The 'actual' address that the memory mapped boards are 'physically' 
//	mapped to is four bits higher than the jumper's lable. 
//	(ie: CC00 -> CC000h address
// PCI-TC models are accessed by calling the
//  DLL with address parameter values of 0x1000 and up (increased by 0x0100)
//  to 0x2100 (total 18 different addresses). These address are arbitrary
//  (defined in the DLL). The first PCI board "found" by scanning of
//  the PCI bus by the driver/enumerator will be assigned the 0x1000
//  address "code" by the DLL. Each board after will be assigned the
//  next address up to MAX.
int	  FindAllBoards(void)
{
	WORD	BrdAddr;
	int		CkType, FoundCnt;

	FoundCnt = 0x00;

	//The check-type for ALL PCI-TC boards is '4'.
	//The following are all ISA bus boards
	//The check-type for PC SMART (not IOR or MMR) boards is '3'.
	//The check-type for PC-LTC/MMR boards is '2'.
	//The check-type for PC-LTC/IOR boards is '1'.


	//now see if there are any PCI boards
	BrdAddr = 0x1000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		RecordPci(FoundCnt, BrdAddr);
		FoundCnt++;
	}

	BrdAddr = 0x1100;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		RecordPci(FoundCnt, BrdAddr);
		FoundCnt++;
	}


/*++
	BrdAddr = 0x1200;
	BrdAddr = 0x1300;
	BrdAddr = 0x1400;
	BrdAddr = 0x1500;
	BrdAddr = 0x1600;
	BrdAddr = 0x1700;	//These address are OK, but will NOT
	BrdAddr = 0x1800;	//		ever be used until the above
	BrdAddr = 0x1900;	//		are used FIRST, so these will
	BrdAddr = 0x1A00;	//		not get used by this program.
	BrdAddr = 0x1B00;	//		These can be used if you have
	BrdAddr = 0x1C00;	//		system that will use more than
	BrdAddr = 0x1D00;	//		two PCI time code devices installed
	BrdAddr = 0x1E00;
	BrdAddr = 0x1F00;
	BrdAddr = 0x2000;
	BrdAddr = 0x2100;
--*/
//look for and IOR return value at the possible IOR addresses
	BrdAddr = 0x200;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);	// returns a 0(none), 
												// 1(IOR), 2(MMR), 3(Smart)		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x220;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x280;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x2A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x300;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x320;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x380;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x3A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].ReaderAvailable = TRUE;
		FoundCnt++;
	}

//look for and MMR/Smart return value at the possible memory map addresses
	BrdAddr = 0xC000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].ReaderAvailable = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	return FoundCnt;
}



//==========================================================
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//This subroutine looks at each PCI board and sets the "abillity"
// bits, then places the board in a mode that is "just about" ready
// to start asserting interrpts. The DLL call in the ISR routine
// finishes the enabling upon entry to the DLL function, and returns
// when an interrupt occurs.
//
void	RecordPci(int Cnt, WORD BrdAddr)
{
	WORD		Addr, Offset08, OffsetEF, OffsetRW;
	BYTE		bId, bType; // bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok;
	DWORD		dwIE;
	
	Addr =  BrdAddr;
	Offset08 = 0x08;
	OffsetEF = 0x3EF;

	AecBoard[Cnt].ReaderAvailable = FALSE;
	AecBoard[Cnt].GeneratorAvailable = FALSE;
	AecBoard[Cnt].VideoAvailable = FALSE;
	// read the smart board type id byte ( 0x50 VLTC, 0x93 VITC, 0x98 LTC)
	//This offset value is NOT IN THE PCI ADDRESS RANGE, BUT THE DLL MAPS
	// this value to a "created" value based upon the data byte at offset
	// 0x08 of the PCI device.
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
		AecBoard[Cnt].BrdModel = (WORD)bType;	//3ef

	if (ok = AEC_PCTC_READ_1BYTE (&bId, &Offset08, &Addr))	
	{

		if ((bId & 0x10) != 0x00)	//if LTC reader bits4 set
		{
			AecBoard[Cnt].ReaderAvailable = TRUE;
		}
		if ((bId & 0x20) != 0x00)	//if LTC gen bits5 set
		{
			AecBoard[Cnt].GeneratorAvailable = TRUE;
			AecBoard[Cnt].VideoAvailable = TRUE;
		}
				
		if ((bId & 0x40) != 0x00)	//if VITC reader bits6 set
		{
			AecBoard[Cnt].ReaderAvailable = TRUE;
			AecBoard[Cnt].VideoAvailable = TRUE;
		}
						
		if ((bId & 0x80) != 0x00)	//if VITC gen bits7 set
		{
			AecBoard[Cnt].GeneratorAvailable = TRUE;
			AecBoard[Cnt].VideoAvailable = TRUE;
		}
		
 		//Make sure that no INTERRUPTS will be generated during initializtion
		//if the board was left in an "active" state from a prior
		//application

		//disable INTERRUPT enable		
		dwIE = 0x00000000;
		OffsetRW = 0xFC;
		ok = AEC_PCTC_WRITE_4BYTES (&dwIE, &OffsetRW, &Addr);

		//disable all automatic interrupts (Read/Gen/field...)
		//Clear all bits at 2Eh
		bId = 0x00;
		OffsetRW = 0x2E;
		ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

		//This can be done now or later with reference to
		// setting up the board to be ready for ISR/interrupt
		// handling/generation

		//Start the Generator and the Reader to run
		//simultaneously. 
		bCom = 0x2F; // dual reader mode command vltc board
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);				

		Sleep(50);	// not technically required, but not a bad
				// idea to make sure that all signals
				// have some time to sync.

		if (AecBoard[Cnt].GeneratorAvailable == TRUE)
		{
			bCom = 0x48; // If Genavailable, start it!
			ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		}

		Sleep(50);

		//Get Board to generate an interrupt (software only) now.
		//This will leave the interrpt pending!
		bId = 0xFF;	//Dummy "command" value, to cause interrupt 
				// response at 0Fh.
		OffsetRW = 0x2F;
		ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

		Sleep(25);	//allow time for the board to process the
					//"command" and write ACK/NAK to 0x0F

		//Clear the interrpt. This will leave the board waiting
		// for a write of a 0x00 value to 0x2F offset that will
		// re-enable the NEXT interrupt. The Writing of 0x00 to
		// 0x2F offset is done BY the ISR upon entry into the
		// ISR call ('NextInt'). This allows the ISR to NOT MISS ANY INTS
		// or allow any Interrupts that are NOT ready to be handled!!!!!
		// Read the interrupt response at 0Fh and throw it away. I know
		// that this is an invalid/error response. 
		// This read should technically not be done until after verifing
		// that there is an "interrupt pending" by reading at FEh bit 0.
		// It is quite safe to do this (at 0Fh) but add the verification
		// read to check at FE.0 before is you want to be more sure.
		// you can even loop on waiting for this bit to set once you
		// write the value FFh to offset 2Fh. Be sure not to have a
		// loop that will run forever.
		//bId = 0x00;
		OffsetRW = 0x0F;
		ok = AEC_PCTC_READ_1BYTE (&bId, &OffsetRW, &Addr);


		// This operation can be done NOW or later. It does
		// not mater, and this operation can be changed
		// to meet any specific requirements that your
		// software may have. The reason that it does NOT
		// matter is that nothing will happen until AFTER\
		// a 00h value is written to offset 2Fh (by entry
		// into 'NextInt' call).
		//enable all automatic interrupts (Read/Gen/field)
		bId = 0x07;
		OffsetRW = 0x2E;
		ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

		//This is very IMPORTANT to be done NOW. This is the
		// KEY that UNLOCKS the IRQ assertion. This operation
		// will result in bit FE.4 being set, and then when
		// and interrupt occurs, bit FE.1 will be '1' until
		// the ISR reads the interrupt code from offset 0Fh.
		//enable INTERRUPT enable		
		dwIE = 0x00000010;
		OffsetRW = 0xFC;
		ok = AEC_PCTC_WRITE_4BYTES (&dwIE, &OffsetRW, &Addr);
		//At this point, when the "next" interrupt is ENABLED
		// by writing a 00h value byte to offset 2Fh, if and when
		// and interrupt event occurs, it will generate an IRQ.
		// The AEC_NTTC.DLL call AEC_PCTC_ISR_1 does this AFTER
		// if has prepared the OS to handle the interrupt vector.
		// When the call returns, it passes the interrupt ID code
		// to the application for processing. See "TcISR1" below.
		// The direct driver call "NextInt" also does the same
		// thing as "TcISR1"...

	}	
	//no return for 'void'
}


//==========================================================
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	RecordSmart(int Cnt, WORD BrdAddr)
{
	WORD		Addr, OffsetE0, OffsetE1, OffsetE2, OffsetEF, Offset;
	BYTE		bId0, bId1, bId2, bType; // bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok;
	
	Addr =  BrdAddr;
	OffsetE0 = 0x3E0;
	OffsetE1 = 0x3E1;
	OffsetE2 = 0x3E2;
	OffsetEF = 0x3EF;

	AecBoard[Cnt].ReaderAvailable = FALSE;
	AecBoard[Cnt].GeneratorAvailable = FALSE;
	AecBoard[Cnt].VideoAvailable = FALSE;


	// DISABLE ALL generated interrupts (everything but Command response)
	bType = 0x00;
	Offset = 0x3F0;
	ok = AEC_PCTC_WRITE_1BYTE (&bType, &Offset, &Addr);

	bCom = 0x16; // idle command  ltc/vitc/vltc
	ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
	
	// read the smart board type id byte ( 0x50 VLTC, 0x93 VITC, 0x98 LTC)
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
	{
		AecBoard[Cnt].BrdModel = (WORD)bType;
		if ((bType == 0x50) || (bType == 0x93))
			AecBoard[Cnt].VideoAvailable = TRUE;
	}
		
	// read the board id bytes to see if this board reads tc.
	//ok = AEC_PCTC_READ_1BYTE (&bId0, &OffsetE0, &Addr);
	ok = AEC_PCTC_READ_1BYTE (&bId1, &OffsetE1, &Addr);
	//ok = AEC_PCTC_READ_1BYTE (&bId2, &OffsetE2, &Addr);
		
	//if ((bId0 == 'R' ) || (bId1 == 'R' ) || (bId2 == 'R' ))
	if (bId1 == 'D' )	//rDr
		AecBoard[Cnt].ReaderAvailable = TRUE;
	if (bId1 == 'G' )	//rG1
	{
		AecBoard[Cnt].ReaderAvailable = TRUE;
		AecBoard[Cnt].GeneratorAvailable = TRUE;
		AecBoard[Cnt].VideoAvailable = TRUE;
	}
	if (bId1 == 'E' )	//gEn
	{
		//AecBoard[Cnt].ReaderAvailable = TRUE;
		AecBoard[Cnt].GeneratorAvailable = TRUE;
		AecBoard[Cnt].VideoAvailable = TRUE;	
	}

	// now make sure that the board is in reader mode IF has reader,
	// else put into and start Generator mode.
	//Set the bCom byte to have correct value for current board
	if (bType ==0x50)
	{
		if (AecBoard[Cnt].GeneratorAvailable == TRUE)
				bCom = 0x2C; // Gen. Mode
		else bCom = 23;
			ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
	}
	else
	{
		if (AecBoard[Cnt].GeneratorAvailable == TRUE)
				bCom = 0x18; // Gen. Mode
		else bCom = 10;
			ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
	}
		
	//Get out of Idle mode into a reader or generator mode
	ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);

	//if not reader, start gen.
	if (AecBoard[Cnt].ReaderAvailable == FALSE)
	{
		Sleep(50);
		bCom = 0x48; // If NO reader, start Gen!
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
	}

	bCom = 0xFF;	//USE A DUMMY COMMAND CODE TO CAUSE AN INTERRUPT
	Offset = 0x3FF;
	ok = AEC_PCTC_WRITE_1BYTE (&bType, &Offset, &Addr);

	//NOW WAIT A FEW MILLISECONDS THEN READ FROM 3FE TO CLEAR THE IRQ
	Sleep(100);
	Offset = 0x3FE;
	ok = AEC_PCTC_READ_1BYTE (&bType, &Offset, &Addr);

	// ENABLE READER/VID FIELD/GENERATOR interrupts
	bType = 0x07;
	Offset = 0x3F0;
	ok = AEC_PCTC_WRITE_1BYTE (&bType, &Offset, &Addr);

	//NOW, when the value 00h is written by the AEC_PCTC_ISR1
	// call, then the interrupts will begin to be processed....
	
	//no return for 'void'
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DWORD TcISR1(HANDLE hAecDevice)		//board1
{
	DWORD		d4;
	WORD		pAddr, OffsetT, OffsetU;
	BYTE		iCd;
	BOOL		ok;
//	LARGE_INTEGER now;

    while ( ! exiting )			//THIS 'WHILE' LOOP IS THE ISR FOR THE FIRST
								//BOARD.  
								//THE ISR WILL LOOP INDEFINITLY. TO STOP the
								//ISR, MAKE A CALL TO STOP THE ISR (Suspend)
								//THREAD! or signal "exiting = true" to exit 
								//(this is what this program does as written),
								//from the MAIN program loop.
    {  

			rByte1 = AEC_PCTC_ISR_1 (&Brd1addr);		// wait for interrupt
			//The PC-LTC/IOR and PC-LTC/MMR boards get a 0x01 value
			//	by the AEC_NTTC.DLL file call above (...ISR_1)
			++IntCnt1;
			iCd = rByte1;
			switch (iCd)
			{
				case (0x01): //This will be the case for IOR/MMR boards
					bRnew = TRUE;
					iReadCnt++;				
					ok = AEC_PCTC_READ_TB(&lRTdat, &Brd1addr);
					break;
				case (0x13):	//tc reader interrupt (get time & user (don't worry about Embedded)			
					bRnew = TRUE;
					iReadCnt++;				
					ok = AEC_PCTC_READ_TB(&lRTdat, &Brd1addr);
					//ok = AEC_PCTC_READ_UB(&lRUdat, &Brd1addr);	//Get User data
					break;
				case (0x4C):	//tc generator interrupt
					bGnew = TRUE;
					iGenCnt++;
					bGnew = TRUE;
					iGenCnt++;
					OffsetT = 0x0040;	//for PCI
					OffsetU = 0x0044;
					if (AecBoard[0].BrdCkType == 3)
					{
						OffsetT = 0x0050;
						OffsetU = 0x0060;
					}
					ok = AEC_PCTC_READ_4BYTES(&lGTdat, &OffsetT, &Brd1addr);
					//ok = AEC_PCTC_READ_4BYTES(&lGUdat, &OffsetU, &Brd1addr);
					break;

				case (0x44):	//Video field int
					//NOTE: 
					//This feature is NOT yet supported in the current PCI-TC models
					//At the time this software was written, only the PCI-LTC/RDR
					//was available.
					//calculate the number of video field interrupts / second ?
					iVidCnt++;
					bVnew = TRUE;

// The commented out code below can be used to test the timing of the software
// as to interrupt to interrupt intervals. Some modifications may be required,
// but at least you will have some idea of what to do if you want to do this.
					// see if interrupts occur too fast or too slow - keep track?
	//				QueryPerformanceCounter(&now);
	//				if ( last.QuadPart )
	//				{
	//					DWORD n = (DWORD) ((now.QuadPart - last.QuadPart) / (frequency.QuadPart / 1000));
	//					if ( n < min )
	//						min = n;
	//					if ( n > max )
	//						max = n;	// **NEW***
	//					if ( n > 17 )	// may need to change this value if not detecting
	//						count += 1;	// 60 /Second video field rate interrupt.
	//								//    Use '34' for 30 frame reader/gen
	//								//    Use '41' for 25 frame reader/gen (PAL)
	//								//    Use '21' for 50 field video rate interrupt (PAL)
	//				}
	//				last.QuadPart = now.QuadPart;

					break;

				default:	//command response, compare, serial...NAK
					iOtherCnt++;
				}

    }
    return(NO_ERROR);       // can't get here
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*++
DWORD TcISR2(HANDLE hAecDevice)		//board2
{
    while ( ! exiting )
    {  
		rByte2 = AEC_PCTC_ISR_2 (&Brd2addr);
			// wait for interrupt
		++IntCnt2;
    }
    return(NO_ERROR);       // can't get here
}
--*/
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*++
DWORD TcISR3(HANDLE hAecDevice)		//board3
{
    while ( ! exiting )
    {  
		rByte3 = AEC_PCTC_ISR_3 (&Brd3addr);
			// wait for interrupt
		++IntCnt3;
    }
    return(NO_ERROR);       // can't get here
}
--*/
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	StartSmart(int Cnt)
{
	BYTE	bCom, bRet;
	WORD	BrdAddr, OffsetRW, Offset3F0;
	BYTE	IDb;
	int		i;
	BOOL	retV;


	OffsetRW = 0x3EF;
	for (i = 0; i < Cnt; i++)
	{
		if (AecBoard[i].BrdCkType == 3)
		{
			BrdAddr = AecBoard[i].BrdAddr;

			Offset3F0 = 0x3F0;
			// **NEW**
			// ** SET the MASK **
			// Choose the correct value here to match the value choosen
			// as the command selected below
			//  = 0x04 // for time code generator interrupt
			//  = 0x02 // video field rate interrupt
			//	= 0x01 // reader interrupt
			//  = 0x08 // SERIAL OPTION: transmit (tx) int
			//  = 0x10 // SERIAL OPTION: receive (rx) int
			//  = 0x20 // time code  comparator int
			IDb = 0x07;	// read+gen+video field
			AEC_PCTC_WRITE_1BYTE(&IDb, &Offset3F0, &BrdAddr);

			bRet = 0x05;	

			
			// change the command below if you are using a generator only
			// time code board. 


			if (retV = AEC_PCTC_READ_1BYTE (&IDb, &OffsetRW, &BrdAddr))	
			{
				if (IDb == 0x50)	//commands for VLTC/... models
					bCom = 0x23;	// dual reader mode command vltc board. set MASK=01
					//bCom = 0x21;	// ltc reader only mode.set MASK=01
					//bCom = 0x22;	// vitc reader only mode.set MASK=01
					//bCom = 0x24;  // ltc gen only.set MASK=04 or 02* (*video connected)
					//bCom = 0x28;  // vitc gen only.set MASK=04 or 02
					//bCom = 0x2C;	// gen ltc & vitc simultaneous.set MASK=04 or 02
					
				else		//commands for LTC/... and VITC/...  model boards
					bCom = 0x10;	// reader mode  (RDR & RG1 models only).
									// set MASK = 01 or 02* (*RG1 model)
				
				//bCom = 0x18;	//generator mode (GEN & RG1 models only)
									// set MASK = 01 or 02* (*video connected)
			
				retV = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &BrdAddr);
			}
		}
	}
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//For PCI devices see the function "RecordPci". That function handles
// the reads/writes that get the PCI device ready to do interrupts
// and sets the stage for calling "AEC_PCTC_ISR_?" in DLL.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	ClearAllInts(int Cnt)
{
	WORD	BrdAddr;
	int		i, j;
	BOOL	retV;
	DWORD	BrdIdw;
	BYTE	bCom, bRet;

	for (i = 0; i < Cnt; i++)
	{
		BrdAddr = AecBoard[i].BrdAddr;
		if ((AecBoard[i].BrdCkType == 1) || (AecBoard[i].BrdCkType == 2))
		{
			returnval = AEC_PCTC_READ_TB (&BrdIdw, &BrdAddr);//
			returnval = AEC_PCTC_READ_TB (&BrdIdw, &BrdAddr);//
			returnval = AEC_PCTC_READ_TB (&BrdIdw, &BrdAddr);//
		}
		else if (AecBoard[i].BrdCkType == 3)
		{
			retV = TRUE;	//dummy line, does nothing
			/*++	//The following lines have become obsolete with the
					//addition of the last part of code in the "RecordSmart"
					//function
			bRet = 0x05;	
			bCom = 0x16;	//put  all smart boards in idle mode				
			returnval = AEC_PCTC_SEND_COMMAND (&bCom, &bRet, &BrdAddr);
			bCom = 0x20;	//about 32ms delay	
			for (j = 0; j < 0x10; j++)	// clear out all of the pending ints if any
			{
				retV = AEC_PCTC_GET_INTCODE(&bCom, &bRet, &BrdAddr);//
			}
			--*/
		}
		else if (AecBoard[i].BrdCkType == 4) //type = 4, PCI
			retV = TRUE;	//dummy line, does nothing
	}
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*++
void	SingleSmartInt()
{
	WORD	BrdAddr, Offset3FF;
	BYTE	IDb;


	Offset3FF = 0x3FF;
				// hard coded 0 (for those with only one board)
	BrdAddr = AecBoard[0].BrdAddr;
	IDb = 0x20;
	AEC_PCTC_WRITE_1BYTE(&IDb, &Offset3FF, &BrdAddr);
}
--*/

//----------------------------------------------------------------
/*++
		//	THE FOLLOWING IS IMPORTANT WHEN EXITING THE PROGRAM
		//  THAT HAS BEEN USING INTERRUPTS.
		//
		//1)Force an interrupt, (after setting EXITING TRUE) by 
		//  sending a dummy command.
		//  Purpose: This will allow the ISR thread to exit cleanly
		//	if it has not already done so. 
		//2)(IF PCI) Clear the IntA enable bit at offset FE.4 by
		//  writing 0x00000000 to Offset FC (Write4 must be used!)
		//   (IF ISA) Put the BOARD into IDLE mode

		//These are done in the following segements!
		// Passes in the number of boards that were found.
		//Shuts downs all of the boards
--*/
//----------------------------------------------------------------
void	CleanUpInterrpts(int Cnt)
{
	WORD		Addr, OffsetRW;
	BYTE		bId, bType; // 
	BYTE		bCom, bRet;
	BOOL		ok;
	DWORD		dwIE;
	int i, type;
	
	for (i=0; i<Cnt; i++)
	{
		Addr = AecBoard[i].BrdAddr;		//
		type = AecBoard[i].BrdCkType;
		if (type == 3)	//smart
		{
			// Force an interrupt!
			// --> For 'Smart' boards, just send a command to 3FF
			//		this will cause an interrupt
			//Purpose: This will allow the ISR thread to exit cleanly
			//			without leaving residual effects 
			
			bCom = 0x16; // will generate an int (will NAK) 
			// option on board. Choose any Command wanted ie: 0x16 = idle
			ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		}
		else if (type == 4) //pci
		{
			//Write (send first half of command) to command port
			bId = 0xF0;
			OffsetRW = 0x2F;
			ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

			Sleep(25);	//ALLOW TIME FOR BOARD TO RESPOND BEFORE
						//CLEARING THE ENABLES!
			//Clear the interrupt enable
			//This will STOP the board from asserting any more IRQs.
			dwIE = 0x00000000;
			OffsetRW = 0xFC;
			ok = AEC_PCTC_WRITE_4BYTES (&dwIE, &OffsetRW, &Addr);

//NOT required upon exit but can be done!
			//clear all int ENABLE flags
//			bId = 0x00;
//			OffsetRW = 0x2E;
//			ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

			//Read (do second half of command) from command response port
			//bId = 0x20;
			OffsetRW = 0x0F;
			ok = AEC_PCTC_READ_1BYTE (&bId, &OffsetRW, &Addr);
			Sleep(1);
			bId = 0x00;
			OffsetRW = 0x2F;
			ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

			bId = 0x00;			//disable interrupt "enable" flags bits
			OffsetRW = 0x2E;
			ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);
		}
//		else	//ior or mmr
//		{
//			ok = TRUE;
//			// Force an interrupt!
//			// --> For 'IOR' OR 'MMR', it can't be done - could be a problem!!
//		}

	}
}

//-----------------------------------------------------------
//Convert a LONG (4byte) value into a character string of TIME (Tm)
//This does NOT mask embedded bits 
// use "dw = (dw & 0x3F7F7F3F);" to mask embedded bits IF needed
//before calling this routine.
//Convert a DWORD (ULONG) into a character string
// 0xABCDabcd --> AB:CD:ab:cd with terminating end of line
//------------------------------------------------------------
int LtoStrTm(ULONG dw, char *chs)	
{
	//Put into string
	wsprintf (chs,"%8.8X",dw);

	//adjust string and add ':' characters
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';
	return 11;	//string LENGTH
	//Works the same as DLL function "DWORDtoString" but is faster (less overhead)
}


//------------------------------------------------------------
// Code used for debugging
void MessageBoxProc( LPSTR lpErrorText )	//(int nErrID, LPSTR lpErrorText)
{
    
	MessageBox(NULL, lpErrorText, NULL, MB_OK);
}
// Usage:
//wsprintf(MBstr, "Error# %x", PUTvar);
//MessageBoxProc (MBstr);
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	      // END OF CODE	END OF CODE		END OF CODE
