// L21RdrView.cpp : implementation of the CL21RdrView class
//

#include "stdafx.h"
#include "Line21Reader.h"

#include "L21RdrDoc.h"
#include "L21RdrView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//extern class CAecPoll	AecPciBrd;
extern CAecPoll	AecPciBrd;
extern BOOL global_ReadCaptureOn;	//global capture flag
//extern int iglobal_CurrentChannelView;
/////////////////////////////////////////////////////////////////////////////
// CL21RdrView

IMPLEMENT_DYNCREATE(CL21RdrView, CView)

BEGIN_MESSAGE_MAP(CL21RdrView, CView)
	//{{AFX_MSG_MAP(CL21RdrView)
	ON_COMMAND(IDR_LINE21STOP, OnLine21stop)
	ON_COMMAND(IDR_LINE21STARTSTOP, OnLine21startstop)
	ON_COMMAND(IDR_LINE21START, OnLine21start)
	ON_WM_TIMER()
	ON_COMMAND(IDR_C1, OnC1)
	ON_COMMAND(IDR_C2, OnC2)
	ON_COMMAND(IDR_C3, OnC3)
	ON_COMMAND(IDR_C4, OnC4)
	ON_COMMAND(IDR_T1, OnT1)
	ON_COMMAND(IDR_T2, OnT2)
	ON_COMMAND(IDR_T3, OnT3)
	ON_COMMAND(IDR_T4, OnT4)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CL21RdrView construction/destruction

CL21RdrView::CL21RdrView()
{
	// TODO: add construction code here
	m_ReaderCaptureOn = FALSE;
	m_firstView = TRUE;
	m_firstCatch = TRUE;
	m_CurrentChannelView = F1_C1;	//default value
	m_bOutTimeF1C1 = FALSE;
	m_bOutTimeF1C2 = FALSE;
	m_bOutTimeF2C1 = FALSE;
	m_bOutTimeF2C2 = FALSE;
	m_bOutTimeF1T1 = FALSE;
	m_bOutTimeF1T2 = FALSE;
	m_bOutTimeF2T1 = FALSE;
	m_bOutTimeF2T2 = FALSE;

	m_DoingText4 = FALSE;
	m_DoingText3 = FALSE;
	m_DoingText2 = FALSE;
	m_DoingText1 = FALSE;

	m_iReadsInARow = 0;
	iRdr = 0;
	iVid = 0;
	iCC = 0;
	m_iStuff = 0;
	iPoll_Loops = 0;
	ic1f1 = 0;
	ic2f1 = 0;
	iControlfirst = 0;
	iControlsecond = 0;

	//m_CurrentChannelView = iglobal_CurrentChannelView;	//default value
}

CL21RdrView::~CL21RdrView()
{
}

BOOL CL21RdrView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CL21RdrView drawing

void CL21RdrView::OnDraw(CDC* pDC)
{
	char	hhmmssff[30];
	CL21RdrDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	POSITION pos;
	int i, linePos; //, iCount;
	TEXTMETRIC textMetrics;
	//UINT ta;
	RECT rect;


	if (!GetDocument()->IsEmpty())
	{
		if (m_firstView)
		{
			pDC->GetTextMetrics(&textMetrics);
			m_tmHigh = textMetrics.tmHeight;
			m_tmHigh += 5;	//add space between lines
			m_firstView = FALSE;	
			m_lineNum = 1;
		}
		//Get the current client rect		
		GetClientRect(&rect);
		linePos = rect.bottom;
		i = 0;

		if (m_CurrentChannelView == F1_C2)
		{
			CStringList &lineList2 = pDoc->m_StringListC2; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList2.GetHeadPosition();	//TOP DOWN
			pos = lineList2.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList2.GetNext(pos);	//TOP DOWN
				CString str1 = lineList2.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}

		else if (m_CurrentChannelView == F2_C1)
		{
			CStringList &lineList3 = pDoc->m_StringListC3; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList3.GetHeadPosition();	//TOP DOWN
			pos = lineList3.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList.3GetNext(pos);	//TOP DOWN
				CString str1 = lineList3.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}

		else if (m_CurrentChannelView == F2_C2)
		{
			CStringList &lineList4 = pDoc->m_StringListC4; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList4.GetHeadPosition();	//TOP DOWN
			pos = lineList4.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList4.GetNext(pos);	//TOP DOWN
				CString str1 = lineList4.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}

//============
		else if (m_CurrentChannelView == F1_T1)
		{
			CStringList &lineList5 = pDoc->m_StringListT1; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList5.GetHeadPosition();	//TOP DOWN
			pos = lineList5.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList5.GetNext(pos);	//TOP DOWN
				CString str1 = lineList5.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}
//============
		else if (m_CurrentChannelView == F1_T2)
		{
			CStringList &lineList6 = pDoc->m_StringListT2; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList6.GetHeadPosition();	//TOP DOWN
			pos = lineList6.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList6.GetNext(pos);	//TOP DOWN
				CString str1 = lineList6.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}
//============
		else if (m_CurrentChannelView == F2_T1)
		{
			CStringList &lineList7 = pDoc->m_StringListT3; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList7.GetHeadPosition();	//TOP DOWN
			pos = lineList7.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList7.GetNext(pos);	//TOP DOWN
				CString str1 = lineList7.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}
//============
		else if (m_CurrentChannelView == F2_T2)
		{
			CStringList &lineList8 = pDoc->m_StringListT4; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList8.GetHeadPosition();	//TOP DOWN
			pos = lineList8.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList8.GetNext(pos);	//TOP DOWN
				CString str1 = lineList8.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}
//============

		else // (m_CurrentChannelView == F1_C1)
		{
			CStringList &lineList1 = pDoc->m_StringListC1; 
			pDC->SetTextAlign(TA_NOUPDATECP);	//(TA_LEFT | TA_TOP | TA_UPDATECP);
			
			//pos = lineList1.GetHeadPosition();	//TOP DOWN
			pos = lineList1.GetTailPosition();	//bottom up

			while ((pos != NULL) && (linePos > m_tmHigh))
			{
				i++;
				//linePos = i * (int)m_tmHigh;	//TOP DOWN
				linePos = (rect.bottom  - (i * (int)m_tmHigh)); //bottom up
				//CString str1 = lineList1.GetNext(pos);	//TOP DOWN
				CString str1 = lineList1.GetPrev(pos);//bottom up

				CString str = str1;					//make a copy
				str.TrimLeft();		//clean up leading tabs/spaces
				str.TrimRight();	//clean up trailing tabs/spaces
				//pDC->TextOut(10, linePos, str);		//TOP DOWN	
				pDC->TabbedTextOut(10, linePos, str, 0, NULL, 10); //bottom up			
			}
		}
	}

	//The following can be used to send debugging info to the window!
	//FOR DEBUG
	pDC->TextOut(450, 5, hhmmssff, wsprintf (hhmmssff,"%d-%d %d %d _%d", m_iStuff, iCC, iVid, iRdr, iPoll_Loops));
	//iControlsecond++; //iControlfirst++;
	pDC->TextOut(20, 5, hhmmssff, wsprintf (hhmmssff,"%d  %d  c1-%d c2-%d", iControlsecond, iControlfirst, ic1f1, ic2f1));


}


/////////////////////////////////////////////////////////////////////////////
// CL21RdrView printing

BOOL CL21RdrView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CL21RdrView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CL21RdrView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CL21RdrView diagnostics

#ifdef _DEBUG
//===============================================================
void CL21RdrView::AssertValid() const
{
	CView::AssertValid();
}

//===============================================================
void CL21RdrView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

//===============================================================
CL21RdrDoc* CL21RdrView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CL21RdrDoc)));
	return (CL21RdrDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
//===============================================================
void CL21RdrView::OnLine21startstop() 
{
	if (!global_ReadCaptureOn)	
		OnLine21start();			
	else //global_ReadCaptureOn
		OnLine21stop();
}
//===============================================================
// CL21RdrView message handlers
void CL21RdrView::OnLine21start() 
{
	iControlsecond = 0;
	iControlfirst = 0;
	ic1f1 = 0;
	ic2f1 = 0;
	m_iReadsInARow = 0;
	iRdr = 0;
	iVid = 0;
	iCC = 0;
	m_iStuff = 0;
	iPoll_Loops = 0;
	if (!global_ReadCaptureOn && !m_ReaderCaptureOn)
	{
		global_ReadCaptureOn = TRUE;
		m_ReaderCaptureOn = TRUE;
		//MessageBeep(0xFFFFFFFF);


		CWnd* pMain = AfxGetMainWnd();
		// The main window _can_ be NULL, so this code
		// doesn't ASSERT and actually tests.
		if (pMain != NULL)
		{
		   // Get the main window's menu
		   CMenu* pMenu = pMain->GetMenu();

		   if (pMenu != NULL && pMenu->GetMenuItemCount() > 0)
		   {
				pMenu->EnableMenuItem(IDR_LINE21START, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
				pMenu->EnableMenuItem(IDR_LINE21STOP, MF_BYCOMMAND | MF_ENABLED);
				//CMenu* submenu = pMenu->GetSubMenu(0);
				//submenu->EnableMenuItem(IDR_LINE21START, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
				//submenu->EnableMenuItem(IDR_LINE21STOP, MF_BYCOMMAND | MF_ENABLED);
		   }
		   // No need to delete pMenu because it is an MFC temporary object.
		   //CToolBar* pTBar = pMain->?
		}
		
		if(m_firstCatch)
		{
			m_firstCatch = FALSE;
			m_pLineCurrentC1 = new CString(" ** AEC Line21 Reader Capture ** ");
			GetDocument()->NewLine(m_pLineCurrentC1, F1_C1);
			m_indexF1C1 = m_pLineCurrentC1->GetLength();

			DoCRLF(F1_C1);
			//GetDocument()->NewLine(m_pLineCurrentC1, F1_C1);
		}
		
		m_pLineCurrentC1 = new CString();
		m_indexF1C1 = 0;
		DoCRLF(F1_C1);
		Insert(F1_C1, TAB);
		Insert(F1_C1, "+++++ START SEGMENT");
		Insert(F1_C1, TAB);
		Insert(F1_C1, TAB);
		InsertDateTime();	//PUT THE DATE/TIME IN CString
		//GetDocument()->NewLine(m_pLineCurrentC1, F1_C1);	
		GetDocument()->NewLine(m_pLineCurrentC1, CHAN_ALL);	

		m_pLineCurrentC1 = NULL;
		m_pLineCurrentC2 = NULL;
		m_pLineCurrentC3 = NULL;
		m_pLineCurrentC4 = NULL;
		m_pLineCurrentT1 = NULL;
		m_pLineCurrentT2 = NULL;
		m_pLineCurrentT3 = NULL;
		m_pLineCurrentT4 = NULL;
		//m_CurrentChannelF1 = CHAN_NONE;	//F1_C1
		m_CurrentChannelF1 = F1_C1;	//set "regular" caption as default
		//m_CurrentChannelF2 = CHAN_NONE;
		m_CurrentChannelF2 = F2_C1;	//set for f2c1 caption default

		InvalidateRect(NULL, TRUE);
		AecPciBrd.StartL21();
		m_StartingNewLine = TRUE;
		//SetTimer(1, 100, NULL);
		SetTimer(1, 30, NULL);
		
		m_loopCnt = 0;
	}
}

//===============================================================
void CL21RdrView::OnLine21stop() 
{
	if (global_ReadCaptureOn && m_ReaderCaptureOn)
	{
		AecPciBrd.StopL21();
		global_ReadCaptureOn = FALSE;	//set the "turn on" flag
		m_ReaderCaptureOn = FALSE;

		CWnd* pMain = AfxGetMainWnd();

		// The main window _can_ be NULL, so this code
		// doesn't ASSERT and actually tests.
		if (pMain != NULL)
		{
		   // Get the main window's menu
		   CMenu* pMenu = pMain->GetMenu();

		   if (pMenu != NULL && pMenu->GetMenuItemCount() > 0)
		   {
				pMenu->EnableMenuItem(IDR_LINE21STOP, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
				pMenu->EnableMenuItem(IDR_LINE21START, MF_BYCOMMAND | MF_ENABLED);
				//CMenu* submenu = pMenu->GetSubMenu(0);
				//submenu->EnableMenuItem(IDR_LINE21START, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
				//submenu->EnableMenuItem(IDR_LINE21STOP, MF_BYCOMMAND | MF_ENABLED);

		   }
		   // No need to delete pMenu because it is an MFC temporary object.
		}

		//+++++++++++++++++++++++++
		// Add code here to time stamp the OUT time of the string
		KillTimer(1);
		if (m_pLineCurrentC1)		//save any current line data
		{
			//InsertTimeOut(F1_C1);
			GetDocument()->NewLine(m_pLineCurrentC1, F1_C1);
		}
		if (m_pLineCurrentC2)		//save any current line data
		{
			//InsertTimeOut(F1_C2);
			GetDocument()->NewLine(m_pLineCurrentC2, F1_C2);
		}
		if (m_pLineCurrentC3)		//save any current line data
		{
			//InsertTimeOut(F2_C1);
			GetDocument()->NewLine(m_pLineCurrentC3, F2_C1);
		}
		if (m_pLineCurrentC4)		//save any current line data
		{
			//InsertTimeOut(F2_C2);
			GetDocument()->NewLine(m_pLineCurrentC4, F2_C2);
		}

		if (m_pLineCurrentT1)		//save any current line data
		{
			//InsertTimeOut(F1_T1);
			GetDocument()->NewLine(m_pLineCurrentT1, F1_T1);
		}
		if (m_pLineCurrentT2)		//save any current line data
		{
			//InsertTimeOut(F1_T2);
			GetDocument()->NewLine(m_pLineCurrentT2, F1_T2);
		}
		if (m_pLineCurrentT3)		//save any current line data
		{
			//InsertTimeOut(F2_T1);
			GetDocument()->NewLine(m_pLineCurrentT3, F2_T1);
		}
		if (m_pLineCurrentT4)		//save any current line data
		{
			//InsertTimeOut(F2_T2);
			GetDocument()->NewLine(m_pLineCurrentT4, F2_T2);
		}
		//+++++++++++++++++++++++++

		Sleep(50);
		m_pLineCurrentC1 = new CString();
		m_indexF1C1 = 0;
		DoCRLF(F1_C1);
		Insert(F1_C1, TAB);
		Insert(F1_C1, "-----  END SEGMENT");
		Insert(F1_C1, TAB);
		Insert(F1_C1, TAB);
		
		InsertDateTime();	//PUT THE DATE/TIME IN F1_C1 CString
		DoCRLF(F1_C1);

		//Insert this string into all of the channels
		GetDocument()->NewLine(m_pLineCurrentC1, CHAN_ALL);
		
		Sleep(100);
		InvalidateRect(NULL, TRUE);
	}	//end if
	MessageBeep(0xFFFFFFFF);
	//m_CurrentChannelF1 = CHAN_NONE;	//F1_C1
	m_CurrentChannelF1 = F1_C1;	//set "regular" caption as default
	//m_CurrentChannelF2 = CHAN_NONE;
	m_CurrentChannelF2 = F2_C1;	//set for c1 caption default
	
}


//===============================================================
void CL21RdrView::InsertDateTime()
{
	//CString strDateTime;
	char str[50];
	GetLocalTime(&datetime);
//	wsprintf(str, "Date= %u/%u/%u  Time= %u:%u:%u:%u", 
//		datetime.wMonth, datetime.wDay, datetime.wYear, 
//		datetime.wHour, datetime.wMinute, datetime.wSecond, datetime.wMilliseconds);
	wsprintf(str, "Date = %2.2u/%2.2u/%4.4u  Time = %2.2u:%2.2u:%2.2u ", 
		datetime.wMonth, datetime.wDay, datetime.wYear, 
		datetime.wHour, datetime.wMinute, datetime.wSecond);
	Insert(F1_C1, str);
		//CString strDateTime
/*		SYSTEMTIME {
			WORD wYear;
			WORD wMonth;
			WORD wDayOfWeek;
			WORD wDay;
			WORD wHour;
			WORD wMinute;
			WORD wSecond;
			WORD wMilliseconds;
		} SYSTEMTIME;  
*/
}

//===============================================================
void CL21RdrView::UpdateCxTxStatus()
{
	UINT idrNow;
	switch(m_CurrentChannelView)
	{
		case F1_C1:
			idrNow = IDR_C1;
			break;
		case F1_T1:
			idrNow = IDR_T1;
			break;
		case F1_C2:
			idrNow = IDR_C2;
			break;
		case F1_T2:
			idrNow = IDR_T2;
			break;
		case F2_C1:
			idrNow = IDR_C3;
			break;
		case F2_T1:
			idrNow = IDR_T3;
			break;
		case F2_C2:
			idrNow = IDR_C4;
			break;
		case F2_T2:
			idrNow = IDR_T4;
			break;
		default:
			idrNow = 0;
	}
	if (idrNow != 0)
	{
		CWnd* pMain = AfxGetMainWnd();
		// The main window _can_ be NULL, so this code
		// doesn't ASSERT and actually tests.
		if (pMain != NULL)
		{
		   // Get the main window's menu
		   CMenu* pMenu = pMain->GetMenu();
		   if (pMenu != NULL && pMenu->GetMenuItemCount() > 0)
		   {
			   pMenu->CheckMenuItem(IDR_C1, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_C2, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_C3, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_C4, MF_UNCHECKED);

			   pMenu->CheckMenuItem(IDR_T1, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_T2, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_T3, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_T4, MF_UNCHECKED);
			   pMenu->CheckMenuItem(idrNow, MF_CHECKED);
		   }
		}
	}
}

//===============================================================
void CL21RdrView::OnC1() 
{
/*		CWnd* pMain = AfxGetMainWnd();
		// The main window _can_ be NULL, so this code
		// doesn't ASSERT and actually tests.
		if (pMain != NULL)
		{
		   // Get the main window's menu
		   CMenu* pMenu = pMain->GetMenu();
		   if (pMenu != NULL && pMenu->GetMenuItemCount() > 0)
		   {
			   pMenu->CheckMenuItem(IDR_C1, MF_CHECKED);
			   pMenu->CheckMenuItem(IDR_C2, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_C3, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_C4, MF_UNCHECKED);

			   pMenu->CheckMenuItem(IDR_T1, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_T2, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_T3, MF_UNCHECKED);
			   pMenu->CheckMenuItem(IDR_T4, MF_UNCHECKED);
		   }
		}
*/
		m_CurrentChannelView = F1_C1;	
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F1_C1;
}

//===============================================================
void CL21RdrView::OnC2() 
{
		m_CurrentChannelView = F1_C2;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F1_C2;
}
//===============================================================
void CL21RdrView::OnC3() 
{
		m_CurrentChannelView = F2_C1;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F2_C1;
}
//===============================================================
void CL21RdrView::OnC4() 
{
		m_CurrentChannelView = F2_C2;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F2_C2;
}
//===============================================================
void CL21RdrView::OnT1() 
{
		m_CurrentChannelView = F1_T1;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F1_T1;
}
//===============================================================
void CL21RdrView::OnT2() 
{
		m_CurrentChannelView = F1_T2;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F1_T2;
}
//===============================================================
void CL21RdrView::OnT3() 
{
		m_CurrentChannelView = F2_T1;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F2_T1;
}
//===============================================================
void CL21RdrView::OnT4() 
{
		m_CurrentChannelView = F2_T2;
		UpdateCxTxStatus();
		InvalidateRect(NULL, TRUE);
		//iglobal_CurrentChannelView = F2_T2;
}
//===============================================================

void CL21RdrView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (bActivate)
	{
		switch (m_CurrentChannelView)
		{
		case F1_C1:
			OnC1();
			break;
		case F1_C2:
			OnC2();
			break;
		case F2_C1:
			OnC3();
			break;
		case F2_C2:
			OnC4();
			break;
		case F1_T1:
			OnT1();
			break;
		case F1_T2:
			OnT2();
			break;
		case F2_T1:
			OnT3();
			break;
		case F2_T2:
			OnT4();
			break;
		default:
			OnC1();
			break;
		}
	}
	
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}
//===============================================================


void CL21RdrView::InsertTime(UINT CurrentCCTxt)
{
	// If time code is available, insert it, else
	// insert pc clock time
	
	char str[12];
	int i;
	if ( AecPciBrd.mbReadsTC && AecPciBrd.ReaderDataGood() )
	{
		// is time code reader in use? - copy last TC read into str[15]
		for (i=0; i<12; i++)
			str[i] = m_charStr[i];

	}
	else
	{
		GetLocalTime(&datetime);
		wsprintf(str, "%2.2u:%2.2u:%2.2u.%2.2u", 			
			datetime.wHour, datetime.wMinute, datetime.wSecond, (datetime.wMilliseconds/10));
		// all are WORD values
	}
	Insert(CurrentCCTxt, str);
}

//===============================================================

void CL21RdrView::InsertTimeOut(UINT CurrentCCTxt)
{
	// If time code is available, insert it, else
	// insert pc clock time
	
	char str[12];
	int i;

	if ( AecPciBrd.mbReadsTC && AecPciBrd.ReaderDataGood() )
	{
		// is time code reader in use? - copy last TC read into str[12]
		for (i=0; i<12; i++)
			str[i] = m_charStr[i];

	}
	else
	{
		GetLocalTime(&datetime);
		wsprintf(str, "%2.2u:%2.2u:%2.2u.%2.2u", 			
			datetime.wHour, datetime.wMinute, datetime.wSecond, (datetime.wMilliseconds/10));
		// all are WORD values
	}
	switch (CurrentCCTxt)
	{
		case F1_C1:
			if (!m_bOutTimeF1C1)
			{
				m_indexF1C1 = m_pLineCurrentC1->Insert(m_outTime, TAB);	//TAB
				m_indexF1C1 = m_pLineCurrentC1->Insert(m_outTime, str);
				m_bOutTimeF1C1 = TRUE;
			}
			break;
		case F1_C2:
			if (!m_bOutTimeF1C2)
			{
				m_indexF1C2 = m_pLineCurrentC2->Insert(m_outTime, TAB);
				m_indexF1C2 = m_pLineCurrentC2->Insert(m_outTime, str);
				m_bOutTimeF1C2 = TRUE;
			}
			break;
		case F2_C1:
			if (!m_bOutTimeF2C1)
			{
				m_indexF2C1 = m_pLineCurrentC3->Insert(m_outTime, TAB);
				m_indexF2C1 = m_pLineCurrentC3->Insert(m_outTime, str);
				m_bOutTimeF2C1 = TRUE;
			}
			break;
		case F2_C2:
			if (!m_bOutTimeF2C2)
			{
				m_indexF2C2 = m_pLineCurrentC4->Insert(m_outTime, TAB);
				m_indexF2C2 = m_pLineCurrentC4->Insert(m_outTime, str);
				m_bOutTimeF2C2 = TRUE;
			}
			break;
		case F1_T1:
			if (!m_bOutTimeF1T1)
			{
				m_indexF1T1 = m_pLineCurrentT1->Insert(m_outTime, TAB);
				m_indexF1T1 = m_pLineCurrentT1->Insert(m_outTime, str);
				m_bOutTimeF1T1 = TRUE;
			}
			break;
		case F1_T2:
			if (!m_bOutTimeF1T2)
			{
				m_indexF1T2 = m_pLineCurrentT2->Insert(m_outTime, TAB);
				m_indexF1T2 = m_pLineCurrentT2->Insert(m_outTime, str);
				m_bOutTimeF1T2 = TRUE;
			}
			break;
		case F2_T1:
			if (!m_bOutTimeF2T1)
			{
				m_indexF2T1 = m_pLineCurrentT3->Insert(m_outTime, TAB);
				m_indexF2T1 = m_pLineCurrentT3->Insert(m_outTime, str);
				m_bOutTimeF2T1 = TRUE;
			}
			break;
		case F2_T2:
			if (!m_bOutTimeF2T2)
			{
				m_indexF2T2 = m_pLineCurrentT4->Insert(m_outTime, TAB);
				m_indexF2T2 = m_pLineCurrentT4->Insert(m_outTime, str);
				m_bOutTimeF2T2 = TRUE;
			}
			break;
		default:
			break;
	}
}

//===============================================================

void CL21RdrView::Insert(UINT ChanFCT, char s)
{	
	int min = 0x30;
	int max = 0x3A;

	//max field2 captions
	int minF2 = 0x48;
	int maxF2 = 0x50;

	//Max text per line
	int minT = 0x38;
	int maxT = 0x48;

	BOOL	SpaceDot = FALSE;

	if (( s == ' ') || (s == '.'))
		SpaceDot = TRUE;

	switch (ChanFCT)
	{
		case F1_C1:
			if (m_pLineCurrentC1)
			{
				if (s != CR_EOL)	
				{
					m_indentF1C1++;
					m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, s);
					//InvalidateRect(NULL, TRUE);
				}

				if ((s == CR_EOL) || ((m_indexF1C1 > min) && SpaceDot) || (m_indexF1C1 > max))
				{
					GetDocument()->NewLine(m_pLineCurrentC1, ChanFCT);
					m_pLineCurrentC1 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentC1 = new CString();
				m_indexF1C1 = 0;

				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, TAB);
				}
					
				if (s != ' ')
					m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, s);
			}

			break;
		case F1_C2:
			if (m_pLineCurrentC2)
			{
				if (s != CR_EOL)
				{
					m_indentF1C2++;
					m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, s);
				}
				if ((s == CR_EOL) || (m_indexF1C2 > min) && SpaceDot || (m_indexF1C2 > max))
				{
					GetDocument()->NewLine(m_pLineCurrentC2, ChanFCT);
					m_pLineCurrentC2 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentC2 = new CString();
				m_indexF1C2 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, TAB);
				}
				if (s != ' ')
					m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, s);
			}
			break;
		case F2_C1:
			if (m_pLineCurrentC3)
			{
				if (s != CR_EOL)
				{
					m_indentF2C1++;
					m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, s);
				}
				if ((s == CR_EOL) || ((m_indexF2C1 > minF2) && SpaceDot) || (m_indexF2C1 > maxF2))
				{
					GetDocument()->NewLine(m_pLineCurrentC3, ChanFCT);
					m_pLineCurrentC3 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentC3 = new CString();
				m_indexF2C1 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, TAB);
				}
				if (s != ' ')
					m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, s);
			}
			break;
		case F2_C2:
			if (m_pLineCurrentC4)
			{
				if (s != CR_EOL)
				{
					m_indentF2C2++;
					m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, s);
				}
					
				if ((s == CR_EOL) || ((m_indexF2C2 > minF2) && SpaceDot) || (m_indexF2C2 > maxF2))
				{
					GetDocument()->NewLine(m_pLineCurrentC4, ChanFCT);
					m_pLineCurrentC4 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentC4 = new CString();
				m_indexF2C2 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, TAB);
				}
				if (s != ' ')
					m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, s);
			}
			break;
		case F1_T1:
			if (m_pLineCurrentT1)
			{
				if (s != CR_EOL)
				{
					m_indentF1T1++;
					m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, s);
				}
					
				if ((s == CR_EOL) || ((m_indexF1T1 > minT) && SpaceDot) || (m_indexF1T1 > maxT))
				{
					GetDocument()->NewLine(m_pLineCurrentT1, ChanFCT);
					m_pLineCurrentT1 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentT1 = new CString();
				m_indexF1T1 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, TAB);
				}
				//if (s != ' ')
					m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, s);
			}
			break;
		case F1_T2:
			if (m_pLineCurrentT2)
			{
				if (s != CR_EOL)
				{
					m_indentF1T2++;
					m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, s);
				}
					
				if ((s == CR_EOL) || ((m_indexF1T2 > minT) && SpaceDot) || (m_indexF1T2 > maxT))				
				{
					GetDocument()->NewLine(m_pLineCurrentT2, ChanFCT);
					m_pLineCurrentT2 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentT2 = new CString();
				m_indexF1T2 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, TAB);
				}
				//if (s != ' ')
					m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, s);
			}
			break;
		case F2_T1:
			if (m_pLineCurrentT3)
			{
				if (s != CR_EOL)
				{
					m_indentF2T1++;
					m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, s);
				}
					
				if ((s == CR_EOL) || ((m_indexF2T1 > minT) && SpaceDot) || (m_indexF2T1 > maxT))				
				{
					GetDocument()->NewLine(m_pLineCurrentT3, ChanFCT);
					m_pLineCurrentT3 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentT3 = new CString();
				m_indexF2T1 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, TAB);
				}
				//if (s != ' ')
					m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, s);
			}
			break;
		case F2_T2:
			if (m_pLineCurrentT4)
			{
				if (s != CR_EOL)
				{
					m_indentF2T2++;
					m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, s);
				}
					
				if ((s == CR_EOL) || ((m_indexF2T2 > minT) && SpaceDot) || (m_indexF2T2 > maxT))
								{
					GetDocument()->NewLine(m_pLineCurrentT4, ChanFCT);
					m_pLineCurrentT4 = NULL;
					InvalidateRect(NULL, TRUE);
				}
			}
			else if (s != CR_EOL)
			{
				m_pLineCurrentT4 = new CString();
				m_indexF2T2 = 0;
				if (AecPciBrd.m_to2E & 0x40)
				{
					InsertTime(ChanFCT);
					m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, TAB);
				}
				//if (s != ' ')
					m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, s);
			}
			break;
		default:	//CHAN_NONE
			//m_iStuff--;
			break;
	}
}
//===============================================================

void CL21RdrView::Insert(UINT ui, char *str)
{
	switch (ui)
	{
		case F1_C1:
			if (m_pLineCurrentC1)
				m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, str);
			break;
		case F1_C2:
			if (m_pLineCurrentC2)
				m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, str);
			break;
		case F2_C1:
			if (m_pLineCurrentC3)
				m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, str);
			break;
		case F2_C2:
			if (m_pLineCurrentC4)
				m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, str);
			break;
		case F1_T1:
			if (m_pLineCurrentT1)
				m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, str);
			break;
		case F1_T2:
			if (m_pLineCurrentT2)
				m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, str);
			break;
		case F2_T1:
			if (m_pLineCurrentT3)
				m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, str);
			break;
		case F2_T2:
			if (m_pLineCurrentT4)
				m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, str);
			break;
		default:	//CHAN_NONE
			break;
	}
}

//===============================================================
/*
void CL21RdrView::InsertCRLF(UINT ui)
{

	switch (ui)
	{
		case F1_C1:
			if (m_pLineCurrentC1)
			{
				m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, CR);
				m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, LF);
			}
			else 
			{
				m_pLineCurrentC1 = new CString();
				m_indexF1C1 = m_pLineCurrentC1->Insert(0, CR);
				m_indexF1C1 = m_pLineCurrentC1->Insert(m_indexF1C1, LF);
			}

			break;
		case F1_C2:
			if (m_pLineCurrentC2)
			{
				m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, CR);
				m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, LF);
			}
			else 
			{
				m_pLineCurrentC2 = new CString();
				m_indexF1C2 = m_pLineCurrentC2->Insert(0, CR);
				m_indexF1C2 = m_pLineCurrentC2->Insert(m_indexF1C2, LF);
			}
			break;
		case F2_C1:
			if (m_pLineCurrentC3)
			{
				m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, CR);
				m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, LF);
			}
			else 
			{
				m_pLineCurrentC3 = new CString();
				m_indexF2C1 = m_pLineCurrentC3->Insert(0, CR);
				m_indexF2C1 = m_pLineCurrentC3->Insert(m_indexF2C1, LF);
			}
			break;
		case F2_C2:
			if (m_pLineCurrentC4)
			{
				m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, CR);
				m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, LF);
			}
			else 
			{
				m_pLineCurrentC4 = new CString();
				m_indexF2C2 = m_pLineCurrentC4->Insert(0, CR);
				m_indexF2C2 = m_pLineCurrentC4->Insert(m_indexF2C2, LF);
			}
			break;
		case F1_T1:
			if (m_pLineCurrentT1)
			{
				m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, CR);
				m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, LF);
			}
			else 
			{
				m_pLineCurrentT1 = new CString();
				m_indexF1T1 = m_pLineCurrentT1->Insert(0, CR);
				m_indexF1T1 = m_pLineCurrentT1->Insert(m_indexF1T1, LF);
			}
			break;
		case F1_T2:
			if (m_pLineCurrentT2)
			{
				m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, CR);
				m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, LF);
			}
			else 
			{
				m_pLineCurrentT2 = new CString();
				m_indexF1T2 = m_pLineCurrentT2->Insert(0, CR);
				m_indexF1T2 = m_pLineCurrentT2->Insert(m_indexF1T2, LF);
			}
			break;
		case F2_T1:
			if (m_pLineCurrentT3)
			{
				m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, CR);
				m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, LF);
			}
			else 
			{
				m_pLineCurrentT3 = new CString();
				m_indexF2T1 = m_pLineCurrentT3->Insert(0, CR);
				m_indexF2T1 = m_pLineCurrentT3->Insert(m_indexF2T1, LF);
			}
			break;
		case F2_T2:
			if (m_pLineCurrentT4)
			{
				m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, CR);
				m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, LF);
			}
			else 
			{
				m_pLineCurrentT4 = new CString();
				m_indexF2T2 = m_pLineCurrentT4->Insert(0, CR);
				m_indexF2T2 = m_pLineCurrentT4->Insert(m_indexF2T2, LF);
			}
			break;
		default:	//CHAN_NONE
			//m_iStuff--;
			break;
	}
}
*/

//===============================================================
void CL21RdrView::DoCRLF(UINT ui)
{
	Insert(ui, CR);
	Insert(ui, LF);	
}

//===============================================================
void CL21RdrView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default	
	//CView::OnTimer(nIDEvent);
	int i = 0;

	BOOL bGotInt = FALSE;
	do 
	{
		do
		{
			bGotInt = Poll_And_Process();
			//Sleep(1);
		} while (bGotInt);
		i++;
	} while (i < 4);

//	Poll_And_Process_Test();	//TEMP until above is DONE!
	
	if (global_ReadCaptureOn)		//If in "READING" mode, start timer again
		SetTimer(1, 5, NULL);	
	return;
}


//===============================================================
BOOL CL21RdrView::Poll_And_Process()
{
	BOOL bProcessed; // = FALSE;
	DWORD dw;
	//BYTE poll = AecPciBrd.PollInt();
	iPoll_Loops++;

	switch (AecPciBrd.PollInt())
	//switch (poll)
	{
		case 0x13:
			iRdr++;
			AecPciBrd.AscTB(m_charStr);	// read and save current time code
			bProcessed = TRUE;
			m_iReadsInARow++;
			if (m_iReadsInARow > 0x300)	//~4sec
			{
				m_iReadsInARow = 0;	//reset
				//AecPciBrd.Restart();
				//AecPciBrd.ClearL21Buffer(25);
				//MessageBeep(0xFFFFFFFF);	//debug use
				MessageBeep(MB_ICONHAND);
			}

			break;

		case 0x1E:
			iCC++;
			dw = AecPciBrd.L21Dword();
			ProcessCC(dw);
			//ProcessCC(AecPciBrd.L21Dword());
			bProcessed = TRUE;
			m_iReadsInARow = 0;	//clear "reset"  counter
			break;

		case 0x44:
			iVid++;
			if ((iVid & 0x0FFF) == 0)	//should beep be every (1/60 sec * 256) ~`4.2 sec
			{
				MessageBeep(MB_OK); //MB_ICONQUESTION
				//MessageBeep(0xFFFFFFFF);	//MB_ICONASTERISK MB_ICONEXCLAMATION MB_ICONHAND
				//MB_ICONQUESTION MB_OK
				//AecPciBrd.ClearL21Buffer(25);	//msec delay of clear then set 2E.6

			}

		default:
			bProcessed = FALSE;
	}

//	BYTE SigStat = (AecPciBrd.m_0C & 0x41);
//	if (m_SigStat != SigStat)
//	{		//update the status of the toolbar flags "IDR_VID" and "IDR_DATA"
//		m_SigStat = SigStat;
//		CWnd* pMain = AfxGetMainWnd();
//		// The main window _can_ be NULL, so this code
//		// doesn't ASSERT and actually tests.
//		if (pMain) //if (pMain != NULL)
//		{
//			pMain->
//		   // Get the main window's menu
//		   CMenu* pMenu = pMain->GetMenu();
//
//		   if (pMenu != NULL && pMenu->GetMenuItemCount() > 0)
//		   {
//				pMenu->EnableMenuItem(IDR_LINE21START, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
//		   }
//		}
//	
//	}

	return bProcessed;
}
//===============================================================
struct CC4
{		//The order of these bytes may need to be reversed!
	BYTE one;
	BYTE two;
	BYTE res;
	BYTE stat;
};
//----------------------------
union D_4B
{
	DWORD	d;
	CC4		b;
};
//----------------------------
// This function handles all of the received CC data and saves 
// to the various text/caption strings
// Use a Union to get 'dw' into 4 bytes and status flags

void CL21RdrView::ProcessCC(DWORD dw)
{
	BYTE bTemp;
	D_4B	L21;
	DWORD dwtemp;
	L21.d = (dw & 0xFFFF7F7F);	//now we have access to each byte via " .b " w/masked parity bits
	//L21.b.stat;
	//L21.b.res;	//NOT used
	//L21.b.two;	//character #2
	//L21.b.one;	//character #1


	//First, check the status byte to make sure that the
	// data if valid and that there are not errors
	// Return if there is a problem with the data
	if ((L21.b.stat & 0x0F) != 0)
		return;		//means that one or more of bits 0-3 is 1 (high)
	if ((L21.b.stat & 0x80) == 0)
		return;		//means that data block NOT valid (ie bit7=0)

	//===== Set current field ident.
	if ((L21.b.stat & 0x40) != 0)
		m_field = ODD;		//means that data block is from odd field (field 1)
	else m_field = NOT_ODD;
	//=====
	//Now, process the vaild bytes
	//Byte one will be the only one that contains a control VALUE, so check it
	//	and then see what comes next (char or conttol code specifier)
	bTemp = (L21.b.one & 0xF0);	//mask out low nibble

	switch (bTemp)
	{
		case 0x00:	//00-0F
			if (m_field)
			{
				m_Control1F1 = 0x00;
				m_Control2F1 = 0x00;
			}
			else
			{
				m_Control1F2 = 0x00;
				m_Control2F2 = 0x00;
			}
			StuffChar(L21.b.two);	//if first control code is 0-F, then second treated normally
			break;	//do nothing, return

		case 0x10:	//10-1F
			CheckControl(L21.b.one, L21.b.two);
			break;

		default:	//20-7F
			if (m_field)
			{
				m_Control1F1 = 0x00;
				m_Control2F1 = 0x00;
			}
			else
			{
				m_Control1F2 = 0x00;
				m_Control2F2 = 0x00;
			}
			dwtemp = dw;
			StuffChar(L21.b.one);
			StuffChar(L21.b.two);
	}

	/*
	//test
	BYTE b;
	for (b = 0x30; b < 0x40; b++)
		Insert(m_CurrentChannelF1, MapSpecialChar(b));	
	m_field = TRUE;
	for (b = 0x20; b < 0x80; b++)
		StuffChar(b);	
	MessageBeep(0xFFFFFFFF);
	Sleep(3000);
	*/
}

//===============================================================
// This function works for most all fonts except the terminal font.
// NOTE: The masking out of bit 7 (parity bit) has been done PRIOR to entry
//===============================================================
void CL21RdrView::StuffChar(BYTE bChar)
{
	BYTE bStuff;

	if (bChar < 0x20)	//stops bad/null "char" data from being saved
		return;

	switch (bChar)
	//switch (bStuff)
	{
		//remap several of the bytes here to get correct char for font used
		case 0x2A:	
			bStuff = 0xE1;
			break;
		case 0x5C:		//
			bStuff = 0xE9;
			break;
		case 0x5E:		//
			bStuff = 0xED;
			break;
		case 0x5F:		//
			bStuff = 0xF3;
			break;
		case 0x60:		//
			bStuff = 0xFA;
			break;
		case 0x7B:		//
			bStuff = 0xE7;
			break;
		case 0x7C:		//
			bStuff = 0xF7;
			break;
		case 0x7D:		//
			bStuff = 0xD1;
			break;
		case 0x7E:		//
			bStuff = 0xF1;
			break;
		case 0x7F:		//Solid Block --> space
			bStuff = ' ';	//
			break;
		default:	//all other data
			bStuff = bChar;
	}

	// Now stuff the character into correct string!
	if (m_field)	// if odd
	{
		m_iStuff++;
		//Insert(F1_C1, bStuff);	//This line is for debugging
		Insert(m_CurrentChannelF1, bStuff);	
	}
	else 
	{
		m_iStuff++;
		//Insert(F2_C1, bStuff);	//This line is for debugging
		Insert(m_CurrentChannelF2, bStuff);
		//Insert(m_CurrentChannelF2, CR_EOL);

	}

}

//===============================================================
void CL21RdrView::CheckControl(BYTE bOne, BYTE bTwo)
{
	//BOOL	bRepeated;		
	int		iTabOffset;
	int		iRow, iIndent;			//for use with 1x/5x & 1x/7x => bOne/bTwo
	BOOL	gotRowIndent = FALSE;	//for use with 1x/5x & 1x/7x => bOne/bTwo
	BOOL	bNoChange = TRUE;		
	BOOL	bDoingText;		
	BYTE	bStuff = 0;
	BYTE	MSNibble;
	BOOL	NewLine = FALSE;
	//Is this the same as received last time?
	if (m_field)
	{
		if ((m_Control1F1 == bOne) &&  (m_Control2F1 == bTwo))
		{
			iControlsecond++; //iControlfirst++;
			m_Control1F1 = 0x00;
			m_Control2F1 = 0x00;
			//bRepeated = TRUE;
			if (bOne & 0x08)	//bit 3 is set for channel 2
			{
				m_channel1 = FALSE;
				ic2f1++;
			}
			else 
			{
				m_channel1 = TRUE;
				ic1f1++;
			}
		}
		else	//first of repeated pair
		{
			iControlfirst++;
			m_Control1F1 = bOne;
			m_Control2F1 = bTwo;
			//bRepeated = FALSE;
			return;
		}
	}
	else
	{
		if ((m_Control1F2 == bOne) &&  (m_Control2F2 == bTwo))
		{
			m_Control1F2 = 0x00;
			m_Control2F2 = 0x00;
			//bRepeated = TRUE;
			if (bOne & 0x08)	//bit 3 is set for channel 2
				m_channel1 = FALSE;
			else m_channel1 = TRUE;
		}
		else	//first of repeated pair
		{
			m_Control1F2 = bOne;
			m_Control2F2 = bTwo;
			//bRepeated = FALSE;
			return;
		}
	}

	//We now know the field and channel, but we are NOT sure
	//what this code does! process more

	MSNibble = (bTwo & 0xF0);	//Save only most significat nibble
	switch (bOne)
	{
		case 0x11:		//2nd of 3x is special Char
		case 0x19:
			//if ((bTwo & 0xF0) == 0x30)	//if 3x
			if (MSNibble == 0x30)	//if 3x
				bStuff = MapSpecialChar(bTwo); //This char is printed at end of this function

			// could be 4x-7x "PAC" 4x&6x are COLOR, 5x&7x are INDENTS
			else if (MSNibble == 0x50)	
			{
				//caculate row/indent	iRow, iIndent, gotRowIndent
				iRow = 1;
				iIndent = (int)((bTwo & 0x0E) * 2);
				gotRowIndent = TRUE;

			}
			else if (MSNibble == 0x70) 	
			{
				//caculate row/indent	iRow, iIndent, gotRowIndent
				iRow = 2;
				iIndent = (int)((bTwo & 0x0E) * 2);
				gotRowIndent = TRUE;

			}
			break;

//=======>> Work on this HERE HERE
		case 0x14:		//2nd of 2x is Misc Control code
		case 0x1C:
			switch (MSNibble)
			{
				case 0x20:
					switch (bTwo)
					{
						case 0x2F:	//End of caption (flip memories)
							NewLine = TRUE;	//StartNewLine()
						case 0x20:	//resume caption loading
						case 0x29:	//Resume direct captioning
						
						case 0x25:	//??roll-up2
						case 0x26:	//??roll-up3
						case 0x27:	//??roll-up4
						case 0x28:	//??Flash On
							bNoChange = FALSE;
							bDoingText = FALSE;
							break;

						case 0x2A:		//Text restart
						case 0x2B:		//resume text display
							bNoChange = FALSE;
							bDoingText = TRUE;
							break;

						// These next ones will all fall through with no
						// change in text/cc mode
						case 0x2D:		//carriage return
							NewLine = TRUE;	//StartNewLine()
							//
						case 0x2C:		//Erase displayed memory
						case 0x2E:		//Erase Non-displayed memory
						case 0x21:	//Backspace
						case 0x22:	//RES.
						case 0x23:	//RES.
						case 0x24:	//Delete to end of Row
							//bNoChange = TRUE;	//USE PRIOR TEXT/CC VALUE
							break;

						default:
							bNoChange = TRUE;	//USE PRIOR TEXT/CC VALUE
							break;
					}
					
				case 0x40:
				case 0x60:
					break;
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 14;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 15;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;

				default:
					break;
			}
			


			break;

		case 0x17:		//Tab offsets 1/2/3 colums
		case 0x1F:
			switch (MSNibble)
			{
				case 0x20:
					iTabOffset = 0;
						//put code here to handle the TabOffset
					switch (bTwo)
					{
						case 0x23:	//
							iTabOffset++;
						case 0x22:	//
							iTabOffset++;
						case 0x21:	//
							iTabOffset++;
							bStuff = ' ';	//Add a "space" instead of tabs for "saving"
						default:
							break;
					}
					break;
					
				case 0x40:
				case 0x60:
					break;
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 9;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 10;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;

				default:
					break;
			}
			
			break;

		case 0x12:		
		case 0x1A:
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 3;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 4;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x15:		
		case 0x1D:
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 5;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 6;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x16:		
		case 0x1E:
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 7;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 8;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x10:		
		case 0x18:
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 11;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x13:		
		case 0x1B:
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 12;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 13;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;


		default:
			break;
		
					//The other 0x1x values can all be default because all 
					//they do is position/color/underline...
					//default:	//all other data
	}

	//Now set the current channel info
//bDoingText
//bNoChange
	/////////////////////////////////////////////
	if (m_field)	//field 1 -- odd is usual cc
	{
		if (m_channel1)
		{
			if (!bNoChange)
				m_DoingText1 = bDoingText;

			if (!m_DoingText1)
				m_CurrentChannelF1 = F1_C1;
			else m_CurrentChannelF1 = F1_T1;
		}
		else
		{		
			if (!bNoChange)
				m_DoingText2 = bDoingText;

			if (!m_DoingText2)
				m_CurrentChannelF1 = F1_C2;
			else m_CurrentChannelF1 = F1_T2;
		}
	}
	/////////////////////////////////////////////
	else	//field 2
	{
		if (m_channel1)
		{
			if (!bNoChange)
				m_DoingText3 = bDoingText;

			if (!m_DoingText3)
				m_CurrentChannelF2 = F2_C1;
			else m_CurrentChannelF2 = F2_T1;
		}
		else
		{
			if (!bNoChange)
				m_DoingText4 = bDoingText;

			if (!m_DoingText4)
				m_CurrentChannelF2 = F2_C2;
			else m_CurrentChannelF2 = F2_T2;
		}
	}
	//////////////////////////////////////////////

	if (gotRowIndent)
	{
		if (m_field)	// if odd
		{
			if (CompareRow(m_CurrentChannelF1, iRow, iIndent))
				NewLine = TRUE;
			else if (CompareIdent(m_CurrentChannelF1, iIndent))
				bStuff = ' ';	//Add a "space" 
		}
		else 
		{
			if (CompareRow(m_CurrentChannelF2, iRow, iIndent))
				NewLine = TRUE;
			else if (CompareIdent(m_CurrentChannelF2, iIndent))
				bStuff = ' ';	//Add a "space" 
		}
	}

	if (NewLine)
		StartNewLine();	//(end of string) save and get new
	else if (bStuff != 0)	// if value was mapped, STUFF IT!
	{

		// Now stuff the character into correct string!
		if (m_field)	// if odd
		{
			m_iStuff++;
			Insert(m_CurrentChannelF1, bStuff);	
		}
		else 
		{
			m_iStuff++;
			Insert(m_CurrentChannelF2, bStuff);
		}
	}
	else if (gotRowIndent)

	return;	//we have nothing else
}

//===============================================================

BYTE CL21RdrView::MapSpecialChar(BYTE b)
{
	switch (b)
	{
		case 0x30:		//registered trakemark
			return 0xAE;
		case 0x31:		//degree sign
			return 0xB0;
		case 0x32:		//  1/2
			return 0xBD;
		case 0x33:		//Inverse query
			return 0x20; // ?? so use space??
		case 0x34:		// trademark TM
			return 0x99;
		case 0x35:		// cents sign
			return 0xA2;
		case 0x36:		// pound sterling sign
			return 0xA3;
		case 0x37:		// music note
			return 0xB6; // This character is NOT correct, but is one available in most fonts!
		case 0x38:		// lcase a-w/grave accent
			return 0xE0;
		case 0x39:		// transparent space
			return 0x20; //just use space
		case 0x3A:		// lcase e-w/grave accent
			return 0xE8;
		case 0x3B:		//lcase a-w/circumflex
			return 0xE2;
		case 0x3C:		//lcase e-w/circumflex
			return 0xEA;
		case 0x3D:		//lcase i-w/circumflex
			return 0xEE;
		case 0x3E:		//lcase o-w/circumflex
			return 0xF4;
		case 0x3F:		//lcase u-w/circumflex
			return 0xFB;
		default:
			return 0;
	}
}

//===============================================================
//===============================================================

BOOL CL21RdrView::Poll_And_Process_Test()
{
	//called from OnTimer
	int iCnt;

	if (m_StartingNewLine)
	{
		m_StartingNewLine = FALSE;	//keep from starting a new line
									//till get newline char

		//=========================
		m_pLineCurrentC1 = new CString();
		//+
		//-GetDocument()->NewLine(m_pLineCurrentC1, F1_C1);
		DoCRLF(F1_C1);
		iCnt = AecPciBrd.AscTB(m_charStr);	// read current time code
		InsertTime(F1_C1);
		Insert(F1_C1, TAB);
		m_bOutTimeF1C1 = FALSE;
		m_outTime = m_indexF1C1;
		//============================

		m_updateNeeded = TRUE;
		if ( m_lastFF != m_charStr[10] )
		{
			//MessageBeep(0xFFFFFFFF);
			m_lastFF = m_charStr[10];
		}
	}
	else
	{

		//iCnt = AEC_PCTC_READ_ASC_TB (m_charStr, &B_Addr);
		iCnt = AecPciBrd.AscTB(m_charStr);
		m_updateNeeded = TRUE;
		if ( m_lastFF != m_charStr[10] )
		{
			//MessageBeep(0xFFFFFFFF);
			m_lastFF = m_charStr[10];

			if (m_loopCnt == 0x00)
			{
				m_loopCnt++;
				//Insert(F1_C1, TAB);
				//m_outTime = m_indexF1C1;
				Insert(F1_C1, 'A');
			}
			else
			{
				char c = (0x41 + (BYTE)m_loopCnt);
				m_loopCnt++;
				Insert(F1_C1, c);
				if (c >= 'z')
				{
					InsertTimeOut(F1_C1);
					m_updateNeeded = TRUE;
					m_StartingNewLine = TRUE;
					GetDocument()->NewLine(m_pLineCurrentC1, F1_C1);
					InvalidateRect(NULL, TRUE);
					m_loopCnt = 0;
				}
			}
		}
	}
	return FALSE;	
}



//===============================================================
//===============================================================
//===============================================================



void CL21RdrView::StartNewLine()
{
	if (m_field)	// if odd
		Insert(m_CurrentChannelF1, CR_EOL);	
	else 
		Insert(m_CurrentChannelF2, CR_EOL);
}


BOOL CL21RdrView::CompareRow(UINT ct, int r, int i)	
{

	BOOL bNew = FALSE;
	switch (ct)
	{
		case F1_C1:
			if (m_RowF1C1 != r)
			{
				m_RowF1C1 = r;
				m_indentF1C1 = i;
				bNew = TRUE;
			}
			break;
		case F1_C2:
			if (m_RowF1C2 != r)
			{
				m_RowF1C2 = r;
				m_indentF1C2 = i;
				bNew = TRUE;
			}
			break;
		case F2_C1:
			if (m_RowF2C1 != r)
			{
				m_RowF2C1 = r;
				m_indentF2C1 = i;
				bNew = TRUE;
			}
			break;
		case F2_C2:
			if (m_RowF2C2 != r)
			{
				m_RowF2C2 = r;
				m_indentF2C2 = i;
				bNew = TRUE;
			}
			break;
		case F1_T1:
			if (m_RowF1T1 != r)
			{
				m_RowF1T1 = r;
				m_indentF1T1 = i;
				bNew = TRUE;
			}
			break;
		case F1_T2:
			if (m_RowF1T2 != r)
			{
				m_RowF1T2 = r;
				m_indentF1T2 = i;
				bNew = TRUE;
			}
			break;
		case F2_T1:
			if (m_RowF2T1 != r)
			{
				m_RowF2T1 = r;
				m_indentF2T1 = i;
				bNew = TRUE;
			}
			break;
		case F2_T2:
			if (m_RowF2T2 != r)
			{
				m_RowF2T2 = r;
				m_indentF2T2 = i;
				bNew = TRUE;
			}
			break;
		default:	//CHAN_NONE
			
			break;
	}
	return bNew;

}

BOOL CL21RdrView::CompareIdent(UINT ct, int i)
{

	BOOL bDoSP = FALSE;
	switch (ct)
	{
		case F1_C1:
			if (m_indentF1C1 < i)
				bDoSP = TRUE;
			m_indentF1C1 = i;
			break;
		case F1_C2:
			if (m_indentF1C2 < i)
				bDoSP = TRUE;
			m_indentF1C2 = i;
			break;
		case F2_C1:
			if (m_indentF2C1 < i)
				bDoSP = TRUE;
			m_indentF2C1 = i;
			break;
		case F2_C2:
			if (m_indentF2C2 < i)
				bDoSP = TRUE;
			m_indentF2C2 = i;
			break;
		case F1_T1:
			if (m_indentF1T1 < i)
				bDoSP = TRUE;
			m_indentF1T1 = i;
			break;
		case F1_T2:
			if (m_indentF1T2 < i)
				bDoSP = TRUE;
			m_indentF1T2 = i;
			break;
		case F2_T1:
			if (m_indentF2T1 < i)
				bDoSP = TRUE;
			m_indentF2T1 = i;
			break;
		case F2_T2:
			if (m_indentF2T2 < i)
				bDoSP = TRUE;
			m_indentF2T2 = i;
			break;
		default:	//CHAN_NONE			
			break;
	}
	return bDoSP;

}

