// L21RdrView.h : interface of the CL21RdrView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_L21RDRVIEW_H__DA1A1625_EB07_4139_BEEE_FDEE30A4A478__INCLUDED_)
#define AFX_L21RDRVIEW_H__DA1A1625_EB07_4139_BEEE_FDEE30A4A478__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	BELL	0x07
#define CR		0x0D
#define	LF		0x0A
#define NUL		0x00
#define EOL		0x00
#define CR_EOL	0x01
#define TAB		0x09
#define ODD		TRUE
#define NOT_ODD	FALSE

#define CHAN_NONE	0
#define F1_C1		1
#define F1_T1		2
#define F1_C2		3
#define F1_T2		4
#define F2_C1		5
#define F2_T1		6
#define F2_C2		7
#define F2_T2		8
#define CHAN_ALL	9


class CL21RdrView : public CView
{
protected: // create from serialization only
	CL21RdrView();
	DECLARE_DYNCREATE(CL21RdrView)

// Attributes
public:
	CL21RdrDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CL21RdrView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CL21RdrView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CL21RdrView)
	afx_msg void OnLine21stop();
	afx_msg void OnLine21startstop();
	afx_msg void OnLine21start();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnC1();
	afx_msg void OnC2();
	afx_msg void OnC3();
	afx_msg void OnC4();
	afx_msg void OnT1();
	afx_msg void OnT2();
	afx_msg void OnT3();
	afx_msg void OnT4();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL CompareIdent(UINT ct, int i);
	BOOL CompareRow(UINT ct, int r, int i);
	void StartNewLine();
	//void InsertCRLF(UINT ui);
	BYTE m_SigStat;
	int ic1f1;
	int ic2f1;
	int iControlsecond;
	int iControlfirst;
	int iVid;
	int iCC;
	int iPoll_Loops;
	int m_iStuff;
	int m_iReadsInARow;
	int iRdr;
	BYTE MapSpecialChar(BYTE b);
	BOOL m_channel1;
	BOOL m_DoingText4;
	BOOL m_DoingText3;
	BOOL m_DoingText2;
	BOOL m_DoingText1;
	BYTE m_Control1F1;
	BYTE m_Control1F2;
	void StuffChar(BYTE bChar);
	void CheckControl(BYTE bOne, BYTE bTwo);
	BOOL m_field;
	void ProcessCC(DWORD dw);
	BOOL Poll_And_Process_Test();
	BOOL Poll_And_Process();
	void DoCRLF(UINT ui);
	void Insert(UINT ui, char* str);
	void Insert(UINT ChanFCT, char s);
	void InsertTimeOut(UINT CurrentCCTxt);
	char m_charStr[12];			//holds the last time code reader value
	void InsertTime(UINT CurrentCCTxt);
	void UpdateCxTxStatus();
	int m_CurrentChannelF1;		//hold the current CC data channel OF Field 1 (C1, C2, T1, T2, none)
	int m_CurrentChannelF2;		//hold the current CC data channel OF Field 2 (C1, C2, T1, T2, none)
	BYTE m_CurrentChannelView;	//hold the current CC data channel being viewed (1-4)
	void InsertDateTime();
	SYSTEMTIME datetime;
	int m_outTime;
	int m_loopCnt;
	BOOL m_firstCatch;
	LONG m_tmHigh;
	int m_lineNum;
	BOOL m_firstView;
	char m_lastFF;
	BOOL m_updateNeeded;
	char lastFF;
	BOOL m_StartingNewLine;
	BOOL m_ReaderCaptureOn;

	int		m_indexF1C1; 
	int		m_indexF1C2;
	int		m_indexF1T1;
	int		m_indexF1T2;
	int		m_indexF2C1; 
	int		m_indexF2C2;
	int		m_indexF2T1;
	int		m_indexF2T2;

	int		m_RowF1C1; 
	int		m_RowF1C2;
	int		m_RowF1T1;
	int		m_RowF1T2;
	int		m_RowF2C1; 
	int		m_RowF2C2;
	int		m_RowF2T1;
	int		m_RowF2T2;

	int		m_indentF1C1; 
	int		m_indentF1C2;
	int		m_indentF1T1;
	int		m_indentF1T2;
	int		m_indentF2C1; 
	int		m_indentF2C2;
	int		m_indentF2T1;
	int		m_indentF2T2;


	BOOL m_bOutTimeF1C1;
	BOOL m_bOutTimeF1C2;
	BOOL m_bOutTimeF2C1;
	BOOL m_bOutTimeF2C2;
	BOOL m_bOutTimeF1T1;
	BOOL m_bOutTimeF1T2;
	BOOL m_bOutTimeF2T1;
	BOOL m_bOutTimeF2T2;
public:
	BYTE m_Control2F1;
	BYTE m_Control2F2;


protected:
	CString*	m_pLineCurrentC1;
	CString*	m_pLineCurrentC2;
	CString*	m_pLineCurrentC3;
	CString*	m_pLineCurrentC4;

	CString*	m_pLineCurrentT1;
	CString*	m_pLineCurrentT2;
	CString*	m_pLineCurrentT3;
	CString*	m_pLineCurrentT4;

};

#ifndef _DEBUG  // debug version in L21RdrView.cpp
inline CL21RdrDoc* CL21RdrView::GetDocument()
   { return (CL21RdrDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_L21RDRVIEW_H__DA1A1625_EB07_4139_BEEE_FDEE30A4A478__INCLUDED_)
