// Read time code from an AEC PCI time code reader board
// 3/2000


#include <windows.h>
#include <stdio.h>

#include <conio.h>	//for getch
#include <ctype.h>	//for getch		

#include <stdlib.h>
#include <winioctl.h>
#include "AECioctl.h"        // This defines the IOCTL constants.

#define     PCI_DEVICE_NAME     "AecPci"


typedef struct _USER_PARMS {
    LONG        LoopCount;
    USHORT      Flags;
    UCHAR       DeviceNumber[MAX_PATH];
} USER_PARMS, *PUSER_PARMS;


/*
typedef struct  _GENPORT_WRITE_INPUT {
    ULONG   PortNumber;     // Port # to write to
    union   {               // Data to be output to port
        ULONG   LongData;
        USHORT  ShortData;
        UCHAR   CharData;
    };
}   GENPORT_WRITE_INPUT;
*/


BOOL	DoReadWriteAction(HANDLE, enum AECPCI_ACTION_ITEM, ULONG, PULONG, PULONG);
char*	DWStrTm(ULONG, char*);
void	WaitForKbrd(char);


void __cdecl main(int argc, char ** argv)
{


	ULONG data4, len, portaddress;
	ULONG data4In, portaddressIn;
	enum AECPCI_ACTION_ITEM inputAction;

    // The following is returned by IOCTL.  It is true if the read succeeds.
    BOOL    IoctlResult;

    // The following parameters are used in the IOCTL call
    HANDLE  hndFile;            // Handle to device, obtain from CreateFile
    GENPORT_WRITE_INPUT InputBuffer;    // Input buffer for DeviceIoControl (PORTulong / LSCunion) (READ/WRITE)
    //ULONG   PortNumber;         // Buffer sent to the driver (Port #). (READ)
    union   {
        ULONG   LongData;
        USHORT  ShortData;
        UCHAR   CharData;
    }   DataBufferOut;             // Buffer received from driver (Data).
    LONG    IoctlCode;
    ULONG   DataLength, DataLengthIn, DataLengthOut, DataValue;
    //DWORD   ReturnedLength;     // Number of bytes returned
    ULONG   ReturnedLength;     // Number of bytes returned
    DWORD	errorCode;    

    UCHAR	deviceName[MAX_PATH];
	UCHAR	iCode;
	int		count, count2;

    USER_PARMS  userParms;

	char	str11[24];
	char	str24[24];
	char	ch;


	//char currentDirectory[128];
	//GetCurrentDirectory (128, currentDirectory);
    
    ZeroMemory(&userParms, sizeof(USER_PARMS));

//============	
    if ( argc < 3 || argv[1][0] != '-' )	//||
         //( argv[1][1] != 'b' && argv[1][1] != 'w' && argv[1][1] != 'd' ) )		 
    {
        //printf("TC_rdwr -b|-w|-d Port#  A byte (-b), word (-w), or a double\n");
		printf("Command line error. Should use format:\n");
        printf("   %s -R1|-R2|-R4|-W1|-W2|-W4|-CMD Port#  Data# \n", argv[0]);
        printf("   Where R is READ, W is Write,\n");
        printf("   1,2,4 BYTES to/from register at offset port (board relative)\n");
        printf("   (or Port# = command) and data to be written (if W).\n");
	//printf("ARGC = %x\n", argc);
        exit(1);
    }
//=============

    strcpy(deviceName, "\\\\.\\");
    strcat(deviceName, PCI_DEVICE_NAME);	//
   strcat(deviceName, "0");	//to be defined... This value will open Device"0"

    //printf("Testing device:  (wait 2 sec)\n");
    Sleep(2000);	//wait for 2 seconds
    printf("CreatFile: %s \n", deviceName);


    hndFile = CreateFile(
                deviceName,	//  " \\\\.\\AecPci ",       // Open the Device "file"
                GENERIC_READ | GENERIC_WRITE,
                FILE_SHARE_READ | FILE_SHARE_WRITE,	//NULL (do not share if COM device)
                NULL,
                OPEN_EXISTING,
                0,		//FILE_FLAG_OVERLAPPED, ????????
                NULL
                );
                
    if (hndFile == INVALID_HANDLE_VALUE)        // Was the device opened?
    {
        printf("Unable to open the device.\n");
        exit(1);
    }
    printf("CreateFile OK \n");

//=============
    // The input buffer is a ULONG containing the port address.  It is
    // specified as 0, 1, 2, ... relative to the base address set in tc_rdwr.h
    // or overridden by the registry.

    // The port data is returned in the output buffer DataBufferOut;
//=============


	inputAction = Read4;		//default

	if ( _stricmp( "R1", argv[1]+1 ) == 0 ) 
		inputAction = Read1; 
	if ( _stricmp( "R2", argv[1]+1 ) == 0 ) 
		inputAction = Read2; 
	if ( _stricmp( "R4", argv[1]+1 ) == 0 ) 
		inputAction = Read4; 

	if ( _stricmp( "W1", argv[1]+1 ) == 0 ) 
		inputAction = Write1; 
	if ( _stricmp( "W2", argv[1]+1 ) == 0 ) 
		inputAction = Write2; 
	if ( _stricmp( "W4", argv[1]+1 ) == 0 ) 
		inputAction = Write4; 

	if ( _stricmp( "CMD", argv[1]+1 ) == 0 ) 
		inputAction = SND_CMD; 

	if ( _stricmp( "RTM", argv[1]+1 ) == 0 ) 
		inputAction = RTM; 
	if ( _stricmp( "RUB", argv[1]+1 ) == 0 ) 
		inputAction = RUB; 
	if ( _stricmp( "REB", argv[1]+1 ) == 0 ) 
		inputAction = REB; 



//	GET_INT,		//get int code			0 (don't care?)		intcode(in) UCHAR
//	RTM,			//  input long			0 (don't care?)		data (out)
//					//Read the TIME bits at offset 10h (transition tolerent) DWORD
//	RUB,			//  input long			0 (don't care?)		data (out)
//					//Read the USER bits at offset 14h (transition tolerent) DWORD
//	REB,			//  input byte			0 (don't care?)		data (out)
//					//Read the EMBEDDED bits at offset 18h (transition tolerent) UCHAR
//	NextInt,		//  output byte			0 (don't care)		data (out)
//					//Queue an IRP for the ISR/DPC to complete


	sscanf(argv[2], "%x", &portaddressIn);
	portaddressIn = portaddressIn & 0x000000FF;		//allow access to the board ports only
	data4In = 0x00000000;
	if	(argc > 3) 
	{	//get data to write
		sscanf(argv[3], "%x", &data4In);
	} 

/*++
	//printf("TODO - action %x, port %x, data %x\n", inputAction, portaddressIn, data4In);
	//portaddress = 0x000000FE;
	//data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, inputAction, portaddressIn, &data4In, &len);
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("IntFlags %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
	--*/
//============	
/*++
// --------> insert AEC Read/Writes below Here
//Read4 from 0x00 offset (should get 6250AECBh)
//	
	InputBuffer.PortNumber = 0x00000000;	//set the offset to read from
	IoctlCode = IOCTL_AEC_READ_PORT_ULONG;	//READ dword (4bytes)
	InputBuffer.LongData = 0x00000000;
	DataLengthOut = sizeof(DataBufferOut.LongData);
	DataLengthIn = sizeof(InputBuffer.PortNumber) + DataLengthOut;
	//DataLengthIn = sizeof(InputBuffer.PortNumber) + sizeof(InputBuffer.LongData);

      IoctlResult = DeviceIoControl(		//
                            hndFile,            //1 Handle to device
                            IoctlCode,          //2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
							&InputBuffer,	//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
							DataLengthIn,		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                            &DataBufferOut,        //5++++ Buffer from driver.
								//size of output buffer
                            DataLengthOut,         //6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
							&ReturnedLength,    //7 Bytes placed in DataBufferOut. (store # upon return)
                            NULL		//8 NULL means wait till op. completes.
                            );


// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        ULONG   Data;
        if (ReturnedLength != DataLengthOut)
        {
            printf(
                "Ioctl transfered %d bytes, expected %d bytes\n",
                ReturnedLength, DataLengthOut );
        }        
        switch (ReturnedLength)
        {
            case sizeof(UCHAR):
                Data = DataBufferOut.CharData;
                break;                
            case sizeof(USHORT):
                Data = DataBufferOut.ShortData;
                break;    
            case sizeof(ULONG):
                Data = DataBufferOut.LongData;
                break;
        }        
        printf("Read from port %x returned %x\n", InputBuffer.PortNumber, Data);
    }
    else
    {

        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
// <------- READ output
--*/
//----------------------------------------------------------------------------------------
//Read1 from 0xFE (interrupt pending flags)
	portaddress = 0x000000FE;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("IntFlags %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
	/*++
//Write1 to 0x2E	//INT FLAG ENABLES	
	portaddress = 0x0000002E;
	data4 = 0x01;
	IoctlResult = DoReadWriteAction(hndFile, Write1, portaddress, &data4, &len);
// WRITE output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Wrote to port %x --> %x\n", portaddress, data4);
    }
    else
    {
        printf("W1 Ioctl failed with code %ld\n", GetLastError() );
    }

--*/
//----------------------------------------------------------------------------------------
/*++
//SND_CMD to 0x2F - data=0x21 (reader mode)
	portaddress = 0x00000021;
	data4 = 0x01;
	IoctlResult = DoReadWriteAction(hndFile, SND_CMD, portaddress, &data4, &len);
// WRITE output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("CMD %x returned with %x\n", portaddress, data4);
    }
    else
    {
        printf("CMD Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
//Read1 from 0x0D (Board operating mode)
	portaddress = 0x0000000D;	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Board Mode (from 0Dh) = %x \n", data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
    /*++
//Read1 from 0x0F (command response)
	portaddress = 0x0000000F;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
    --*/
//----------------------------------------------------------------------------------------
    /*++
//Read1 from 0xFE (interrupt pending flags)
	portaddress = 0x000000FE;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("IntFlags %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
	//printf("TODO - action %x, port %x, data %x\n", inputAction, portaddressIn, data4In);
	//portaddress = 0x00000000;
	//data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, inputAction, portaddressIn, &data4In, &len);
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("DoReadWriteAction - port %x, data %x\n", portaddressIn, data4In);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Read1 from 0x0D (Board operating mode)
	portaddress = 0x0000000D;	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Board Mode = %x \n", data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
    /*++
//Read1 from 0xFE (interrupt pending flags)
	portaddress = 0x000000FE;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("IntFlags %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
    --*/
//----------------------------------------------------------------------------------------
    /*++
//Read1 from 0x0F (command response)
	portaddress = 0x0000000F;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
    --*/
//----------------------------------------------------------------------------------------
//Read1 from 0xFE (interrupt pending flags)
	portaddress = 0x000000FE;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("IntFlags %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
    /*++
//Read1 from 0x0D (Board operating mode)
	portaddress = 0x0000000D;	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Board Mode = %x \n", data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/

//----------------------------------------------------------------------------------------
/*++
//Read4 from 0x10	//TIME data
	portaddress = 0x00000010;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
//	Sleep(1000);
//----------------------------------------------------------------------------------------
/*++
//Read1 from 0xFE (interrupt pending flags)
	portaddress = 0x000000FE;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
/*++
//Read1 from 0x0F (command response)
	portaddress = 0x0000000F;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
/*++
//Read1 from 0xFE (interrupt pending flags)
	portaddress = 0x000000FE;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
/*++
//Read1 from 0x0F (command response)
	portaddress = 0x0000000F;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
--*/
//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

//Read4 from 0x10	//TIME data
	portaddress = 0x00000010;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Port %x - TIME = %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }

//----------------------------------------------------------------------------------------

//Read4 from 0x14	//USER data
	portaddress = 0x00000014;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Port %x - USER = %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
    /*++
//Read4 from 0x00				//This passes a copy of the configuration regs
	portaddress = 0x00000000;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Read2 from 0x00	
	portaddress = 0x00000000;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read2, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Read1 from 0x00	
	portaddress = 0x00000000;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Write4 to 0x	
	portaddress = 0x00000030;
	data4 = 0x23593015;
	IoctlResult = DoReadWriteAction(hndFile, Write4, portaddress, &data4, &len);
// WRITE output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Wrote to port %x --> %x\n", portaddress, data4);
    }
    else
    {
        printf("W4 Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Read4 from 0x30	
	portaddress = 0x00000030;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Write2 to 0x	
	portaddress = 0x00000034;
	data4 = 0x00003123;
	IoctlResult = DoReadWriteAction(hndFile, Write2, portaddress, &data4, &len);
// WRITE output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Wrote to port %x --> %x\n", portaddress, data4);
    }
    else
    {
        printf("W2 Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Read2 from 0x00	
	portaddress = 0x00000034;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read2, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
//----------------------------------------------------------------------------------------
//Read1 from 0x00	
	portaddress = 0x0000002E;
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Read from port %x returned %x\n", portaddress, data4);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
// <------- READ output//----------------------------------------------------------------------------------------

// <-------- insert AEC Read/Writes above Here
--*/

	SetPriorityClass ( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );




	_cputs( "\n\tType 'X' to exit: \n\n\a " );	// the '\a' is the 'beep'

	count = 0;
	count2 = 0;
	ch = 'a';
//------------------------- BEGIN POLLING LOOP -----------------------------
//*++	//comment out from here to "END POLLING LOOP and add the "ISR LOOP" 
		// code into the source (to use ISR LOOP)

//Write1 to 0x2E	//INT FLAG ENABLES	
	portaddress = 0x0000002E;
	data4 = 0x01;
	IoctlResult = DoReadWriteAction(hndFile, Write1, portaddress, &data4, &len);
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Wrote to port %x --> %x\n", portaddress, data4);
    }
    else
    {
        printf("W1 Ioctl failed with code %ld\n", GetLastError() );
    }

	
	portaddress = 0x0000002F;	//Write1 to 0x2F	//ENABLE NEXT (if needed)
	data4 = 0x00;
	IoctlResult = DoReadWriteAction(hndFile, Write1, portaddress, &data4, &len);
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("Wrote to port %x --> %x\n", portaddress, data4);
    }
    else
    {
        printf("W1 Ioctl failed with code %ld\n", GetLastError() );
    }


	do	//GET_INT
	{

				//Read4 from 0x10	//TIME data	-	RTM, RUB, REB
		portaddress = 0x00000010;
		data4 = 0x00000000;
		IoctlResult = DoReadWriteAction(hndFile, GET_INT, portaddress, &data4, &len);
		// READ output---->
		if (IoctlResult)                            // Did the IOCTL succeed?
		{
			iCode = (UCHAR)data4;
			if (iCode == 0x13)
			{
				count++;
				//Read4 from 0x10	//TIME data	-	RTM, RUB, REB
				portaddress = 0x00000010;
				data4 = 0x00000000;
				//IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
				IoctlResult = DoReadWriteAction(hndFile, RTM, portaddress, &data4, &len);
				// READ output---->
				if (IoctlResult)                            // Did the IOCTL succeed?
				{
			        //printf("Port %x - RTM = %x\r", portaddress, data4);
					//*str24 = DWStrTm(data4, str11);
					DWStrTm(data4, str11);
					printf("RTM = %s   %d  \r", str11, count);
				}
				else
				{
					printf("Ioctl RTM failed with code %ld\r", GetLastError() );
				}
			}
		}
		else
		{
			printf("Ioctl GET_INT failed with code %ld\r", GetLastError() );
		}

		if ( _kbhit() )
		{
			ch = _getch();
			ch = toupper( ch );
		}
	} while( ch != 'X' ); //while( ch != 'Y' );

//--*/		//comment out to here from "BEGIN POLLING LOOP to use ISR LOOP
//------------------------- END POLLING LOOP -----------------------------


//------------------------- BEGIN ISR LOOP  SETUP ------------------------
/*++	//comment OUT from here to "END ISR LOOP" to NOT use ISR (use Polled)
	count = 0;
	count2 = 0;
	ch = 'a';

		
	portaddress = 0x0000002E;	//Write1 to 0x2E	
	data4 = 0x01;			//INT READER FLAG ENABLES
	IoctlResult = DoReadWriteAction(hndFile, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL succeed?
	{
	    printf("W1 01@2E Ioctl failed with code %ld\n", GetLastError() );
	}
	//WaitForKbrd('@');

	//cause a command response - no ISR/IRQ enable yet
	portaddress = 0x0000002F;	//Write1 to 0x2F	
	data4 = 0xFF;			//
	IoctlResult = DoReadWriteAction(hndFile, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL succeed?
	{
	    printf("W1 FF@2F Ioctl failed with code %ld\n", GetLastError() );
	}
	Sleep(10);		//put some delay here

	portaddress = 0x000000FE;	//Read1 from 0xFE	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
    if (!IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("R1 @FE Ioctl failed with code %ld\n", GetLastError() );
    }

	portaddress = 0x000000FC;	//Write4 to 0xFC	
	data4 = 0x00000010;			//IRQ ENABLE
	IoctlResult = DoReadWriteAction(hndFile, Write4, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL succeed?
	{
	    printf("W4 10@FC Ioctl failed with code %ld\n", GetLastError() );
	}

	
	portaddress = 0x000000FE;	//Read1 from 0xFE	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
// READ output---->
    if (!IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("R1 @FE Ioctl failed with code %ld\n", GetLastError() );
    }

//------------------------- BEGIN ISR LOOP -----------------------------
	//Main_LOOP
	do	//USES "NextInt"
	{				
		portaddress = 0x00000010;
		data4 = 0x00000000;
		//POLLED method
		IoctlResult = DoReadWriteAction(hndFile, GET_INT, portaddress, &data4, &len);

		//ISR QUEUED  method
		//IoctlResult = DoReadWriteAction(hndFile, NextInt, portaddress, &data4, &len);
		// READ output---->
		if (IoctlResult)                            // Did the IOCTL succeed?
		{
			iCode = (UCHAR)data4;
			if (iCode == 0x13)
			{
				count++;
				//Read4 from 0x10	//TIME data	-	RTM, RUB, REB
				portaddress = 0x00000010;
				data4 = 0x00000000;
				//IoctlResult = DoReadWriteAction(hndFile, Read4, portaddress, &data4, &len);
				IoctlResult = DoReadWriteAction(hndFile, RTM, portaddress, &data4, &len);
				// READ output---->
				if (IoctlResult)                            // Did the IOCTL succeed?
				{
			        //printf("Port %x - RTM = %x\r", portaddress, data4);
					//*str24 = DWStrTm(data4, str11);
					DWStrTm(data4, str11);
					if ((data4 & 0x0000FFFF) == 0x00000000)
					{
						count2 = count;
						count = 0;
					}
					//printf("RTM = %s   %4.4d %4.4d \r", str11, count, count2);
					printf("RTM = %s   %4.4d ", str11, count);
					if (count == 0)
						printf("%4.4d \r", count2);
					printf("\r");
				}
				else
				{
					printf("Ioctl RTM failed with code %ld\r", GetLastError() );
				}
			}
		}
		else
		{
			printf("Ioctl GET_INT failed with code %ld\r", GetLastError() );
		}

		if ( _kbhit() )
		{
			ch = _getch();
			ch = toupper( ch );
			count = 0;		//reset the count
		}
		
	} while( ch != 'X' ); //while( ch != 'Y' );

  --*/	//Comment OUT from BEGIN ISR LOOP SETUP to HERE for POLLED IO
//------------------------- END ISR LOOP -----------------------------



//------------------------- BEGIN GENERAL SHUTDOWN -----------------------------

	portaddress = 0x000000FC;	//Write4 to 0xFC	
	data4 = 0x00000000;			//MAKE SURE THAT IRQ IS DISABLED
	IoctlResult = DoReadWriteAction(hndFile, Write4, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL succeed?
	{
	    printf("\nW4 0@FC Ioctl failed with code %ld\n", GetLastError() );
	}
	//------------------------------------------------------------------
	portaddress = 0x000000FE;	//Read1 from 0xFE	
	data4 = 0x00000000;
	IoctlResult = DoReadWriteAction(hndFile, Read1, portaddress, &data4, &len);
    if (!IoctlResult)                            // Did the IOCTL succeed?
    {
        printf("\nR1 @FE Ioctl failed with code %ld\n", GetLastError() );
    }
//    else
//    {
//        printf("\nR1 %x@%x \n", data4, portaddress);
//    }

	//-------------------------------------------------------------------
	portaddress = 0x0000002E;	//Write1 to 0x2E	
	data4 = 0x00;			//DISABLE INT READER FLAG ENABLES on exit
	IoctlResult = DoReadWriteAction(hndFile, Write1, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL succeed?
	{
	    printf("\nW1 0@2E Ioctl failed with code %ld\n", GetLastError() );
	}

	//cause a command response - IRQ has been turned off
	portaddress = 0x0000002F;	//Write1 to 0x2F	
	data4 = 0xFF;			//
	IoctlResult = DoReadWriteAction(hndFile, SND_CMD, portaddress, &data4, &len);
	if (!IoctlResult)                            // Did the IOCTL succeed?
	{
	    printf("\nSND_CMD FF@2F Ioctl failed with code %ld\n", GetLastError() );
	}

	printf("\n\n");		//Line feed 

    if (!CloseHandle(hndFile))                  // Close the Device "file".
    {
        printf("Failed to close device.\n");
    }
        
	printf("Close device - OK.\n");

    exit(0);
}


//-----------------------------------------------------------

char* DWStrTm(ULONG dw, char *chs)
{
	wsprintf (chs,"%8.8X",dw);
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';

	return chs;
}

//-----------------------------------------------------------

void WaitForKbrd(char ch)
{
	char c;
	printf("Press any key to continue - %c \n", ch);
	do { } while (!_kbhit());
	do {
		c = _getch(); 
	} while (_kbhit());
	Sleep(300);
}
//------------------------------------------------------------

BOOL 
DoReadWriteAction(
				  IN HANDLE hOpen, 
				  IN enum AECPCI_ACTION_ITEM act, 
				  IN ULONG port,
				  IN OUT PULONG pdata,
				  IN PULONG pLB
				  )
{

	BOOL status;
		//enum AECPCI_ACTION	action;		// action to perform
		//ULONG					port;       // port address
		//ULONG					value;      // input or output data
	AECPCI_ACTION_ITEM		ai;			// *PAECPCI_ACTION_ITEM;
	//IOCTL_AECPCI_PROCESS_BUFFER
	ULONG   LengthBack;

	ai.action = act;
	ai.port = port;
	ai.value = *pdata;

	if (status = DeviceIoControl(		
                hOpen,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_BUFFER,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ai,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ai),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ai,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ai),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				pLB,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                )				
		)
	{
		*pdata = ai.value;
	}


/*++
    NOP_THING,         //  No operation		0                   0
    Read1,              //  input byte			offset				data (in)	
    Read2,              //  input word			offset				data (in)
    Read4,              //  input long			offset				data (in)
    Write1,             //  output byte			offset				data (out)
    Write2,             //  output word 		offset				data (out)
    Write4,             //  output long 		offset				data (out)

	R256=256,			//SPECIAL FOR READING ALL 256 BYTES (nt ONLY)
					//fixed offset write/read... operation
	SND_CMD,		//send command			command(out)		intcode(in)
					//read the NEXT INTCODE - fixed OFFSET read / enable next
	GET_INT			//get int code			0 (don't care?)		intcode(in)
  --*/
	return status;

}

//============================================================================
/*
//----------------------------------------------------------------------------------------
// FOR READS:
//	Choose IOCTLCODE
//	Set InputBuffer.PortNumber (address)
//	
// FOR WRITES:
//	Choose IOCTLCODE
//	Set InputBuffer.PortNumber (address)
//	Set DataValue	//value to write
//	

	InputBuffer.PortNumber = 0x00000000;	//set the offset to read from
    IoctlCode = IOCTL_AEC_READ_PORT_UCHAR;	//READ byte
    //IoctlCode = IOCTL_AEC_READ_PORT_USHORT;	//READ 2bytes
    //IoctlCode = IOCTL_AEC_READ_PORT_ULONG;	//READ 4bytes
	//IoctlCode = IOCTL_AEC_WRITE_PORT_UCHAR;
	//IoctlCode = IOCTL_AEC_WRITE_PORT_USHORT;
	//IoctlCode = IOCTL_AEC_WRITE_PORT_ULONG;
	InputBuffer.CharData = 0x00;
	//InputBuffer.ShortData = 0x0000;
	//InputBuffer.LongData = 0x00000000;
	DataLengthOut = sizeof(DataBufferOut.CharData);
	//DataLengthOut = sizeof(DataBufferOut.ShortData);
	//DataLengthOut = sizeof(DataBufferOut.LongData);
	DataLengthIn = sizeof(InputBuffer.PortNumber) + DataLengthOut;


    IoctlResult = DeviceIoControl(		//
                            hndFile,            //1 Handle to device
                            IoctlCode,          //2 IO Control code -- (Read)/ (Write)
						//pointer to buffer to supply input data
			    &InputBuffer,	//3++ Buffer to driver.  Holds port & data (if any).
						//size of input buffer
			    DataLengthIn,		//4+++ Length of buffer in bytes.
						//pointer to buffer to receive output data
                            &DataBufferOut,        //5++++ Buffer from driver.
						//size of output buffer
                            DataLengthOut,         //6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
						//pointer to variable to receive output byte count
			    &ReturnedLength,    //7 Bytes placed in DataBufferOut. (store # upon return)
                            NULL		//8 NULL means wait till op. completes.
                            );

// READ output---->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {
        ULONG   Data;
        if (ReturnedLength != DataLengthOut)
        {
            printf(
                "Ioctl transfered %d bytes, expected %d bytes\n",
                ReturnedLength, DataLengthOut );
        }        
        switch (ReturnedLength)
        {
            case sizeof(UCHAR):
                Data = DataBufferOut.CharData;
                break;                
            case sizeof(USHORT):
                Data = DataBufferOut.ShortData;
                break;    
            case sizeof(ULONG):
                Data = DataBufferOut.LongData;
                break;
        }        
        printf("Read from port %x returned %x\n", InputBuffer.PortNumber, Data);
    }
    else
    {
        printf("Ioctl failed with code %ld\n", GetLastError() );
    }
// <------- READ output

//WRITE output -------->
    if (IoctlResult)                            // Did the IOCTL succeed?
    {        printf(
            "Wrote to port %x the data %x\n",
            InputBuffer.PortNumber, DataValue);    }
    else    {        printf("Ioctl failed with code %ld\n", GetLastError() );    }
// <---------- WRITE output
//----------------------------------------------------------------------------------------
--*/
//--------------------------------------------------------------------------------
/*++
Table 1.4
Escape Sequence Represents 
\a Bell (alert) 
\b Backspace 
\f Formfeed 
\n New line 
\r Carriage return 
\t Horizontal tab 
\v Vertical tab 
\' Single quotation mark 
\"  Double quotation mark 
\\ Backslash 
\? Literal question mark 
\ooo ASCII character in octal notation 
\xhhh ASCII character in hexadecimal notation 

--------------------------------------------------------------------------------
  --*/