

// TestIsr.cpp : implementation of the worker thread
//

#include "stdafx.h"
#include "test1.h"
#include "testG.h"
#define		TAB		0x09
#define		CR		0x0D
#define		SPACE	0x20

//#include "calcthrd.h"
//#include "recaldoc.h"
//#include "slowcalc.h"
//#include "mtrecalc.h"

extern "C"{
#include "AECiNTTC.h"	//PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS
}


//===============================================================
#define		ODD		TRUE
#define		NOT_ODD	FALSE
#define		FLAG_ENABLES 0x43
#define		NO_FLAG_ENABLES 0x00
//GLOBAL variables
WORD	B_Addr = 0x1000;	//1000h
volatile BOOL exiting = FALSE;
BOOL	ReaderAvailable = FALSE;
BOOL	GeneratorAvailable = FALSE;
BOOL	L21Available = FALSE;
BOOL	VideoAvailable = FALSE;
BYTE	brdType = 0;
volatile BYTE	DoingText1 = FALSE;
volatile BYTE	ControlCode1, ControlCode2;
volatile int g_iRow, g_iIndent;
BOOL	ReadingEnabled = TRUE;

	
//===============================================================
struct CC4
{		//The order of these bytes may need to be reversed!
	BYTE one;
	BYTE two;
	BYTE res;
	BYTE stat;
};

union DW_4B
{
	DWORD	d;
	CC4		b;
};
//===============================================================

VOID StartPause(BOOL On)	//ReadingEnable?
{
	WORD OffsetRW;
	BYTE bId;
	BOOL ok;

	if (On)
	{		
		bId = FLAG_ENABLES;		//defined bits for this test program	
	}
	else 
	{
		bId = NO_FLAG_ENABLES;
		MessageBeep(0xFFFFFFFF);
	}

	OffsetRW = 0x2E;
	ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &B_Addr);
	//This will set or clear the selected automatic interrupts.
	// See defines for NO_FLAG_ENABLES, FLAG_ENABLES

	return;

}
//===============================================================

BOOL IsrQuit()
{
	WORD OffsetRW;
	BYTE bId;
	BOOL	ok;
	exiting = TRUE;
	Sleep(35);

	//This will force an Interrupt event IF the ISR is PARKED (in the ISR call)
	//Write (send first half of command) to command port
	//this 'bId' value causes a "0xF?" value to be returned as comand response
	//but this is a "don't" care situation as we are shutting down.
	bId = 0xF0;		
	OffsetRW = 0x2F;
	ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &B_Addr);

	//The rest of the cleanup is done as the ISR Thread exits
	return ok;

}

//=============================================================================

BOOL	SetupPci(WORD BrdAddr)
{
	WORD		Addr, Offset08, OffsetEF, OffsetRW;
	BYTE		bId, bType, bRW; // bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok;
	DWORD		dwIE;
	
	Addr =  BrdAddr;
	Offset08 = 0x08;
	OffsetEF = 0x3EF;


	//Start the Generator and the Reader to run
	//simultaneously. 
	bCom = 0x02; // dual reader mode command vltc board
	ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);				

	Sleep(150);	// not technically required, but not a bad
			// idea to make sure that all signals
			// have some time to sync.

	//Start the Generator and the Reader to run
	//simultaneously. 
	bCom = 0x02; // dual reader mode command vltc board
	ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);				

	Sleep(150);	// not technically required, but not a bad
			// idea to make sure that all signals
			// have some time to sync.


	//This address offset is "mapped" special and is handled for PCI models
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
		brdType = bType;	//3ef

	if (ok = AEC_PCTC_READ_1BYTE (&bId, &Offset08, &Addr))	
	{
		if (bId & 0x10)		//if LTC reader bit4 set
			ReaderAvailable = TRUE;		
		if (bId & 0xA0)		//if LTC gen bit5/VITC gen bit7 set
		{
			GeneratorAvailable = TRUE;
			VideoAvailable = TRUE;
		}
		if (bId & 0x40)		//if VITC reader bit6 set
		{
			ReaderAvailable = TRUE;
			VideoAvailable = TRUE;
		}
		if (bId & 0x04)		//if L21 reader bit2  set
		{
			L21Available = TRUE;
			VideoAvailable = TRUE;
		}
	}
	else return FALSE;
		
	//====================================================================
 	//Make sure that the interrupt "enable" is NOT currently set. If
	//it is, then we don't want to cause a problem for another application
	//that is already using the interrupts. Check bit FE.4 to see if set
	//#INT_A line driving enabled (ie: IRQ line drive upon interrupt is SET)
	OffsetRW = 0xFC;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &Addr);
	if (bRW & 0x10)	//if bit4
		return FALSE;
	//====================================================================
		

 	//Make sure that no INTERRUPTS will be generated during initializtion
	//if the board was left in an "active" state from a prior
	//application 
		//These few lines are probably not needed, but are safe to do.
		//disable INTERRUPT enable		
	dwIE = 0x00000000;
	OffsetRW = 0xFC;
	ok = AEC_PCTC_WRITE_4BYTES (&dwIE, &OffsetRW, &Addr);

	//disable all automatic interrupts (Read/Gen/field/L21...)
	//Clear all bits at 2Eh
	bId = NO_FLAG_ENABLES;
	OffsetRW = 0x2E;
	ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

	//This can be done now or later with reference to
	// setting up the board to be ready for ISR/interrupt
	// handling/generation


	dwIE = 0x00000080;	//Tell the board to put L21 data at offset 53-50h
	OffsetRW = 0x20;	//Put the "code" at offset 23-20h
	ok = AEC_PCTC_WRITE_4BYTES (&dwIE, &OffsetRW, &Addr);

	//Stuff the "data at 0x20" into the L21/.... control/settup registers
	bCom = 0x5A; // Init special function registers
	ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);				


	//Start the Generator and the Reader to run
	//simultaneously. 
	bCom = 0x2F; // dual reader mode command vltc board
	ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);				

	Sleep(50);	// not technically required, but not a bad
			// idea to make sure that all signals
			// have some time to sync.

	if (GeneratorAvailable == TRUE)
	{
		bCom = 0x48; // If Genavailable, start it!
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
	}

	Sleep(50);

	//Get Board to generate an interrupt (software only) now.
	//This will leave the interrpt pending!
	bId = 0xF0;	//Dummy "command" value, to cause interrupt 
			// response at 0Fh.
	OffsetRW = 0x2F;
	ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

	Sleep(25);	//allow time for the board to process the
				//"command" and write ACK/NAK to 0x0F

	//Clear the interrpt. This will leave the board waiting
	// for a write of a 0x00 value to 0x2F offset that will
	// re-enable the NEXT interrupt. The Writing of 0x00 to
	// 0x2F offset is done BY the ISR upon entry into the
	// ISR call ('NextInt'). This allows the ISR to NOT MISS ANY INTS
	// or allow any Interrupts that are NOT ready to be handled!!!!!
	// Read the interrupt response at 0Fh and throw it away. I know
	// that this is an invalid/error response. 
	// This read should technically not be done until after verifing
	// that there is an "interrupt pending" by reading at FEh bit 0.
	// It is quite safe to do this (at 0Fh) but add the verification
	// read to check at FE.0 before is you want to be more sure.
	// you can even loop on waiting for this bit to set once you
	// write the value FFh to offset 2Fh. Be sure not to have a
	// loop that will run forever.
	//bId = 0x00;
	OffsetRW = 0x0F;
	ok = AEC_PCTC_READ_1BYTE (&bId, &OffsetRW, &Addr);


	// This operation can be done NOW or later. It does
	// not mater, and this operation can be changed
	// to meet any specific requirements that your
	// software may have. The reason that it does NOT
	// matter is that nothing will happen until AFTER\
	// a 00h value is written to offset 2Fh (by entry
	// into 'NextInt' call).
	//enable all desired interrupts (Reader/video/L21)(bits 0,1,6)
	//	NOTE: Bit 2 is NOT set. This could be set if needed to do
	//	special GENERATOR ISR stuff
	bId = FLAG_ENABLES;
	OffsetRW = 0x2E;
	ok = AEC_PCTC_WRITE_1BYTE (&bId, &OffsetRW, &Addr);

	//This is very IMPORTANT to be done NOW. This is the
	// KEY that UNLOCKS the IRQ assertion. This operation
	// will result in bit FE.4 being set, and then when
	// and interrupt occurs, bit FE.1 will be '1' until
	// the ISR reads the interrupt code from offset 0Fh.
	//enable INTERRUPT enable		
	dwIE = 0x00000010;
	OffsetRW = 0xFC;
	ok = AEC_PCTC_WRITE_4BYTES (&dwIE, &OffsetRW, &Addr);
	//At this point, when the "next" interrupt is ENABLED
	// by writing a 00h value byte to offset 2Fh, if and when
	// and interrupt event occurs, it will generate an IRQ.
	// The AEC_NTTC.DLL call AEC_PCTC_ISR_1 does this AFTER
	// if has prepared the OS to handle the interrupt vector.
	// When the call returns, it passes the interrupt ID code
	// to the application for processing. See "TcISR1" below.
	// The direct driver call "NextInt" also does the same
	// thing as "TcISR1"...

	return ok;
}




//============================================================================
//===============================================================
// This function works for most all fonts except the terminal font.
// NOTE: The masking out of bit 7 (parity bit) has been done PRIOR to entry
//===============================================================
BYTE StuffChar(BYTE bChar)
{
	BYTE bStuff;

	if (bChar < 0x20)	//stops bad/null "char" data from being saved
		return 0x00;

	switch (bChar)
	//switch (bStuff)
	{
		//remap several of the bytes here to get correct char for font used
		case 0x2A:	
			bStuff = 0xE1;
			break;
		case 0x5C:		//
			bStuff = 0xE9;
			break;
		case 0x5E:		//
			bStuff = 0xED;
			break;
		case 0x5F:		//
			bStuff = 0xF3;
			break;
		case 0x60:		//
			bStuff = 0xFA;
			break;
		case 0x7B:		//
			bStuff = 0xE7;
			break;
		case 0x7C:		//
			bStuff = 0xF7;
			break;
		case 0x7D:		//
			bStuff = 0xD1;
			break;
		case 0x7E:		//
			bStuff = 0xF1;
			break;
		case 0x7F:		//Solid Block --> space
			bStuff = ' ';	//
			break;
		default:	//all other data
			bStuff = bChar;
	}
/*
	// Now stuff the character into correct string!
	if (field)	// if odd
	{
		iStuff++;
		//Insert(F1_C1, bStuff);	//This line is for debugging
		Insert(CurrentChannelF1, bStuff);	
	}
	else 
	{
		iStuff++;
		//Insert(F2_C1, bStuff);	//This line is for debugging
		Insert(CurrentChannelF2, bStuff);
		//Insert(CurrentChannelF2, CR_EOL);
	}
	*/
	return bStuff;

}

//===============================================================

BYTE MapSpecialChar(BYTE b)
{
	switch (b)
	{
		case 0x30:		//registered trakemark
			return 0xAE;
		case 0x31:		//degree sign
			return 0xB0;
		case 0x32:		//  1/2
			return 0xBD;
		case 0x33:		//Inverse query
			return 0x20; // ?? so use space??
		case 0x34:		// trademark TM
			return 0x99;
		case 0x35:		// cents sign
			return 0xA2;
		case 0x36:		// pound sterling sign
			return 0xA3;
		case 0x37:		// music note
			return 0xB6; // This character is NOT correct, but is one available in most fonts!
		case 0x38:		// lcase a-w/grave accent
			return 0xE0;
		case 0x39:		// transparent space
			return 0x20; //just use space
		case 0x3A:		// lcase e-w/grave accent
			return 0xE8;
		case 0x3B:		//lcase a-w/circumflex
			return 0xE2;
		case 0x3C:		//lcase e-w/circumflex
			return 0xEA;
		case 0x3D:		//lcase i-w/circumflex
			return 0xEE;
		case 0x3E:		//lcase o-w/circumflex
			return 0xF4;
		case 0x3F:		//lcase u-w/circumflex
			return 0xFB;
		default:
			return 0;
	}
}


//===============================================================
BOOL CompareRow(int r, int i)	
{
	BOOL bNew = FALSE;
	if (g_iRow != r)
	{
		g_iRow = r;
		g_iIndent = i;
		bNew = TRUE;
	}
	return bNew;
}

BOOL CompareIdent(int i)
{
	BOOL bDoSP = FALSE;
	if (g_iIndent < i)
		bDoSP = TRUE;
	g_iIndent = i;
	return bDoSP;
}
//==========================================================================

DWORD CheckControl(BYTE bOne, BYTE bTwo)
{
	//BOOL	bRepeated;		
	int		iTabOffset;
	int		iRow, iIndent;			//for use with 1x/5x & 1x/7x => bOne/bTwo
	BOOL	gotRowIndent = FALSE;	//for use with 1x/5x & 1x/7x => bOne/bTwo
	BOOL	bNoChange = TRUE;		
	BOOL	bDoingText;		
	BYTE	bStuff = 0;
	BYTE	MSNibble;
	BOOL	NewLine = FALSE;
	BOOL	channel1;	//field,
	DW_4B	CCDat;
	CCDat.d = 0x00000000;

	//Is this the same as received last time?
	if ((ControlCode1 == bOne) &&  (ControlCode2 == bTwo))
	{
		//iControlsecond++; //iControlfirst++;
		ControlCode1 = 0x00;
		ControlCode2 = 0x00;
		//bRepeated = TRUE;
		if (bOne & 0x08)	//bit 3 is set for channel 2
		{
			channel1 = FALSE;
			return CCDat.d;	//We are only going to process Caption 1 data
			//ic2f1++;
		}
		else 
		{
			channel1 = TRUE;
			//ic1f1++;
		}
	}
	else	//first of repeated pair
	{
		//iControlfirst++;
		ControlCode1 = bOne;
		ControlCode2 = bTwo;
		//bRepeated = FALSE;
		return CCDat.d;
	}

	//We now know the field and channel, but we are NOT sure
	//what this code does! process more

	MSNibble = (bTwo & 0xF0);	//Save only most significat nibble
	switch (bOne)
	{
		case 0x11:		//2nd of 3x is special Char
		//case 0x19:	//Caption2
			//if ((bTwo & 0xF0) == 0x30)	//if 3x
			if (MSNibble == 0x30)	//if 3x
				bStuff = MapSpecialChar(bTwo); //This char is printed at end of this function

			// could be 4x-7x "PAC" 4x&6x are COLOR, 5x&7x are INDENTS
			else if (MSNibble == 0x50)	
			{
				//caculate row/indent	iRow, iIndent, gotRowIndent
				iRow = 1;
				iIndent = (int)((bTwo & 0x0E) * 2);
				gotRowIndent = TRUE;

			}
			else if (MSNibble == 0x70) 	
			{
				//caculate row/indent	iRow, iIndent, gotRowIndent
				iRow = 2;
				iIndent = (int)((bTwo & 0x0E) * 2);
				gotRowIndent = TRUE;

			}
			break;

//=======>> Work on this HERE HERE
		case 0x14:		//2nd of 2x is Misc Control code
		//case 0x1C:	//Caption2
			switch (MSNibble)
			{
				case 0x20:
					switch (bTwo)
					{
						case 0x2F:	//End of caption (flip memories)
							NewLine = TRUE;	//StartNewLine()
						case 0x20:	//resume caption loading
						case 0x29:	//Resume direct captioning
						
						case 0x25:	//??roll-up2
						case 0x26:	//??roll-up3
						case 0x27:	//??roll-up4
						case 0x28:	//??Flash On
							bNoChange = FALSE;
							bDoingText = FALSE;
							break;

						case 0x2A:		//Text restart
						case 0x2B:		//resume text display
							bNoChange = FALSE;
							bDoingText = TRUE;
							break;

						// These next ones will all fall through with no
						// change in text/cc mode
						case 0x2D:		//carriage return
							NewLine = TRUE;	//StartNewLine()
							//
						case 0x2C:		//Erase displayed memory
						case 0x2E:		//Erase Non-displayed memory
						case 0x21:	//Backspace
						case 0x22:	//RES.
						case 0x23:	//RES.
						case 0x24:	//Delete to end of Row
							//bNoChange = TRUE;	//USE PRIOR TEXT/CC VALUE
							break;

						default:
							//bNoChange = TRUE;	//USE PRIOR TEXT/CC VALUE
							break;
					}
					
				case 0x40:
				case 0x60:
					break;
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 14;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 15;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;

				default:
					break;
			}
			


			break;

		case 0x17:		//Tab offsets 1/2/3 colums
		//case 0x1F:	//Caption2
			switch (MSNibble)
			{
				case 0x20:
					iTabOffset = 0;
						//put code here to handle the TabOffset
					switch (bTwo)
					{
						case 0x23:	//
							iTabOffset++;
						case 0x22:	//
							iTabOffset++;
						case 0x21:	//
							iTabOffset++;
							bStuff = ' ';	//Add a "space" instead of tabs for "saving"
						default:
							break;
					}
					break;
					
				case 0x40:
				case 0x60:
					break;
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 9;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 10;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;

				default:
					break;
			}
			
			break;

		case 0x12:		
		//case 0x1A:	//Caption2
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 3;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 4;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x15:		
		//case 0x1D:	//Caption2
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 5;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 6;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x16:		
		//case 0x1E:	//Caption2
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 7;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 8;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x10:		
		//case 0x18:	//Caption2
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 11;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;
		case 0x13:		
		//case 0x1B:	//Caption2
			switch (MSNibble)
			{
				case 0x50:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 12;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x70:
					//caculate row/indent	iRow, iIndent, gotRowIndent
					iRow = 13;
					iIndent = (int)((bTwo & 0x0E) * 2);
					gotRowIndent = TRUE;
					break;
				case 0x40:
				case 0x60:
				default:
					break;
			}			
			break;


		default:
			break;
		
					//The other 0x1x values can all be default because all 
					//they do is position/color/underline...
					//default:	//all other data
	}

	//Now set the current channel info

	/////////////////////////////////////////////
	if (!bNoChange)
		DoingText1 = bDoingText;

	if (DoingText1)
		return 0x00000000;	//We are only woring with Caption1 bytes (not text)
	//////////////////////////////////////////////

	if (gotRowIndent)
	{
		if (CompareRow(iRow, iIndent))
			NewLine = TRUE;
		else if (CompareIdent(iIndent))
			bStuff = ' ';	//Add a "space" 
	}

	if (NewLine)
		CCDat.b.stat = 0xFF;  //StartNewLine
	else if (bStuff != 0)	// if value was mapped, STUFF IT!
	{
		CCDat.b.one = bStuff;//return with character byte	
	}
	
	return CCDat.d;	//return whatever is there
}


//===============================================================

DWORD ProcessCC(DWORD dw)
{
	BOOL	field;
	BYTE bTemp;		//to hold processed bytes
	DW_4B	L21;
	DW_4B ProcDat;
	DWORD dwtemp;
	L21.d = (dw & 0xFFFF7F7F);	//now we have access to each byte via " .b " w/masked parity bits
	//L21.b.stat;
	//L21.b.res;	//NOT used
	//L21.b.two;	//character #2
	//L21.b.one;	//character #1

	ProcDat.d = 0x00000000;	//initialize return to NOTHING

	//First, check the status byte to make sure that the
	// data if valid and that there are no errors
	// Return if there is a problem with the data
	if ((L21.b.stat & 0x0F) != 0)
		return 0x00000000;		//means that one or more of bits 0-3 is 1 (high)
	if ((L21.b.stat & 0x80) == 0)
		return 0x00000000;		//means that data block NOT valid (ie bit7=0)

	//===== Check current field ident.
	if ((L21.b.stat & 0x40) != 0)
		field = ODD;		//means that data block is from odd field (field 1)
	else //field = NOT_ODD;
		return 0x00000000;		//We are only going to process Field1 data here
	//=====
	//Now, process the Field1 bytes
	//Byte one will be the only one that contains a control VALUE, so check it
	//	and then see what comes next (char or conttol code specifier)
	bTemp = (L21.b.one & 0xF0);	//mask out low nibble

	switch (bTemp)
	{
		case 0x00:	//00-0F
			if (field)
			{
				ControlCode1 = 0x00;
				ControlCode2 = 0x00;
			}
			if (!DoingText1)
				ProcDat.b.one = StuffChar(L21.b.two);	//if first control code is 0-F, then second treated normally
			break;	//do nothing, return

		case 0x10:	//10-1F
			ProcDat.d = CheckControl(L21.b.one, L21.b.two);
			break;

		default:	//20-7F
			if (field)
			{
				ControlCode1 = 0x00;
				ControlCode2 = 0x00;
			}
			dwtemp = dw;
			if (!DoingText1)
			{
				ProcDat.b.one = StuffChar(L21.b.one);
				ProcDat.b.two = StuffChar(L21.b.two);
			}
	}
	return  ProcDat.d; //
}

//===========================================================================

//===========================================================================

//===========================================================================

UINT IsrThreadProc(LPVOID pParam)
{
	WORD		OffsetRW; //, OffsetU, OffsetT;
	//BYTE		iCd;
	BYTE		bRW;
	BOOL		ok;
//	LARGE_INTEGER now;
//	LARGE_INTEGER frequency;
	HANDLE	hAecDevice;
	int IntIndex;

	int iOtherCnt = 0;
	int iVidCnt = 0;
	int iL21 = 0;
	//int iGenCnt = 0;
	int iReadCnt = 0;

	DWORD	procDW, dw;
	DW_4B	dwChar;

	BYTE	rIntCode;
//	char lastFF;
	int i, j;
	int CkType;
	char	charStr[20];
	DWORD	dwL21; //, dwRdr;
	BOOL	bF1C1 = TRUE;	//Start with default as C1 in use
	WORD	OffsetL21 = 0x0050;	//Setup to read L21 data at 53-50h
	//WORD	OffsetVitc = 0x005C;//Setup to read VITC at 5F-5Ch 

	CIsrThreadInfo* pIsrInfo = (CIsrThreadInfo*)pParam;
//	QueryPerformanceFrequency ( &frequency );

	int boardNum = AEC_PCTC_GET_NUMBER_OF_DEVICES ();	//make sure have time code board

	if (boardNum)
	{
		exiting = FALSE;
		CkType = AEC_PCTC_CHECK_BOARD (&B_Addr);		
		if (CkType)	//will = 4) becasue addr is 0x1000
		{
			if (!SetupPci(B_Addr))
				exiting = TRUE;
		}
		else exiting = TRUE;
	}
	else exiting = TRUE;


	//	// This thread exits the loop only when the main application sets the
	//	// "exiting" event.

	//debugging code next few lines
	OffsetRW = 0x0C;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
	OffsetRW = 0x0D;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
	OffsetRW = 0x2E;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
	OffsetRW = 0xFE;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);



	ok = AEC_PCTC_INIT_BRD_INT (&hAecDevice, &IntIndex, &B_Addr);
	
	//Set the defautl "time out text" just in case this board is NOT reading
	//any time code.
	j = 11;
	charStr[0] = 'N';
	charStr[1] = 'o';
	charStr[2] = 'T';
	charStr[3] = 'i';
	charStr[4] = 'm';
	charStr[5] = 'e';
	charStr[6] = 'C';
	charStr[7] = 'o';
	charStr[8] = 'd';
	charStr[9] = 'e';
	charStr[10] = ' ';

			//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   			//THIS 'WHILE' LOOP IS THE ISR FOR THIS PCI BOARD (at 1000h). 
			//THE ISR WILL LOOP INDEFINITLY. IT WILL BE STOPPED WHEN THE
			//THE "exiting" FLAG BECOMES TRUE AND WHEN THE "ISR_1" RETURNS.
			//THE MAIN PROCESS MUST BE SURE TO SET "exiting" TO TRUE AND 
			//WRITE A COMMAND BYTE TO OFFSET 2Fh TO FORCE A RETURN IF BOARD
			//IS WAITING FOR RETURN FROM "ISR_1"
	while ( ! exiting )
    {  
			rIntCode = AEC_PCTC_ISR_1 (&B_Addr);		// wait for interrupt			
			switch (rIntCode)
			{
				case (0x13):	//tc reader interrupt (get time & user (don't worry about Embedded)			
					iReadCnt++;				
					j = AEC_PCTC_READ_ASC_TB (charStr, &B_Addr);
				//	if ((iReadCnt & 0x000001FF) == 0)
				//	{
				//		MessageBeep(0xFFFFFFFF);
				//		//if (pIsrInfo->m_pMainFrame)
				//		//{
				//		//	::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, 'X', 0);
				//		//	::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, 0x0D, 0);
				//		//}
				//	}
					//temp--->
					//if (pIsrInfo->m_pMainFrame)
					//	::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, charStr[10], 0);

					//ok = AEC_PCTC_READ_TB(&dwRdr, &B_Addr);
					//ok = AEC_PCTC_READ_UB(&dwRUdat, &B_Addr);	//Get User data
					break;
				/*case (0x4C):	//tc generator interrupt
					iGenCnt++;
					iGenCnt++;
					OffsetTime = 0x0040;	//for PCI
					//OffsetUser = 0x0044;
					ok = AEC_PCTC_READ_4BYTES(&lGTdat, &OffsetTime, &Brd1addr);
					//ok = AEC_PCTC_READ_4BYTES(&lGUdat, &OffsetUser, &Brd1addr);
					break;
				*/
				case (0x1E):	//L21 reader interrupt
					iL21++;
					//if ((iL21 & 0x0000007F) == 0)
					//	MessageBeep(0xFFFFFFFF);
					ok = AEC_PCTC_READ_4BYTES(&dwL21, &OffsetL21, &B_Addr);
					//Now process the L21 data
					//
					//dwChar.d = (dw & 0xFFFF7F7F);	//now we have access to each byte via " .b " w/masked parity bits
					//dwChar.b.stat;
					//dwChar.b.res;	//NOT used
					//dwChar.b.two;	//character #2
					//dwChar.b.one;	//character #1
					if ((procDW = ProcessCC(dwL21)) && (pIsrInfo->m_pMainFrame))
					{
						dwChar.d = procDW;
						if (dwChar.b.stat)	//if stat != 0 then Newline
						{
							::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, 0x0D, 0);
							for (i=0; i != j; i++)
								::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, charStr[i], 0 );
								//hwnd->PostMessage(WM_CHAR, charStr[i], 0);
							
							::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, TAB, 0 );
							//::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, '#', 0);
						}
						else	//see if there are chars to print
						{
							if (dwChar.b.one)	//if NONZERO
								::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, dwChar.b.one, 0);
							if (dwChar.b.two)
								::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, dwChar.b.two, 0);
						}
					}
					break;
				case (0x44):	//Video field int
					iVidCnt++;

					//   The commented out code below can be used to test the timing of the software
					//   as to interrupt to interrupt intervals. Some modifications may be required,
					//   but at least you will have some idea of what to do if you want to do this.
					//   see if interrupts occur too fast or too slow - keep track?
					//
					//QueryPerformanceCounter(&now);
					//if ( last.QuadPart )
					//{
					//		DWORD n = (DWORD) ((now.QuadPart - last.QuadPart) / (frequency.QuadPart / 1000));
					//		if ( n < min )
					//			min = n;
					//		if ( n > max )
					//			max = n;	// **NEW***
					//		if ( n > 17 )	// may need to change this value if not detecting
					//			count += 1;	// 60 /Second video field rate interrupt.
					//		//    Use '34' for 30 frame reader/gen
					//		//    Use '41' for 25 frame reader/gen (PAL)
					//		//    Use '21' for 50 field video rate interrupt (PAL)
					//}
					//last.QuadPart = now.QuadPart;

					break;

				default:	//command response, compare, serial...NAK
					iOtherCnt++;
			}

    }

	//Clear the interrupt enable
	//This will STOP the board from asserting any more IRQs.
	dw = 0x00000000;
	OffsetRW = 0xFC;
	ok = AEC_PCTC_WRITE_4BYTES (&dw, &OffsetRW, &B_Addr);

	Sleep(50);	//allow time for "command" (write1) from "IsrQuit" to process
				//if it has not done so already

	//Now if we have bit at FE.0 '1', then we have to finish processing the
	// command, else, just do the "enable next" (ie: write1 0x00 to offset 0x2F)

//	bRW = rIntCode;
//	int k = iReadCnt;
//	k = iL21;
//	k = iOtherCnt;
//	k = iVidCnt;

	OffsetRW = 0x0FE;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
	if (bRW & 0x01)
	{
		//Read (do second half of command) from command response port
		OffsetRW = 0x0F;
		ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
	}

	bRW = 0x00;
	OffsetRW = 0x2F;
	ok = AEC_PCTC_WRITE_1BYTE (&bRW, &OffsetRW, &B_Addr);

			//clear all int ENABLE flags
	bRW = NO_FLAG_ENABLES;			//disable interrupt "enable" flags bits
	OffsetRW = 0x2E;
	ok = AEC_PCTC_WRITE_1BYTE (&bRW, &OffsetRW, &B_Addr);

	Sleep(5);

	OffsetRW = 0x0FE;
	ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
	if (bRW & 0x01)
	{
		//Read (do second half of command) from command response port
		OffsetRW = 0x0F;
		ok = AEC_PCTC_READ_1BYTE (&bRW, &OffsetRW, &B_Addr);
		bRW = 0x00;
		OffsetRW = 0x2F;
		ok = AEC_PCTC_WRITE_1BYTE (&bRW, &OffsetRW, &B_Addr);
	}
	return 0;
}




//=============================================================
/*

	while (TRUE)
	{

		Sleep(15);
		//MessageBeep(0xFFFFFFFF);

		j = AEC_PCTC_READ_ASC_TB (charStr, &B_Addr);
		if ( lastFF != charStr[10] )
		{
			lastFF = charStr[10];
			//Next line sends a carriage return command "0x0D"
			
			if (pIsrInfo->m_pMainFrame)
				::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, 0x0D, 0);
				//::SendMessage(hwnd, WM_CHAR, 0x0D, 0);
			
			//The following line send a WCLOSE message 
			//   to the Application's main window. This will cause the
			//   Application to exit.
			//AfxGetMainWnd()->PostMessage(WCLOSE, 0, 0);
			
			for (i=0; i != j; i++)
			{
				if (pIsrInfo->m_pMainFrame)
					::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, charStr[i], 0 );
				//hwnd->PostMessage(WM_CHAR, charStr[i], 0);
			}

			if (pIsrInfo->m_pMainFrame)
			{
				::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, TAB, 0 );
				::PostMessage(pIsrInfo->m_pMainFrame, WM_CHAR, '#', 0);
			}
		}
	}

*/
//		bRecalcCompleted = FALSE;
//
//		// Wait until the main application thread asks this thread to do
//		//      another calculation.
//		if (WaitForSingleObject(pRecalcInfo->hEventStartRecalc, INFINITE)
//			!= WAIT_OBJECT_0)
//			break;
//
//		// Exit the thread if the main application sets the "kill recalc"
//		// event. The main application will set the "start recalc" event
//		// before setting the "kill recalc" event.
//
//		if (WaitForSingleObject(pRecalcInfo->hEventKillRecalcThread, 0)
//			== WAIT_OBJECT_0)
//			break; // Terminate this thread by existing the proc.
//
//		// Reset event to indicate "not done", that is, recalculation is in progress.
//		ResetEvent(pRecalcInfo->hEventRecalcDone);
//
//		bRecalcCompleted = SlowAdd(pRecalcInfo->nInt1,
//			pRecalcInfo->nInt2,
//			pRecalcInfo->nSum,
//			pRecalcInfo,
//			pRecalcInfo->nRecalcSpeedSeconds,
//			pRecalcInfo->hwndNotifyProgress);
//
//		// Set event to indicate that recalculation is done (i.e., no longer in progres),
//		// even if perhaps interrupted by "kill recalc" event detected in the SlowAdd function.
//		SetEvent(pRecalcInfo->hEventRecalcDone);
//
//		if (!bRecalcCompleted)  // If interrupted by kill then...
//			break; // terminate this thread by exiting the proc.
//
//		::PostMessage(pRecalcInfo->hwndNotifyRecalcDone,
//			WUSER_RECALC_DONE, 0, 0);
//	}
//
//	if (!bRecalcCompleted)
//		SetEvent(pRecalcInfo->hEventRecalcThreadKilled);
